2009-09-15 Ryan Jordan <ryan.jordan@sourcefire.com>
    * doc/README.frag3:
      Removed ttl_limit option, as it has been deprecated.
    * doc/README.ftptelnet:
      Added the ignore_telnet_erase_cmds option.
    * doc/README.ssh:
      Fixed the documentation to reflect changes in SSH for 2.8.5.
    * doc/snort_manual.tex:
      Duplicated the above doc changes for the manual. Clarified order
      of rule actions. 
    * etc/gen-msg.map:
      Punctuation changes.
    * etc/snort.conf:
      Fix the example SSH configuration, and turn it on by default. This
      should increase performance in situations where a lot of SSH traffic
      was inspected.
    * rpm/snort.spec:
      Updated version number.
    * src/build.h:
      Updated build number.
    * configure.in:
      Added configure switch to disable core files.
    * src/codes.c:
    * src/codes.h:
      Removed old/unused code.
    * src/debug.c:
    * src/sfutil/sfportobject.c:
    * src/snort.c:
    * src/snort.h:
    * src/util.c:
      redirect stdin/stdout/stderr to /dev/null
      for debug write to file and change ownership of file to dropped privs
    * src/decode.c:
      Allow support for label values of 0 or 2 at locations other than bottom
      of stack.
    * src/decode.h:
    * src/win32/WIN32-Prj/snort_installer.nsi:
      Moved a couple rules into the decoder.
    * src/detection-plugins/detection_options.c:
    * src/detection-plugins/detection_options.h:
    * src/detection-plugins/Makefile.am:
    * src/detection-plugins/sp_pattern_match.c:
    * src/detection-plugins/sp_pattern_match.h:
    * src/detection-plugins/sp_react.c:
    * src/detection-plugins/sp_react.h:
    * src/detection-plugins/sp_respond2.c:
    * src/detection-plugins/sp_respond2.h:
    * src/detection-plugins/sp_respond.c:
    * src/detection-plugins/sp_respond.h:
    * src/detection-plugins/sp_session.c:
    * src/win32/WIN32-Prj/snort.dsp:
      Made react, resp, and resp2 independent except that libnet is only
      initialized/closed once regardless of build combinations.
    * src/dynamic-plugins/sf_engine/sf_snort_detection_engine.c:
      Added a new check to handle loading of older libraries.
    * src/dynamic-plugins/sf_dynamic_preprocessor.h:
    * src/dynamic-preprocessors/dcerpc/sf_preproc_info.h:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.c:
    * src/dynamic-preprocessors/dcerpc2/sf_preproc_info.h:
    * src/dynamic-preprocessors/dcerpc2/snort_dce2.c:
    * src/dynamic-preprocessors/dcerpc2/spp_dce2.c:
    * src/dynamic-preprocessors/dns/sf_preproc_info.h:
    * src/dynamic-preprocessors/dns/spp_dns.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_si.c:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
    * src/dynamic-preprocessors/ftptelnet/spp_ftptelnet.c:
    * src/dynamic-preprocessors/smtp/sf_preproc_info.h:
    * src/dynamic-preprocessors/ssh/sf_preproc_info.h:
    * src/dynamic-preprocessors/ssh/spp_ssh.h:
    * src/dynamic-preprocessors/ssl/sf_preproc_info.h:
      Changed the build numbers of preprocessors.
    * src/dynamic-preprocessors/dcerpc/spp_dcerpc.c:
    * src/preprocessors/spp_arpspoof.c:
    * src/preprocessors/spp_stream5.c:
    * src/sfutil/acsmx2.c:
    * src/sfutil/acsmx2.h:
      Fixed compile warnings.
    * src/preprocessors/spp_sfportscan.c:
      Don't include vlan header in portscan event/log packet.
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Fix core by adjusting IPv6 buffer size
    * src/profiler.c:
      Clean up preprocessor profiler formatting.
    * src/dynamic-preprocessors/ssh/spp_ssh.c:
      Changed limit on max_server_version_len to 255.
    * src/dynamic-preprocessors/smtp/smtp_log.h:
    * src/dynamic-preprocessors/smtp/smtp_xlink2state.c:
    * src/dynamic-preprocessors/smtp/spp_smtp.c:
    * src/generators.h:
      Gave xlink2state smtp preprocessor alert a unique sid.
    * src/dynamic-plugins/sf_engine/sf_snort_detection_engine.c:
      Fixed memory leaks.
    * src/fpcreate.c:
      Fixed potential segfault with multiplie policies.
    * src/fpdetect.c:
    * src/fpdetect.h:
    * src/preprocessors/perf-base.c:
    * src/preprocessors/perf.c:
    * src/preprocessors/perf-event.c:
    * src/preprocessors/perf-event.h:
    * src/preprocessors/perf-flow.c:
    * src/preprocessors/perf-flow.h:
    * src/preprocessors/spp_frag3.c:
    * src/preprocessors/spp_perfmonitor.c:
    * src/sfutil/sfActionQueue.c:
      IPv6-related changes.
    * src/mempool.c:
      Check return values from mempool_init and fatal if bad when freeing
      pools, set to NULL.
    * src/preprocessors/Stream5/snort_stream5_icmp.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/preprocessors/Stream5/snort_stream5_udp.c:
    * src/sfutil/sfPolicy.c:
      Added additional error-checking.
    * src/output-plugins/spo_unified.c:
    * src/parser.c:
    * src/parser.h:
    * src/signature.c:
    * src/signature.h:
      Fixed a couple invalid reads & writes.
    * src/plugbase.c:
      Check configuration for all policies.
    * snort_head/snort/snort.8:
      Updated man page to reflect doc changes.

2009-07-13 Ryan Jordan <ryan.jordan@sourcefire.com>
    * src/win32/WIN32-Prj/sf_testdetect.dsp:
    * src/win32/WIN32-Prj/snort.dsp:
    * src/win32/WIN32-Prj/snort.dsw:
       Win32 updates.
    * configure.in:
       Update for module pack confliction.
    * snort.8:
       Removed obsolete option -o
    * doc/CREDITS:
       Updated credits to reflect Snort 2.8.5 work
    * doc/INSTALL:
       Indentation changes, update for Mac
    * doc/Makefile.am:
       Added README.filters
    * doc/README.filters:
       New README, describes the new filtering features in Snort 2.8.5
    * doc/README.frag3:
       Added the overlap_limit and min_fragment_length options
    * doc/README.ftptelnet:
       Indentation changes
    * doc/README.http_inspect:
       Added post_depth option.
    * doc/README.INLINE:
       Changed "snort_inline" to "Snort Inline"
    * doc/README.PerfProfiling:
       Updated stats output to reflect "Rev" column
    * doc/README.reload:
       New README, describes how to reload a Snort configuration in 2.8.5
    * doc/README.ssh:
       Updated the README to reflect changes in the SSH preprocessor for 2.8.5
    * doc/README.thresholding:
       Updated to indicate that "threshold" is deprecated in favor of "event_filter".
    * doc/snort_manual.tex:
       Updated to include 2.8.5 features, formatting updates.
       Removed old references to Stream4.
    * etc/gen-msg.map:
       Moved XMAS attack handling to decoder.
       Gave xlink2state smtp preprocessor alert unique sid.
    * etc/threshold.conf:
       Updated with formatting changes, deprecation notice for "threshold"
    * src/build.h:
       New build number.
    * src/codes.c:
    * src/codes.h:
       Removed unused files.
    * src/decode.c:
    * src/decode.h:
       Made some options policy-specific. Removed a couple poorly-performing
       rules and made them into decoder checks instead.
    * src/detect.c:
    * src/ppm.h:
       Don't reset packet time
    * src/detection-plugins/sp_asn1.c:
    * src/detection-plugins/sp_asn1_detect.c:
       Removed redundant check.
    * src/detection-plugins/sp_isdataat.c:
    * src/detection-plugins/sp_isdataat.h:
       Moved flags & struct to header file.
    * src/detection-plugins/sp_pattern_match.c:
    * src/detection-plugins/sp_replace.c:
    * src/detection-plugins/sp_replace.h:
       Check for combination of "replace" and "http_*" options, which are
       incompatible.
    * src/detection-plugins/sp_respond2.c:
    * src/detection-plugins/sp_respond.c:
       Renamed respond's config so it didn't conflict with gloabl Snort config.
    * src/dynamic-plugins/sf_convert_dynamic.c:
    * src/dynamic-plugins/sf_convert_dynamic.h:
       Added a missing handler for "isdataat" options in .so rules.
    * src/dynamic-plugins/sf_dynamic_engine.h:
    * src/dynamic-plugins/sf_dynamic_plugins.c:
    * src/dynamic-plugins/sf_dynamic_preprocessor.h:
    * src/dynamic-plugins/sf_engine/sf_snort_detection_engine.c:
    * src/dynamic-plugins/sf_engine/sf_snort_packet.h:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.h:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_byte.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_content.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_hdropts.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_loop.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_pcre.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_rc4.c:
    * src/dynamic-plugins/sp_dynamic.c:
    * src/dynamic-plugins/sp_dynamic.h:
    * src/dynamic-plugins/sp_preprocopt.c:
    * src/dynamic-plugins/sp_preprocopt.h:
    * src/ipv6_port.h:
    * src/sfutil/sf_ip.c:
    * src/sfutil/sf_ip.h:
       Changed variables from "uintX_t" to "u_intX_t".
    * src/dynamic-preprocessors/dcerpc2/dce2_cl.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_co.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_co.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_event.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_smb.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_smb.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_stats.h:
    * src/dynamic-preprocessors/dcerpc2/snort_dce2.c:
    * src/dynamic-preprocessors/dcerpc2/spp_dce2.c:
       Added detection for DCE/RPC server->client attacks.
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_client_lookup.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_server_lookup.c:
       Fixed memory leak.
    * src/dynamic-preprocessors/ftptelnet/pp_ftp.c:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.h:
    * src/dynamic-preprocessors/ftptelnet/spp_ftptelnet.c:
       Fixed some FTP false positives.
    * src/dynamic-preprocessors/smtp/smtp_config.c:
    * src/dynamic-preprocessors/smtp/smtp_xlink2state.c:
    * src/dynamic-preprocessors/smtp/spp_smtp.c:
    * src/dynamic-preprocessors/ssh/spp_ssh.c:
    * src/dynamic-preprocessors/ssl/spp_ssl.c:
       Fixed multiple policy support in these preprocessors.
    * src/fpdetect.c:
    * src/rules.h:
       One rule can have different actions in different policies.
    * src/generators.h:
       Changed SSL preprocessor's ID to avoid conflict with DCE/RPC 2
    * src/inline.c:
       Win32 updates
    * src/log.c:
       Fixed issue with verbose output while in IDS mode.
    * src/mempool.c:
    * src/mempool.h:
    * src/preprocessors/portscan.c:
    * src/sfutil/Makefile.am:
    * src/sfutil/sfActionQueue.c:
    * src/sfutil/sfActionQueue.h:
       Made several config options specific to bound policies.
    * src/output-plugins/spo_unified2.h:
       Used 104 and 105 for the VLAN+MPLS event records.
    * src/parser/IpAddrSet.c:
    * src/parser/IpAddrSet.h:
       Clean up IpAddrSet in rate filter and suppress
    * src/parser.c:
    * src/parser.h:
       Fixed warnings
    * src/preprocessors/HttpInspect/include/hi_ui_config.h:
    * src/preprocessors/HttpInspect/session_inspection/hi_si.c:
    * src/preprocessors/HttpInspect/user_interface/hi_ui_config.c:
    * src/preprocessors/snort_httpinspect.c:
    * src/preprocessors/spp_httpinspect.c:
       HTTP Inspect now allows 1024 server profiles. The storage size was
       reduced.
    * src/preprocessors/spp_frag3.c:
       Fixed problem where Snort wouldn't reload if prealloc_memcap was specified.
    * src/preprocessors/spp_perfmonitor.c:
       Fixed problem where "now" file stopped updating after a reload.
    * src/preprocessors/spp_sfportscan.c:
    * src/sfutil/sfportobject.c:
    * src/sfutil/sfrf.c:
    * src/sfutil/sfthd.c:
    * src/sfutil/sfthd.h:
       Fixed memory leaks.
    * src/preprocessors/spp_stream5.c:
    * src/sfutil/sfPolicyUserData.c:
    * src/sfutil/sfPolicyUserData.h:
    * src/target-based/sftarget_reader.c:
    * src/target-based/sftarget_reader.h:
       Update for linuxthreads.
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
       Added -H command-line option. Uses 192 for all TCP flushpoints.
       Only useful for repeatability while testing Snort.
    * src/profiler.c:
       Added rule revision to profiling output.
    * src/rate_filter.c:
    * src/rate_filter.h:
       Automatically enable "session delete" events with "session add" events.
    * src/sf_sdlist.c:
    * src/sfutil/sf_ipvar.c:
       Formatting changes
    * src/sf_types.h:
       Win32 updates
    * src/snort.c:
    * src/snort.h:
       Several fixes involving policy reload
    * src/util.c:
       Formatting changes, updated references to snort.org.
    * src/util.h:
       Don't allow 0 for threshold count or seconds.

2009-05-06 Ryan Jordan <ryan.jordan@sourcefire.com>
    * etc/gen-msg.map:
      Added new messages for MPLS and Frag3.
    * etc/snort.conf:
      Modified an example port number, and added overlap_limit to the default
      frag3_engine config.
    * src/detect.c:
    * src/detect.h:
    * src/detection_filter.c:
    * src/detection_filter.h:
    * src/rate_filter.c:
    * src/rate_filter.h:
    * src/sfthreshold.c:
    * src/sfthreshold.h:
      Added support for detection_filter, rate_filter, and event_filter.
      See doc/README.filters for more info.
    * src/detection-plugins/Makefile.am:
    * src/detection-plugins/sp_hdr_opt_wrap.c:
    * src/detection-plugins/sp_hdr_opt_wrap.h:
    * src/dynamic-plugins/Makefile.am:
    * src/dynamic-plugins/sf_convert_dynamic.c:
    * src/dynamic-plugins/sf_convert_dynamic.h:
    * src/dynamic-plugins/sf_engine/sf_snort_detection_engine.c:
      Changed the way .so rules are handled, to take advantage of the Rule
      Option Tree.
    * src/detection-plugins/sp_byte_check.c:
    * src/detection-plugins/sp_byte_check.h:
      Added support for ">=" and "<=" test options.
    * src/detection-plugins/sp_flowbits.c:
    * src/detection-plugins/sp_flowbits.h:
    * src/dynamic-plugins/sp_dynamic.c:
      Flowbits are now part of the rule stub that gets generated when
      dumping dynamic rules.
    * src/detection-plugins/sp_pattern_match.c:
    * src/detection-plugins/sp_pattern_match.h:
    * src/detection-plugins/sp_replace.c:
    * src/detection-plugins/sp_replace.h:
      Content replacement code moved out to sp_replace.{c,h}
    * src/detection-plugins/sp_pcre.c:
    * src/detection-plugins/sp_pcre.h:
      PCRE matches are no lnoger repeated if anchored.
    * src/decode.h:
    * src/dynamic-plugins/sf_engine/sf_snort_packet.h:
      Packet structure re-arranged, and other code cleanup.
    * src/dynamic-preprocessors/ssh/Makefile.am:
    * src/dynamic-preprocessors/ssh/sf_preproc_info.h:
    * src/dynamic-preprocessors/ssh/sf_ssh.dsp:
    * src/dynamic-preprocessors/ssh/spp_ssh.c:
    * src/dynamic-preprocessors/ssh/spp_ssh.h:
      Updated SSH preprocessor. Config options have been modified, see
      README.ssh for details.
    * src/parser.c:
      Fixed handling of IP lists with mis-matched brackets.
    * src/output-plugins/spo_unified2.c:
    * src/output-plugins/spo_unified2.h:
      MPLS and VLAN records have been consolidated into Unified2Event_v2.
    * src/win32/Makefile.am:
    * src/win32/WIN32-Code/inet_aton.c:
    * src/win32/WIN32-Code/misc.c:
    * src/win32/WIN32-Code/syslog.c:
    * src/win32/WIN32-Code/win32_service.c:
    * src/win32/WIN32-Includes/config.h:
    * src/win32/WIN32-Includes/stdint.h:
    * src/win32/WIN32-Prj/build_all.dsp:
    * src/win32/WIN32-Prj/sf_engine_initialize.dsp:
    * src/win32/WIN32-Prj/snort.dsp:
    * src/win32/WIN32-Prj/snort.dsw:
    * src/win32/WIN32-Prj/snort_initialize.dsp:
    * src/win32/WIN32-Prj/snort_installer.nsi:
      Updated Win32 installer to include new Snort files.
    * rpm/snort.spec:
      Updated RPM to include new Snort files.
    * doc/CREDITS:
    * doc/README.filters:
    * doc/README.frag3:
    * doc/README.http_inspect:
    * doc/README.ssh:
    * doc/README.thresholding:
    * doc/snort_manual.tex:
      Documentation updates.

    In addition, the following files were modified to enable:
      - Reloading snort.conf without restarting Snort
      - Applying multiple snort.confs on a per-vlan or per-CIDR block basis
      - Compiler warning clean-up
    * src/bounds.h:
    * src/byte_extract.c:
    * src/byte_extract.h:
    * src/checksum.h:
    * src/cpuclock.h:
    * src/debug.c:
    * src/decode.c:
    * src/detection-plugins/detection_options.c:
    * src/detection-plugins/detection_options.h:
    * src/detection-plugins/sp_asn1.c:
    * src/detection-plugins/sp_asn1_detect.c:
    * src/detection-plugins/sp_asn1_detect.h:
    * src/detection-plugins/sp_asn1.h:
    * src/detection-plugins/sp_byte_jump.c:
    * src/detection-plugins/sp_byte_jump.h:
    * src/detection-plugins/sp_clientserver.c:
    * src/detection-plugins/sp_clientserver.h:
    * src/detection-plugins/sp_cvs.c:
    * src/detection-plugins/sp_cvs.h:
    * src/detection-plugins/sp_dsize_check.c:
    * src/detection-plugins/sp_dsize_check.h:
    * src/detection-plugins/sp_ftpbounce.c:
    * src/detection-plugins/sp_ftpbounce.h:
    * src/detection-plugins/sp_icmp_code_check.c:
    * src/detection-plugins/sp_icmp_code_check.h:
    * src/detection-plugins/sp_icmp_id_check.c:
    * src/detection-plugins/sp_icmp_id_check.h:
    * src/detection-plugins/sp_icmp_seq_check.c:
    * src/detection-plugins/sp_icmp_seq_check.h:
    * src/detection-plugins/sp_icmp_type_check.c:
    * src/detection-plugins/sp_icmp_type_check.h:
    * src/detection-plugins/sp_ip_fragbits.c:
    * src/detection-plugins/sp_ip_fragbits.h:
    * src/detection-plugins/sp_ip_id_check.c:
    * src/detection-plugins/sp_ip_id_check.h:
    * src/detection-plugins/sp_ipoption_check.c:
    * src/detection-plugins/sp_ipoption_check.h:
    * src/detection-plugins/sp_ip_proto.c:
    * src/detection-plugins/sp_ip_same_check.c:
    * src/detection-plugins/sp_ip_same_check.h:
    * src/detection-plugins/sp_ip_tos_check.c:
    * src/detection-plugins/sp_ip_tos_check.h:
    * src/detection-plugins/sp_isdataat.c:
    * src/detection-plugins/sp_isdataat.h:
    * src/detection-plugins/sp_react.c:
    * src/detection-plugins/sp_react.h:
    * src/detection-plugins/sp_respond2.c:
    * src/detection-plugins/sp_respond2.h:
    * src/detection-plugins/sp_respond.c:
    * src/detection-plugins/sp_respond.h:
    * src/detection-plugins/sp_rpc_check.c:
    * src/detection-plugins/sp_rpc_check.h:
    * src/detection-plugins/sp_session.c:
    * src/detection-plugins/sp_session.h:
    * src/detection-plugins/sp_tcp_ack_check.c:
    * src/detection-plugins/sp_tcp_ack_check.h:
    * src/detection-plugins/sp_tcp_flag_check.c:
    * src/detection-plugins/sp_tcp_flag_check.h:
    * src/detection-plugins/sp_tcp_seq_check.c:
    * src/detection-plugins/sp_tcp_seq_check.h:
    * src/detection-plugins/sp_tcp_win_check.c:
    * src/detection-plugins/sp_tcp_win_check.h:
    * src/detection-plugins/sp_ttl_check.c:
    * src/detection-plugins/sp_ttl_check.h:
    * src/detection-plugins/sp_urilen_check.c:
    * src/detection-plugins/sp_urilen_check.h:
    * src/dynamic-plugins/sf_dynamic_common.h:
    * src/dynamic-plugins/sf_dynamic_define.h:
    * src/dynamic-plugins/sf_dynamic_detection.h:
    * src/dynamic-plugins/sf_dynamic_engine.h:
    * src/dynamic-plugins/sf_dynamic_plugins.c:
    * src/dynamic-plugins/sf_dynamic_preprocessor.h:
    * src/dynamic-plugins/sf_engine/Makefile.am:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.h:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_byte.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_content.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_hdropts.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_loop.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_pcre.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_rc4.c:
    * src/dynamic-plugins/sf_preproc_example/sf_dynamic_preproc_lib.c:
    * src/dynamic-plugins/sf_preproc_example/sf_dynamic_preproc_lib.h:
    * src/dynamic-plugins/sp_dynamic.h:
    * src/dynamic-plugins/sp_preprocopt.c:
    * src/dynamic-plugins/sp_preprocopt.h:
    * src/dynamic-preprocessors/dcerpc/dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc_config.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc.h:
    * src/dynamic-preprocessors/dcerpc/dcerpc_util.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc_util.h:
    * src/dynamic-preprocessors/dcerpc/Makefile.am:
    * src/dynamic-preprocessors/dcerpc/sf_dcerpc.dsp:
    * src/dynamic-preprocessors/dcerpc/sf_preproc_info.h:
    * src/dynamic-preprocessors/dcerpc/smb_andx_decode.c:
    * src/dynamic-preprocessors/dcerpc/smb_andx_decode.h:
    * src/dynamic-preprocessors/dcerpc/smb_andx_structs.h:
    * src/dynamic-preprocessors/dcerpc/smb_file_decode.c:
    * src/dynamic-preprocessors/dcerpc/smb_file_decode.h:
    * src/dynamic-preprocessors/dcerpc/smb_file_structs.h:
    * src/dynamic-preprocessors/dcerpc/smb_structs.h:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.h:
    * src/dynamic-preprocessors/dcerpc/spp_dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/spp_dcerpc.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_cl.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_co.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_config.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_config.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_debug.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_debug.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_event.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_event.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_http.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_list.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_roptions.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_session.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_smb.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_stats.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_tcp.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_utils.h:
    * src/dynamic-preprocessors/dcerpc2/includes/dcerpc.h:
    * src/dynamic-preprocessors/dcerpc2/includes/smb.h:
    * src/dynamic-preprocessors/dcerpc2/Makefile.am:
    * src/dynamic-preprocessors/dcerpc2/sf_dce2.dsp:
    * src/dynamic-preprocessors/dcerpc2/snort_dce2.c:
    * src/dynamic-preprocessors/dcerpc2/snort_dce2.h:
    * src/dynamic-preprocessors/dcerpc2/spp_dce2.c:
    * src/dynamic-preprocessors/dns/Makefile.am:
    * src/dynamic-preprocessors/dns/sf_dns.dsp:
    * src/dynamic-preprocessors/dns/sf_preproc_info.h:
    * src/dynamic-preprocessors/dns/spp_dns.c:
    * src/dynamic-preprocessors/dns/spp_dns.h:
    * src/dynamic-preprocessors/dynamic_preprocessors.dsp:
    * src/dynamic-preprocessors/ftptelnet/ftpp_eo_log.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_eo_log.h:
    * src/dynamic-preprocessors/ftptelnet/ftpp_si.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_si.h:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_config.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_config.h:
    * src/dynamic-preprocessors/ftptelnet/hi_util_kmap.c:
    * src/dynamic-preprocessors/ftptelnet/hi_util_xmalloc.c:
    * src/dynamic-preprocessors/ftptelnet/hi_util_xmalloc.h:
    * src/dynamic-preprocessors/ftptelnet/Makefile.am:
    * src/dynamic-preprocessors/ftptelnet/pp_ftp.c:
    * src/dynamic-preprocessors/ftptelnet/pp_telnet.c:
    * src/dynamic-preprocessors/ftptelnet/pp_telnet.h:
    * src/dynamic-preprocessors/ftptelnet/sf_ftptelnet.dsp:
    * src/dynamic-preprocessors/ftptelnet/sf_preproc_info.h:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.h:
    * src/dynamic-preprocessors/ftptelnet/spp_ftptelnet.c:
    * src/dynamic-preprocessors/ftptelnet/spp_ftptelnet.h:
    * src/dynamic-preprocessors/libs/sfcommon.h:
    * src/dynamic-preprocessors/libs/sfdynamic_preproc_libs.dsp:
    * src/dynamic-preprocessors/libs/sfparser.c:
    * src/dynamic-preprocessors/libs/ssl.c:
    * src/dynamic-preprocessors/libs/ssl.h:
    * src/dynamic-preprocessors/Makefile.am:
    * src/dynamic-preprocessors/sf_dynamic_initialize/sf_dynamic_initialize.dsp:
    * src/dynamic-preprocessors/smtp/Makefile.am:
    * src/dynamic-preprocessors/smtp/sf_preproc_info.h:
    * src/dynamic-preprocessors/smtp/sf_smtp.dsp:
    * src/dynamic-preprocessors/smtp/smtp_config.c:
    * src/dynamic-preprocessors/smtp/smtp_config.h:
    * src/dynamic-preprocessors/smtp/smtp_log.c:
    * src/dynamic-preprocessors/smtp/smtp_normalize.c:
    * src/dynamic-preprocessors/smtp/smtp_normalize.h:
    * src/dynamic-preprocessors/smtp/smtp_util.c:
    * src/dynamic-preprocessors/smtp/smtp_util.h:
    * src/dynamic-preprocessors/smtp/smtp_xlink2state.c:
    * src/dynamic-preprocessors/smtp/smtp_xlink2state.h:
    * src/dynamic-preprocessors/smtp/snort_smtp.c:
    * src/dynamic-preprocessors/smtp/snort_smtp.h:
    * src/dynamic-preprocessors/smtp/spp_smtp.c:
    * src/dynamic-preprocessors/ssl/Makefile.am:
    * src/dynamic-preprocessors/ssl/sf_preproc_info.h:
    * src/dynamic-preprocessors/ssl/sf_ssl.dsp:
    * src/dynamic-preprocessors/ssl/spp_ssl.c:
    * src/dynamic-preprocessors/ssl/spp_ssl.h:
    * src/event.h:
    * src/event_queue.c:
    * src/event_queue.h:
    * src/event_wrapper.c:
    * src/event_wrapper.h:
    * src/fpcreate.c:
    * src/fpcreate.h:
    * src/fpdetect.c:
    * src/fpdetect.h:
    * src/generators.h:
    * src/inline.c:
    * src/inline.h:
    * src/ipv6_port.h:
    * src/log.c:
    * src/log.h:
    * src/log_text.c:
    * src/log_text.h:
    * src/Makefile.am:
    * src/mempool.c:
    * src/mstring.c:
    * src/mstring.h:
    * src/output-plugins/spo_alert_arubaaction.c:
    * src/output-plugins/spo_alert_fast.c:
    * src/output-plugins/spo_alert_full.c:
    * src/output-plugins/spo_alert_prelude.c:
    * src/output-plugins/spo_alert_sf_socket.c:
    * src/output-plugins/spo_alert_syslog.c:
    * src/output-plugins/spo_alert_test.c:
    * src/output-plugins/spo_alert_unixsock.c:
    * src/output-plugins/spo_alert_unixsock.h:
    * src/output-plugins/spo_csv.c:
    * src/output-plugins/spo_database.c:
    * src/output-plugins/spo_database.h:
    * src/output-plugins/spo_log_ascii.c:
    * src/output-plugins/spo_log_ascii.h:
    * src/output-plugins/spo_log_null.c:
    * src/output-plugins/spo_log_null.h:
    * src/output-plugins/spo_log_tcpdump.c:
    * src/output-plugins/spo_unified.c:
    * src/output-plugins/spo_unified.h:
    * src/parser/IpAddrSet.c:
    * src/parser/IpAddrSet.h:
    * src/parser.h:
    * src/pcap_pkthdr32.h:
    * src/pcrm.c:
    * src/pcrm.h:
    * src/plugbase.c:
    * src/plugbase.h:
    * src/ppm.c:
    * src/ppm.h:
    * src/preprocessors/HttpInspect/client/hi_client.c:
    * src/preprocessors/HttpInspect/include/hi_client_stateful.h:
    * src/preprocessors/HttpInspect/include/hi_include.h:
    * src/preprocessors/HttpInspect/include/hi_reqmethod_check.h:
    * src/preprocessors/HttpInspect/include/hi_si.h:
    * src/preprocessors/HttpInspect/include/hi_stateful_inspect.h:
    * src/preprocessors/HttpInspect/include/hi_ui_config.h:
    * src/preprocessors/HttpInspect/include/hi_uri.h:
    * src/preprocessors/HttpInspect/include/hi_urilen_check.h:
    * src/preprocessors/HttpInspect/include/hi_util_xmalloc.h:
    * src/preprocessors/HttpInspect/normalization/hi_norm.c:
    * src/preprocessors/HttpInspect/session_inspection/hi_si.c:
    * src/preprocessors/HttpInspect/user_interface/hi_ui_config.c:
    * src/preprocessors/HttpInspect/utils/hi_util_kmap.c:
    * src/preprocessors/HttpInspect/utils/hi_util_xmalloc.c:
    * src/preprocessors/perf-base.c:
    * src/preprocessors/perf-base.h:
    * src/preprocessors/perf.c:
    * src/preprocessors/perf-event.c:
    * src/preprocessors/perf-event.h:
    * src/preprocessors/perf-flow.c:
    * src/preprocessors/perf-flow.h:
    * src/preprocessors/perf.h:
    * src/preprocessors/portscan.c:
    * src/preprocessors/portscan.h:
    * src/preprocessors/sfprocpidstats.c:
    * src/preprocessors/snort_httpinspect.c:
    * src/preprocessors/snort_httpinspect.h:
    * src/preprocessors/spp_arpspoof.c:
    * src/preprocessors/spp_bo.c:
    * src/preprocessors/spp_bo.h:
    * src/preprocessors/spp_frag3.c:
    * src/preprocessors/spp_frag3.h:
    * src/preprocessors/spp_httpinspect.c:
    * src/preprocessors/spp_httpinspect.h:
    * src/preprocessors/spp_perfmonitor.c:
    * src/preprocessors/spp_perfmonitor.h:
    * src/preprocessors/spp_rpc_decode.c:
    * src/preprocessors/spp_sfportscan.c:
    * src/preprocessors/spp_sfportscan.h:
    * src/preprocessors/spp_stream5.c:
    * src/preprocessors/spp_stream5.h:
    * src/preprocessors/Stream5/snort_stream5_icmp.c:
    * src/preprocessors/Stream5/snort_stream5_icmp.h:
    * src/preprocessors/Stream5/snort_stream5_session.c:
    * src/preprocessors/Stream5/snort_stream5_session.h:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.h:
    * src/preprocessors/Stream5/snort_stream5_udp.c:
    * src/preprocessors/Stream5/snort_stream5_udp.h:
    * src/preprocessors/Stream5/stream5_common.c:
    * src/preprocessors/Stream5/stream5_common.h:
    * src/preprocessors/stream_api.h:
    * src/preprocessors/stream_ignore.c:
    * src/preprocessors/stream_ignore.h:
    * src/preprocessors/str_search.h:
    * src/preprocids.h:
    * src/profiler.c:
    * src/profiler.h:
    * src/rules.h:
    * src/sf_types.h:
    * src/sfutil/acsmx2.c:
    * src/sfutil/acsmx2.h:
    * src/sfutil/acsmx.c:
    * src/sfutil/acsmx.h:
    * src/sfutil/asn1.c:
    * src/sfutil/asn1.h:
    * src/sfutil/bnfa_search.c:
    * src/sfutil/ipobj.c:
    * src/sfutil/Makefile.am:
    * src/sfutil/mpse.c:
    * src/sfutil/mpse.h:
    * src/sfutil/sfeventq.c:
    * src/sfutil/sfeventq.h:
    * src/sfutil/sfghash.c:
    * src/sfutil/sfghash.h:
    * src/sfutil/sfhashfcn.c:
    * src/sfutil/sf_ip.c:
    * src/sfutil/sf_ip.h:
    * src/sfutil/sf_iph.c:
    * src/sfutil/sf_ipvar.c:
    * src/sfutil/sfksearch.c:
    * src/sfutil/sfksearch.h:
    * src/sfutil/sflsq.c:
    * src/sfutil/sflsq.h:
    * src/sfutil/sfPolicy.c:
    * src/sfutil/sfPolicy.h:
    * src/sfutil/sfPolicyUserData.c:
    * src/sfutil/sfPolicyUserData.h:
    * src/sfutil/sfportobject.c:
    * src/sfutil/sfportobject.h:
    * src/sfutil/sfrf.c:
    * src/sfutil/sfrf.h:
    * src/sfutil/sfrt.c:
    * src/sfutil/sfrt_dir.c:
    * src/sfutil/sfrt_dir.h:
    * src/sfutil/sfrt.h:
    * src/sfutil/sfrt_lctrie.c:
    * src/sfutil/sfrt_lctrie.h:
    * src/sfutil/sfrt_trie.h:
    * src/sfutil/sf_textlog.h:
    * src/sfutil/sfthd.c:
    * src/sfutil/sfthd.h:
    * src/sfutil/sf_vartable.c:
    * src/sfutil/sf_vartable.h:
    * src/sfutil/sfxhash.c:
    * src/sfutil/util_math.c:
    * src/sfutil/util_math.h:
    * src/sfutil/util_net.c:
    * src/sfutil/util_net.h:
    * src/signature.c:
    * src/signature.h:
    * src/snort.c:
    * src/snort.h:
    * src/snprintf.c:
    * src/spo_plugbase.h:
    * src/tag.c:
    * src/tag.h:
    * src/target-based/sf_attribute_table_parser.l:
    * src/target-based/sf_attribute_table.y:
    * src/target-based/sftarget_hostentry.c:
    * src/target-based/sftarget_hostentry.h:
    * src/target-based/sftarget_protocol_reference.c:
    * src/target-based/sftarget_protocol_reference.h:
    * src/target-based/sftarget_reader.c:
    * src/target-based/sftarget_reader.h:
    * src/util.c:
    * src/util.h:

2009-04-20 Ryan Jordan <ryan.jordan@sourcefire.com>
    * src/dynamic-preprocessors/dcerpc2/dce2_config.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_smb.c:
    * src/dynamic-preprocessors/dcerpc2/snort_dce2.c:
      Changed DCE2 configuration such that events are disabled by default.
    * src/dynamic-preprocessors/ftptelnet/pp_ftp.c:
      Fixed false positive when an additional /r/n followed the QUIT command.
    * src/dynamic-preprocessors/ssh/spp_ssh.c:
      Fixed infinite loop when parsing SSH configuration.
    * src/output-plugins/spo_database.c:
      Fixed an issue that prevented Snort from inserting records into the
      sensor table of a MySQL database. Thanks to David Cecchino for pointing
	  out this issue.
    * src/parser.c:
    * src/sfutil/ipobj.c:
      Fixed handling of IP lists that begin with variables, when IPv6 was
      enabled.
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Handle case where require_3whs is configured, no session has been
      created and an ACK is received with a RST flag. Thanks to Jeff Johnson
	  for reporting the problem.
    * src/sfthreshold.c:
    * src/sfutil/sf_ipvar.c:
    * src/sfutil/sfportobject.c:
    * src/sfutil/sfthd.c:
    * src/sfutil/sf_vartable.c:
    * src/util.c:
      Fixed issues with use of IPv6 address variables.
    * rpm/snort.spec:
      Added DCE2 preprocessor to RPM spec file. Thanks to Scott Fabbri, c0uch,
	  and Andrew Pendray for reporting this.
    * doc/snort_manual.tex:
      Updated to add Bhagyasree Bantwal, newest member of Snort Team.

2009-03-11 Steven Sturges <ssturges@sourcefire.com>
    * src/util.c:
      Fix for IPv6 on Win32 to define interface variables.
    * src/win32/WIN32-Prj/snort_installer_options.ini:
      Update for IPv6 intalls.

2009-03-10 Steven Sturges <ssturges@sourcefire.com>
    * src/dynamic-plugins/sf_engine/sf_snort_detection_engine.c:
      Correctly pass operation to allow flowbits checked-but-not-set and 
      set-but-not-checked validation to work between text and shared rules.
    * src/dynamic-plugins/sf_dynamic_define.h:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.h:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_pcre.c:
      Handle relative PCREs the same as text rules.  Fix misnamed macro.
    * src/dynamic-preprocessors/dcerpc2/dce2_co.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_event.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_smb.c:
    * src/dynamic-preprocessors/dcerpc2/snort_dce2.c:
      Address False positives seen in testing.
    * src/dynamic-preprocessors/ftptelnet/ftpp_si.c:
      Add missing attribute check when FTP traffic is picked up mid-TCP stream.
    * src/dynamic-preprocessors/ftptelnet/pp_ftp.c:
      Fix handling of EPRT command for IPv6.
    * src/output-plugins/spo_unified2.c:
      unlink output file in test mode.
    * src/fpcreate.c: 
    * src/fpdetect.c:
    * src/parser.c:
      Fix logging to syslog for rule counts at startup.
    * src/generators.h:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/preprocessors/Stream5/stream5_common.h:
    * etc/gen-msg.map:
      Add stream5 option to restrict the number of consecutive
      small TCP segments inserted for reassembly without seeing an ACK.
      Generate alert (gid:129,sid:12) when that limit is exceeded. 
      Allow overriding of this configuration on a port basis via an
      ignore_ports option.
    * src/sfutil/sf_ip.c:
    * src/sfutil/sf_ip.h:
      Fixed issues w/ IPv6 comparisons and /32 used with IPv6.  Added 
      and updated unit test code.  Thanks to mamcmil on snort.org
      forums for pointing out the problem. 
    * src/win32/WIN32-Prj/snort_installer.nsi:
    * src/win32/WIN32-Prj/snort_installer_options.ini:
    * src/win32/WIN32-Prj/sf_engine.dsp:
    * src/dynamic-preprocessors/dcerpc/sf_dcerpc.dsp:
    * src/dynamic-preprocessors/dcerpc2/sf_dce2.dsp:
    * src/dynamic-preprocessors/dns/sf_dns.dsp:
    * src/dynamic-preprocessors/ftptelnet/sf_ftptelnet.dsp:
    * src/dynamic-preprocessors/smtp/sf_smtp.dsp:
    * src/dynamic-preprocessors/ssh/sf_ssh.dsp:
    * src/dynamic-preprocessors/ssl/sf_ssl.dsp:
    * configure.in:
    * rpm/snort.spec:
    * src/win32/WIN32-Includes/config.h:
      2.8.4 Final build changes.  Allow IPv6 to be installed via windows
      installer.

2009-02-06 Todd Wease <twease@sourcefire.com>
    * snort.8:
    * src/parser.c:
    * src/snort.c:
    * src/snort.h:
      Added command line option "--require-rule-sid" to require every rule have
      an sid.
    * src/detection-plugins/detection_options.c:
    * src/detection-plugins/detection_options.h:
      Fix compilation issue with --disable-dynamicplugin.  Thanks to
      Jason Wallace for bringing this to our attention.
    * src/dynamic-plugins/sf_engine/sf_snort_detection_engine.c:
      Push dynamic engine minor version to 10 and build version to 16.
    * src/dynamic-plugins/sf_engine/sf_snort_detection_engine.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.h:
      Fix preprocessor rule option processing for dynamic detection rules.
    * src/dynamic-plugins/sf_engine/sf_snort_detection_engine.c:
      Add checks for header and method buffers when fast pattern is not
      specified in dynamic detection rules.
    * src/dynamic-preprocessors/dcerpc/dcerpc_util.c:
    * src/dynamic-preprocessors/dcerpc/smb_andx_decode.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_utils.c:
    * src/dynamic-preprocessors/ftptelnet/pp_ftp.c:
    * src/dynamic-preprocessors/smtp/smtp_util.c:
    * src/preprocessors/HttpInspect/client/hi_client_norm.c:
    * src/sfutil/acsmx2.c:
    * src/sfutil/bnfa_search.c:
      Update uses of isprint() to check for isascii() as well where only
      printable ascii characters are relevant.
    * src/dynamic-preprocessors/smtp/snort_smtp.c:
      Update smtp preprocessor to use stream5 direction data when determining
      if preprocessor is configured to process traffic.
    * doc/README.stream5:
    * doc/snort_manual.tex:
    * src/preprocessors/spp_stream5.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Add range checking in stream5 preprocessor for prune_log_max and update
      error messages to indicate 0 is a valid value for prune_log_max,
      max_queued_segs and max_queued_bytes.
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Update to stream5 preprocessor to handle ECN and CWR bits in the SYN
      packet.  Thanks to Lothar Braun for bringing this to our attention.
    * src/sfutil/sf_ip.c:
    * src/sfutil/sf_ip.h:
      Fix configuration parsing of IPv6 addresses to allow /32 cidr.
    * src/decode.c:
    * src/decode.h:
    * src/detect.c:
    * src/detect.h:
    * src/detection-plugins/sp_ip_proto.c:
    * src/detection-plugins/sp_ip_proto.h:
    * src/dynamic-plugins/sf_engine/sf_snort_packet.h:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.c:
    * src/dynamic-preprocessors/dcerpc2/snort_dce2.c:
    * src/dynamic-preprocessors/dns/spp_dns.c:
    * src/dynamic-preprocessors/ftptelnet/spp_ftptelnet.c:
    * src/dynamic-preprocessors/smtp/spp_smtp.c:
    * src/dynamic-preprocessors/ssh/spp_ssh.c:
    * src/dynamic-preprocessors/ssl/spp_ssl.c:
    * src/fpcreate.c:
    * src/fpcreate.h:
    * src/fpdetect.h:
    * src/parser.c:
    * src/plugbase.c:
    * src/plugbase.h:
    * src/preprocessors/spp_arpspoof.c:
    * src/preprocessors/spp_bo.c:
    * src/preprocessors/spp_frag3.c:
    * src/preprocessors/spp_httpinspect.c:
    * src/preprocessors/spp_perfmonitor.c:
    * src/preprocessors/spp_rpc_decode.c:
    * src/preprocessors/spp_sfportscan.c:
    * src/preprocessors/spp_stream5.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/rules.h:
    * src/snort.c:
      Added rule and preprocessor filtering by protocol so that traffic will
      not be evaluated for which there are no rules or preprocessors interested
      in that traffic.
    * src/decode.c:
      Fixed IPv6 decoder for Sparc memory alignment in IPv6 enabled binary.
    * src/decode.h:
    * src/dynamic-plugins/sf_engine/sf_snort_packet.h:
    * src/log_text.c:
    * src/sfutil/sf_iph.c:
      Fixed issue in IPv6 enabled binary, where ICMP (not ICMP6) over IPv6
      would cause a segfault.
    * src/detection-plugins/detection_options.c:
    * src/detection-plugins/detection_options.h:
    * src/profiler.c:
    * src/profiler.h:
      Fixed inconsistent results in rule profiling.  Thanks to Geoff
      Whittington for bringing this to our attention.
    * src/detection-plugins/sp_byte_jump.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.h:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_byte.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_roptions.c:
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
      Added new "post_offset" argument to byte jump rule option to move some
      designated amount after the byte jump.
    * src/dynamic-plugins/sf_dynamic_plugins.c:
    * src/dynamic-plugins/sf_dynamic_preprocessor.h:
    * src/dynamic-plugins/sf_preproc_example/sf_dynamic_preproc_lib.c:
    * src/plugbase.c:
    * src/target-based/sftarget_reader.c:
    * src/target-based/sftarget_reader.h:
      Added functionality to the dynamic-plugin API to check whether adaptive
      profiles is configured and to check whether or not a preprocessor is
      configured.
    * src/dynamic-preprocessors/dcerpc/spp_dcerpc.c:
    * src/dynamic-preprocessors/dcerpc2/spp_dce2.c:
      Fatal error if both dcerpc and dcerpc2 preprocessors are configured.
    * src/dynamic-preprocessors/dcerpc/spp_dcerpc.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_config.c:
    * src/dynamic-preprocessors/dcerpc2/spp_dce2.c:
    * src/dynamic-preprocessors/dns/spp_dns.c:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
    * src/dynamic-preprocessors/smtp/spp_smtp.c:
    * src/dynamic-preprocessors/ssl/spp_ssl.c:
    * src/preprocessors/spp_httpinspect.c:
    * src/preprocessors/spp_rpc_decode.c:
      Updates to stream5 filtering so that stream5 does not track sessions for
      which there are no rules that could fire on that traffic or preprocessors
      that are interested in that traffic.
    * doc/README.dcerpc2:
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
    * etc/gen-msg.map:
    * etc/snort.conf:
      Added dcerpc2 preprocessor documentation.
    * src/dynamic-preprocessors/dcerpc2/dce2_cl.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_co.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_smb.c:
    * src/dynamic-preprocessors/dcerpc2/snort_dce2.c:
    * src/dynamic-preprocessors/dcerpc2/spp_dce2.c:
      Added performance profiling statistics to the dcerpc2 preprocessor.
    * src/dynamic-preprocessors/dcerpc2/dce2_cl.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_co.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_roptions.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_smb.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_utils.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_utils.h:
    * src/dynamic-preprocessors/dcerpc2/includes/dcerpc.h:
    * src/dynamic-preprocessors/dcerpc2/includes/smb.h:
      Fix for architectures requiring strict memory alignment such as Sparc in
      the dcerpc2 preprocessor.
    * src/dynamic-preprocessors/dcerpc2/dce2_config.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_config.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_roptions.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_roptions.h:
      Updated configuration error reporting in the dcerpc2 preprocessor.
    * src/dynamic-preprocessors/dcerpc2/dce2_cl.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_co.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_co.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_smb.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_smb.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_tcp.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_udp.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_session.h:
    * src/dynamic-preprocessors/dcerpc2/snort_dce2.c:
    * src/dynamic-preprocessors/dcerpc2/snort_dce2.h:
      Updated dcerpc2 preprocessor autodetection and handling of missed
      packets to limit false positives.
    * src/dynamic-preprocessors/dcerpc2/dce2_cl.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_co.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_config.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_debug.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_list.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_memory.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_roptions.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_smb.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_stats.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_utils.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_utils.h:
    * src/dynamic-preprocessors/dcerpc2/snort_dce2.c:
    * src/dynamic-preprocessors/dcerpc2/spp_dce2.c:
      Updated dcerpc2 preprocessor logging.
    * preproc_rules/preprocessor.rules:
    * src/dynamic-preprocessors/dcerpc2/dce2_co.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_event.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_event.h:
    * src/generators.h:
      Added new preprocessor event to the dcerpc2 preprocessor to alert on
      Bind or Alter Context PDUs that don't have any context items.
    * src/dynamic-preprocessors/ftptelnet/pp_ftp.c:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
      Updated ftp_telnet preprocessor to consider the AUTH command as the
      beginning of a possibly encrypted session.
    * src/dynamic-preprocessors/ftptelnet/sf_preproc_info.h:
      Pushed the ftp_telnet preprocessor minor version to 2 and build
      version to 11.
    * src/decode.c:
    * src/snort.h:
    * src/util.c:
      Added additional ethertypes to Vlan decoder.
    * configure.in
    * src/output-plugins/spo_database.c:
      Added reconnect capability to MySQL database output plugin.  Thanks to
      Ian Mitchell and other users on the lists for bringing this to our
      attention.
    * src/output-plugins/spo_unified2.c:
    * src/output-plugins/spo_unified2.h:
      Added code to better handle logging to an NFS mounted share.
    * src/parser.c:
      Command line BPF filter now overrides configuration in snort.conf.
    * src/parser.c:
      Command line log directory now overrides configuration in snort.conf.
    * src/parser.c:
    * src/snort.c:
      Fixed read back mode to reallow reading from stdin.  Thanks to John
      Gerber for bringing this to our attention.
    * src/plugbase.c:
    * src/util.c:
      Fixed compilation on HPUX 11.11.  Thanks to Lars Ebeling for bringing
      this to our attention.
    * src/preprocessors/spp_rpc_decode.c:
      Continue defragmentation even when alerting on fragmentation in the
      rpc_decode preprocessor.
    * src/preprocessors/spp_stream5.c:
      Stream5 will now fatal error if there isn't at least one of track tcp,
      track udp or track icmp.
    * src/sfthreshold.c:
    * src/sfutil/sfthd.c:
    * src/sfutil/sfthd.h:
      Allow a count of -1 to threshold configuration option to disable all
      thresholding for that object.
    * src/snort.c:
      Fixed issue with SIGHUP and handling of daemonize flag.
    * preproc_rules/decoder.rules:
    * preproc_rules/preprocessor.rules:
      Added decoder/preprocessor rules for MPLS and DCE/RPC.
    * snort.8:
      Update manpage for "-x", "--conf-error-out" and "--exit-check" command
      line options.

2008-12-30 Steven Sturges <ssturges@sourcefire.com>
    * src/output-plugins/spo_database.c:
      Update to check for a missing host name when connecting to a
      MySQL database and fail gracefully.  Thanks to Chris Benedict
      for the report.
    * doc/README.stream5:
    * doc/snort_manual.pdf:
    * doc/snort_manual.tex:
    * src/preprocessors/spp_stream5.c:
    * src/preprocessors/stream_api.h:
    * src/preprocessors/Stream5/snort_stream5_session.c:
    * src/preprocessors/Stream5/snort_stream5_session.h:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/preprocessors/Stream5/stream5_common.h:
      Update Stream5 to better handle out-of-sequence server responses
      when not doing server-side reassembly.  Add limits on number of
      bytes and segments queued to prevent one session from consuming
      all memory.
    * src/target-based/sf_attribute_table.y:
      Force bison to use malloc/free instead of alloca for older versions
      of bison.
    * src/target-based/sf_attribute_table_parser.l:
    * src/target-based/sftarget_reader.c:
      Don't fatal error when reloading an attribute table beyond the
      configured limit.  Only display warning to syslog/console.

2008-10-03 Todd Wease <twease@sourcefire.com>
    * configure.in:
    * src/decode.c:
    * src/decode.h:
    * src/detection-plugins/sp_pattern_match.c:
    * src/dynamic-plugins/sf_dynamic_plugins.c:
    * src/dynamic-plugins/sf_dynamic_preprocessor.h:
    * src/dynamic-plugins/sf_engine/Makefile.am:
    * src/dynamic-plugins/sf_engine/sf_snort_packet.h:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_hdropts.c:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.c:
    * src/dynamic-preprocessors/dns/spp_dns.c:
    * src/dynamic-preprocessors/ftptelnet/ftp_bounce_lookup.c:
    * src/dynamic-preprocessors/ftptelnet/ftp_bounce_lookup.h:
    * src/dynamic-preprocessors/ftptelnet/ftp_cmd_lookup.c:
    * src/dynamic-preprocessors/ftptelnet/ftp_cmd_lookup.h:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_config.h:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_config.h:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_server_lookup.c:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_si.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_server_lookup.c:
    * src/dynamic-preprocessors/ftptelnet/pp_ftp.c:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
    * src/dynamic-preprocessors/libs/sfdynamic_preproc_libs.dsp:
    * src/dynamic-preprocessors/sf_dynamic_initialize/sf_dynamic_initialize.dsp:
    * src/fpdetect.c:
    * src/generators.h:
    * src/ipv6_port.h:
    * src/log.c:
    * src/log_text.c:
    * src/output-plugins/spo_alert_test.c:
    * src/output-plugins/spo_csv.c:
    * src/preprocessors/HttpInspect/session_inspection/hi_si.c:
    * src/preprocessors/snort_httpinspect.c:
    * src/preprocessors/spp_frag3.c:
    * src/preprocessors/spp_sfportscan.c:
    * src/preprocessors/Stream5/snort_stream5_session.c:
    * src/preprocessors/stream_ignore.c:
    * src/sfutil/ipobj.c:
    * src/sfutil/ipobj.h:
    * src/sfutil/sf_ip.c:
    * src/sfutil/sf_ip.h:
    * src/sfutil/sf_iph.c:
    * src/sfutil/sf_ipvar.c:
    * src/sfutil/sfrt.c:
    * src/sfutil/sfrt.h:
    * src/sfutil/sfrt_dir.c:
    * src/sfutil/sfrt_dir.h:
    * src/snort.c:
    * src/target-based/sf_attribute_table.y:
    * src/target-based/sftarget_reader.c:
    * src/target-based/sftarget_reader.h:
    * src/win32/WIN32-Prj/sf_engine.dsp:
      IPv6 updates and support for sfportscan, ftp_telnet, frag3 and dns
      preprocessors and adaptive IPS.
    * etc/gen-msg.map:
    * src/decode.h:
    * src/detect.c:
    * src/detection-plugins/sp_byte_check.c:
    * src/detection-plugins/sp_byte_jump.c:
    * src/dynamic-plugins/sf_engine/sf_snort_packet.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_cl.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_cl.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_co.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_co.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_config.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_config.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_debug.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_debug.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_event.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_event.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_http.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_http.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_list.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_list.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_memory.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_memory.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_roptions.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_roptions.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_session.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_smb.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_smb.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_stats.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_stats.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_tcp.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_tcp.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_udp.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_udp.h:
    * src/dynamic-preprocessors/dcerpc2/dce2_utils.c:
    * src/dynamic-preprocessors/dcerpc2/dce2_utils.h:
    * src/dynamic-preprocessors/dcerpc2/includes/dcerpc.h:
    * src/dynamic-preprocessors/dcerpc2/includes/smb.h:
    * src/dynamic-preprocessors/dcerpc2/Makefile.am:
    * src/dynamic-preprocessors/dcerpc2/sf_dce2.dsp:
    * src/dynamic-preprocessors/dcerpc2/sf_preproc_info.h:
    * src/dynamic-preprocessors/dcerpc2/snort_dce2.c:
    * src/dynamic-preprocessors/dcerpc2/snort_dce2.h:
    * src/dynamic-preprocessors/dcerpc2/spp_dce2.c:
    * src/dynamic-preprocessors/dcerpc2/spp_dce2.h:
    * src/dynamic-preprocessors/Makefile.am:
    * src/generators.h:
    * src/output-plugins/spo_alert_fast.c:
    * src/preprocessors/snort_httpinspect.c:
    * src/sf_types.h:
    * src/sfutil/sfrt.c:
    * src/sfutil/sfrt.h:
    * src/util.c:
    * src/win32/WIN32-Prj/snort.dsp:
    * src/win32/WIN32-Prj/snort.dsw:
      Addition of dcerpc2 preprocessor.  Addition of new rule options
      supported by preprocessor.
    * src/detect.c:
    * src/detect.h:
    * src/dynamic-plugins/sf_dynamic_plugins.c:
    * src/dynamic-plugins/sf_dynamic_preprocessor.h:
    * src/dynamic-plugins/sf_preproc_example/sf_dynamic_preproc_lib.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc_config.c:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.h:
    * src/dynamic-preprocessors/dcerpc/spp_dcerpc.c:
    * src/dynamic-preprocessors/dns/spp_dns.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_si.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_config.h:
    * src/dynamic-preprocessors/ftptelnet/spp_ftptelnet.c:
    * src/dynamic-preprocessors/smtp/snort_smtp.c:
    * src/dynamic-preprocessors/smtp/snort_smtp.h:
    * src/dynamic-preprocessors/smtp/spp_smtp.c:
    * src/dynamic-preprocessors/ssh/spp_ssh.c:
    * src/dynamic-preprocessors/ssl/spp_ssl.c:
    * src/fpdetect.c:
    * src/parser.c:
    * src/preprocessors/HttpInspect/include/hi_si.h:
    * src/preprocessors/HttpInspect/include/hi_ui_config.h:
    * src/preprocessors/HttpInspect/session_inspection/hi_si.c:
    * src/preprocessors/spp_httpinspect.c:
    * src/preprocessors/spp_rpc_decode.c:
    * src/preprocessors/spp_stream5.c:
    * src/preprocessors/Stream5/snort_stream5_session.h:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/target-based/sftarget_protocol_reference.c:
    * src/target-based/sftarget_protocol_reference.h:
      Add adaptive support for http_inspect, rpc, smtp, dcerpc, dcerpc2, dns,
      ftp_telnet, ssh and ssl preprocessors.
    * configure.in:
    * src/detect.c:
    * src/detection-plugins/detection_options.c:
    * src/detection-plugins/sp_asn1.c:
    * src/detection-plugins/sp_asn1.h:
    * src/detection-plugins/sp_byte_check.c:
    * src/detection-plugins/sp_byte_check.h:
    * src/detection-plugins/sp_byte_jump.c:
    * src/detection-plugins/sp_byte_jump.h:
    * src/detection-plugins/sp_clientserver.c:
    * src/detection-plugins/sp_clientserver.h:
    * src/detection-plugins/sp_cvs.c:
    * src/detection-plugins/sp_cvs.h:
    * src/detection-plugins/sp_dsize_check.c:
    * src/detection-plugins/sp_dsize_check.h:
    * src/detection-plugins/sp_flowbits.c:
    * src/detection-plugins/sp_flowbits.h:
    * src/detection-plugins/sp_ftpbounce.c:
    * src/detection-plugins/sp_ftpbounce.h:
    * src/detection-plugins/sp_icmp_code_check.c:
    * src/detection-plugins/sp_icmp_code_check.h:
    * src/detection-plugins/sp_icmp_id_check.c:
    * src/detection-plugins/sp_icmp_id_check.h:
    * src/detection-plugins/sp_icmp_seq_check.c:
    * src/detection-plugins/sp_icmp_seq_check.h:
    * src/detection-plugins/sp_icmp_type_check.c:
    * src/detection-plugins/sp_icmp_type_check.h:
    * src/detection-plugins/sp_ip_fragbits.c:
    * src/detection-plugins/sp_ip_fragbits.h:
    * src/detection-plugins/sp_ip_id_check.c:
    * src/detection-plugins/sp_ip_id_check.h:
    * src/detection-plugins/sp_ipoption_check.c:
    * src/detection-plugins/sp_ipoption_check.h:
    * src/detection-plugins/sp_ip_proto.c:
    * src/detection-plugins/sp_ip_proto.h:
    * src/detection-plugins/sp_ip_same_check.c:
    * src/detection-plugins/sp_ip_same_check.h:
    * src/detection-plugins/sp_ip_tos_check.c:
    * src/detection-plugins/sp_ip_tos_check.h:
    * src/detection-plugins/sp_isdataat.c:
    * src/detection-plugins/sp_isdataat.h:
    * src/detection-plugins/sp_pattern_match.c:
    * src/detection-plugins/sp_pattern_match.h:
    * src/detection-plugins/sp_pcre.c:
    * src/detection-plugins/sp_pcre.h:
    * src/detection-plugins/sp_react.c:
    * src/detection-plugins/sp_react.h:
    * src/detection-plugins/sp_respond2.c:
    * src/detection-plugins/sp_respond2.h:
    * src/detection-plugins/sp_respond.c:
    * src/detection-plugins/sp_respond.h:
    * src/detection-plugins/sp_rpc_check.c:
    * src/detection-plugins/sp_rpc_check.h:
    * src/detection-plugins/sp_session.c:
    * src/detection-plugins/sp_session.h:
    * src/detection-plugins/sp_tcp_ack_check.c:
    * src/detection-plugins/sp_tcp_ack_check.h:
    * src/detection-plugins/sp_tcp_flag_check.c:
    * src/detection-plugins/sp_tcp_flag_check.h:
    * src/detection-plugins/sp_tcp_seq_check.c:
    * src/detection-plugins/sp_tcp_seq_check.h:
    * src/detection-plugins/sp_tcp_win_check.c:
    * src/detection-plugins/sp_tcp_win_check.h:
    * src/detection-plugins/sp_ttl_check.c:
    * src/detection-plugins/sp_ttl_check.h:
    * src/detection-plugins/sp_urilen_check.c:
    * src/detection-plugins/sp_urilen_check.h:
    * src/dynamic-plugins/sp_dynamic.c:
    * src/dynamic-plugins/sp_preprocopt.c:
    * src/dynamic-plugins/sp_preprocopt.h:
    * src/dynamic-preprocessors/dcerpc/sf_dcerpc.dsp:
    * src/dynamic-preprocessors/dns/sf_dns.dsp:
    * src/dynamic-preprocessors/ftptelnet/sf_ftptelnet.dsp:
    * src/dynamic-preprocessors/libs/sfdynamic_preproc_libs.dsp:
    * src/dynamic-preprocessors/smtp/sf_smtp.dsp:
    * src/dynamic-preprocessors/ssh/sf_ssh.dsp:
    * src/dynamic-preprocessors/ssl/sf_ssl.dsp:
    * src/fpcreate.c:
    * src/fpcreate.h:
    * src/fpdetect.c:
    * src/fpdetect.h:
    * src/parser.c:
    * src/pcrm.c:
    * src/pcrm.h:
    * src/plugbase.c:
    * src/ppm.c:
    * src/ppm.h:
    * src/preprocessors/spp_frag3.c:
    * src/preprocessors/spp_frag3.h:
    * src/preprocessors/str_search.c:
    * src/profiler.c:
    * src/profiler.h:
    * src/rules.h:
    * src/sfutil/acsmx2.c:
    * src/sfutil/acsmx2.h:
    * src/sfutil/acsmx.c:
    * src/sfutil/acsmx.h:
    * src/sfutil/bnfa_search.c:
    * src/sfutil/bnfa_search.h:
    * src/sfutil/mpse.c:
    * src/sfutil/mpse.h:
    * src/sfutil/sfksearch.c:
    * src/sfutil/sfksearch.h:
    * src/snort.c:
    * src/win32/WIN32-Prj/sf_engine.dsp:
    * src/win32/WIN32-Prj/snort.dsp:
      Harden rule option tree code.
    * configure.in:
    * doc/Makefile.am:
    * doc/snort_manual.tex:
    * doc/README.sfportscan:
    * src/detect.c:
    * src/detection-plugins/sp_clientserver.c:
    * src/detection-plugins/sp_flowbits.c:
    * src/fatal.h:
    * src/generators.h:
    * src/Makefile.am:
    * src/parser.c:
    * src/plugbase.c:
    * src/preprocessors/flow/common_defs.h (removed):
    * src/preprocessors/flow/flow.c (removed):
    * src/preprocessors/flow/flow_cache.c (removed):
    * src/preprocessors/flow/flow_cache.h (removed):
    * src/preprocessors/flow/flow_callback.c (removed):
    * src/preprocessors/flow/flow_callback.h (removed):
    * src/preprocessors/flow/flow_class.c (removed):
    * src/preprocessors/flow/flow_class.h (removed):
    * src/preprocessors/flow/flow_config.h (removed):
    * src/preprocessors/flow/flow_error.h (removed):
    * src/preprocessors/flow/flow.h (removed):
    * src/preprocessors/flow/flow_hash.c (removed):
    * src/preprocessors/flow/flow_hash.h (removed):
    * src/preprocessors/flow/flow_print.c (removed):
    * src/preprocessors/flow/flow_print.h (removed):
    * src/preprocessors/flow/flow_stat.c (removed):
    * src/preprocessors/flow/flow_stat.h (removed):
    * src/preprocessors/flow/int-snort (removed):
    * src/preprocessors/flow/Makefile.am (removed):
    * src/preprocessors/flow/portscan (removed):
    * src/preprocessors/Makefile.am:
    * src/preprocessors/portscan.c (removed):
    * src/preprocessors/snort_httpinspect.c:
    * src/preprocessors/snort_stream4_session.c (removed):
    * src/preprocessors/snort_stream4_session.h (removed):
    * src/preprocessors/snort_stream4_udp.c (removed):
    * src/preprocessors/snort_stream4_udp.h (removed):
    * src/preprocessors/spp_flow.c (removed):
    * src/preprocessors/spp_flow.h (removed):
    * src/preprocessors/spp_stream4.c (removed):
    * src/preprocessors/spp_stream4.h (removed):
    * src/preprocessors/stream.h (removed):
    * src/preprocids.h:
    * src/snort.c:
    * src/win32/WIN32-Prj/snort.dsp:
      Removal of stream4 and flow preprocessors from code base.
    * src/tag.c:
    * src/tag.h:
    * src/ubi_BinTree.c (removed):
    * src/ubi_BinTree.h (removed):
    * src/ubi_SplayTree.c (removed):
    * src/ubi_SplayTree.h (removed):
      Tagging now uses a hash table instead of a splay tree for data
      storage.
    * src/detection-plugins/detection_options.c:
    * src/detection-plugins/sp_pattern_match.c:
    * src/detection-plugins/sp_pattern_match.h:
    * src/dynamic-preprocessors/smtp/snort_smtp.c:
    * src/fpcreate.c:
    * src/fpcreate.h:
    * src/fpdetect.c:
    * src/fpdetect.h:
    * src/plugbase.c:
    * src/preprocessors/str_search.c:
    * src/preprocessors/str_search.h:
    * src/sfutil/acsmx2.c:
    * src/sfutil/acsmx2.h:
    * src/sfutil/acsmx.c:
    * src/sfutil/acsmx.h:
    * src/sfutil/bnfa_search.c:
    * src/sfutil/bnfa_search.h:
    * src/sfutil/mpse.c:
    * src/sfutil/mpse.h:
    * src/sfutil/sfksearch.c:
    * src/sfutil/sfksearch.h:
      Support rules with content rule options that are only not contents.
    * src/detection-plugins/detection_options.c:
    * src/detection-plugins/sp_asn1.c:
    * src/detection-plugins/sp_byte_check.c:
    * src/detection-plugins/sp_byte_jump.c:
    * src/detection-plugins/sp_clientserver.c:
    * src/detection-plugins/sp_cvs.c:
    * src/detection-plugins/sp_dsize_check.c:
    * src/detection-plugins/sp_flowbits.c:
    * src/detection-plugins/sp_ftpbounce.c:
    * src/detection-plugins/sp_icmp_code_check.c:
    * src/detection-plugins/sp_icmp_id_check.c:
    * src/detection-plugins/sp_icmp_seq_check.c:
    * src/detection-plugins/sp_icmp_type_check.c:
    * src/detection-plugins/sp_ip_fragbits.c:
    * src/detection-plugins/sp_ip_id_check.c:
    * src/detection-plugins/sp_ipoption_check.c:
    * src/detection-plugins/sp_ip_proto.c:
    * src/detection-plugins/sp_ip_same_check.c:
    * src/detection-plugins/sp_ip_tos_check.c:
    * src/detection-plugins/sp_isdataat.c:
    * src/detection-plugins/sp_pattern_match.c:
    * src/detection-plugins/sp_pcre.c:
    * src/detection-plugins/sp_react.c:
    * src/detection-plugins/sp_respond2.c:
    * src/detection-plugins/sp_respond.c:
    * src/detection-plugins/sp_rpc_check.c:
    * src/detection-plugins/sp_session.c:
    * src/detection-plugins/sp_tcp_ack_check.c:
    * src/detection-plugins/sp_tcp_flag_check.c:
    * src/detection-plugins/sp_tcp_seq_check.c:
    * src/detection-plugins/sp_tcp_win_check.c:
    * src/detection-plugins/sp_ttl_check.c:
    * src/detection-plugins/sp_urilen_check.c:
    * src/dynamic-plugins/sf_dynamic_plugins.c:
    * src/dynamic-plugins/sf_dynamic_preprocessor.h:
    * src/dynamic-plugins/sf_preproc_example/sf_dynamic_preproc_lib.c:
    * src/dynamic-plugins/sp_dynamic.c:
    * src/dynamic-plugins/sp_dynamic.h:
    * src/dynamic-plugins/sp_preprocopt.c:
    * src/dynamic-plugins/sp_preprocopt.h:
    * src/plugbase.c:
    * src/plugbase.h:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Add override keyword support.  Argument to a rule option can be
      overriden and processed elsewhere.  Added for support of new byte_test
      and byte_jump rule option argument "dce".
    * src/detection-plugins/detection_options.c:
    * src/dynamic-plugins/sf_dynamic_engine.h:
    * src/dynamic-plugins/sf_dynamic_common.h:
    * src/dynamic-plugins/sp_preprocopt.c:
    * src/dynamic-plugins/sp_preprocopt.h:
      Add hash and compare functions for preprocessors to rule option tree.
    * src/detection-plugins/sp_clientserver.c:
    * src/detection-plugins/sp_pattern_match.c:
    * src/preprocessors/snort_httpinspect.c:
    * src/preprocessors/spp_httpinspect.h:
      Make sure Stream5 is enabled when parsing most arguments to flow rule
      option.  Make sure http_inspect is enabled when parsing uricontent or http
      content modifiers.
    * src/detection-plugins/sp_clientserver.c:
      Added no_frag and only_frag arguments to flow rule option.
    * src/dynamic-plugins/sf_dynamic_plugins.c:
    * src/dynamic-plugins/sf_dynamic_preprocessor.h:
    * src/dynamic-plugins/sf_preproc_example/sf_dynamic_preproc_lib.c:
      Added dynamic callbacks for logging and resetting event queue.
    * doc/README.stream5:
    * doc/snort_manual.tex:
    * src/dynamic-preprocessors/dcerpc/spp_dcerpc.c:
    * src/dynamic-preprocessors/dns/spp_dns.c:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
    * src/dynamic-preprocessors/smtp/spp_smtp.c:
    * src/dynamic-preprocessors/ssh/spp_ssh.c:
    * src/dynamic-preprocessors/ssl/spp_ssl.c:
    * src/preprocessors/perf-base.c:
    * src/preprocessors/perf-base.h:
    * src/preprocessors/snort_httpinspect.c:
    * src/preprocessors/snort_httpinspect.h:
    * src/preprocessors/spp_httpinspect.c:
    * src/preprocessors/spp_rpc_decode.c:
    * src/preprocessors/spp_stream5.c:
    * src/preprocessors/Stream5/snort_stream5_session.h:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.h:
    * src/preprocessors/Stream5/snort_stream5_udp.c:
    * src/preprocessors/Stream5/snort_stream5_udp.h:
    * src/preprocessors/Stream5/stream5_common.c:
    * src/preprocessors/Stream5/stream5_common.h:
    * src/preprocessors/stream_api.h:
      Port and service based filtering to improve performance.  Stream5 will
      ignore traffic (if it is configured to do so) for which there are no
	  rules or preprocessors configured to look at this traffic.
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_client_lookup.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_client_lookup.h:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_config.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_config.h:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_server_lookup.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_server_lookup.h:
    * src/dynamic-preprocessors/ftptelnet/hi_util_kmap.h:
    * src/dynamic-preprocessors/ftptelnet/Makefile.am:
    * src/dynamic-preprocessors/ftptelnet/pp_ftp.c:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
      ftp_telnet_protocol server configurations now support multiple IP
      addresses and netmasks.
    * src/preprocessors/HttpInspect/include/hi_ui_config.h:
    * src/preprocessors/HttpInspect/include/hi_ui_server_lookup.h:
    * src/preprocessors/HttpInspect/user_interface/hi_ui_server_lookup.c:
    * src/preprocessors/snort_httpinspect.c:
    * src/preprocessors/spp_httpinspect.c:
      http_inspect preprocessor server configurations now support multiple IP
      addresses and netmasks.
    * doc/README.http_inspect:
    * doc/snort_manual.tex:
    * src/generators.h:
    * src/preprocessors/HttpInspect/client/hi_client.c:
    * src/preprocessors/HttpInspect/event_output/hi_eo_log.c:
    * src/preprocessors/HttpInspect/include/hi_eo_events.h:
    * src/preprocessors/HttpInspect/user_interface/hi_ui_config.c:
    * src/preprocessors/snort_httpinspect.c:
      Add a "max_headers" and "max_header_length" options to http_inspect
      server configuration.
    * src/preprocessors/HttpInspect/client/hi_client.c:
      Fix to correctly identify end of http client body request.
    * src/profiler.c:
    * src/profiler.h:
    * src/ppm.c:
    * src/ppm.h:
      Update to handle rule latency threhsolding with rule option tree.
    * doc/README.ftptelnet:
    * doc/snort_manual.tex:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
      Added "ignore_data_chan" option to ftp_telnet preprocessor to deprecate
      confusing "data_chan" option.
    * src/preprocessors/spp_stream5.c:
      Fix to alert on dropped packet in midstream session.
    * doc/CREDITS:
    * doc/snort_manual.tex:
      Update for new members of Snort team - Dilbagh Chahal and Ryan Jordan.
    * etc/snort.conf:
      Add "trustservers" do default ssl preprocessor configuration.
    * src/win32/WIN32-Includes/config.h:
    * src/win32/WIN32-Includes/WinPCAP/pcap-stdinc.h:
      Updates to compile in Visual Studio 2008.

2008-09-15 Todd Wease <twease@sourcefire.com>
    * src/detection-plugins/detection_options.c:
    * src/detection-plugins/detection_options.h:
    * src/fpcreate.c:
    * src/generators.h:
    * src/ppm.c:
    * src/ppm.h:
    * src/profiler.c:
    * src/rules.h:
    * etc/gen-msg.map:
      Update rule latency thresholding.
    * src/preprocessors/spp_flow.c:
    * src/preprocessors/spp_stream4.c:
    * doc/README.flow:
    * doc/README.flow-portscan:
    * doc/README.stream4:
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
      The flow and stream4 preprocessors will be deprecated in a
      future release.

2008-08-12 Todd Wease <twease@sourcefire.com>
    * src/bounds.h:
    * src/dynamic-preprocessors/dcerpc/dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc.h:
    * src/dynamic-preprocessors/dcerpc/dcerpc_config.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc_util.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc_util.h:
    * src/dynamic-preprocessors/dcerpc/smb_andx_decode.c:
    * src/dynamic-preprocessors/dcerpc/smb_andx_decode.h:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.h:
    * src/dynamic-preprocessors/dcerpc/spp_dcerpc.c:
    * src/preprocessors/spp_stream5.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * doc/README.dcerpc:
    * doc/snort_manual.tex:
      DCE/RPC preprocessor changes to handle abnormal TCP segmentation.
      Added option to reassemble fragmentation buffers early.  Updated
      documentation.
    * src/decode.c:
    * src/decode.h:
    * src/preprocessors/Stream5/snort_stream5_session.c:
      Fixed handling of MPLS label in checking Stream session uniqueness
      when IPv4 packets are received and build is IPv6.
    * src/preprocessors/perf-base.c:
    * src/preprocessors/perf-base.h:
      MPLS stats are now printed, whether compiled for MPLS or not.
    * src/detection-plugins/sp_pattern_match.c:
      Fixed checksum calculation for IPv6 case for 'replace' rule option.
    * src/dynamic-plugins/sf_engine/sf_snort_detection_engine.c:
      Added check to not register so rule if it has already been registered.
    * src/dynamic-preprocessors/smtp/snort_smtp.c:
    * src/dynamic-preprocessors/smtp/snort_smtp.h:
      Added better handling of SMTP data header options to avoid false
      positives occuring with data header buffer overlflow smtp preprocessor
      event.  Thanks to rmkml for bringing this to our attention.
    * src/event_queue.c:
    * src/signature.c:
      Added checks to only allow one rule without an SID defined.  Thanks to
      Christian Mock for bringing this to our attention.
    * src/parser.c:
    * doc/README.PerfProfiling:
      Updated performance profiling README to document new 'filename' option.
      Fixed handling of 'filename' option in the rule profiling configuration.
    * src/plugbase.c:
      Changed plugins startup output to use log function instead of printf().
    * src/preprocessors/HttpInspect/client/hi_client.c:
      Fixes to avoid false positives on http_inspect preprocessor events for
      bare byte encoding and oversize request-uri directory.
    * doc/CREDITS:
      Credits updates.
    * doc/README.decode:
    * doc/snort_manual.tex:
      Fixed some spelling errors and confusing syntax.  Thanks to Hari Sekhon
      for pointing many of these out.

2008-07-18 Todd Wease <twease@sourcefire.com>
    * src/detection-plugins/sp_dsize_check.c:
      Fix issue with rule option "dsize" range check.
      Thanks to Bhadresh Patel for bringing this to our attention.
    * src/detection-plugins/sp_pcre.c:
      Fix issue with evaluating PCRE rule options with /U modifier that
      are followed by a relative content rule option.
      Many thanks to Bamm Visscher for doing the research, finding the
      offending rule and producing the test case necessary to track
      down and fix the issue.  Also thanks to others on the snort users
      list - craig for starting a thread and JJ Cummings for confirming
      it was not a logging issue.

2008-07-11 Todd Wease <twease@sourcefire.com>
    * src/byte_extract.c:
      Added byte test for 3 bytes.
    * src/debug.c:
    * src/debug.h:
    * src/dynamic-preprocessors/libs/ssl.c:
    * src/dynamic-preprocessors/libs/ssl.h:
    * src/dynamic-preprocessors/ssl/sf_preproc_info.h: 
    * src/dynamic-preprocessors/ssl/spp_ssl.c:
    * src/dynamic-preprocessors/ssl/spp_ssl.h:
      Updates to SSL preprocessor to make it work with stream
      reassembly, multiple handshake records and disabling detection.
    * src/decode.c:
    * src/preprocessors/spp_frag3.c:
    * src/parser.c:
    * src/snort.c:
    * src/snort.h:
      Fix MPLS fragmentation reassembly issue.
    * src/detection-plugins/detection_options.c:
    * src/detection-plugins/detection_options.h:
    * src/detection-plugins/sp_asn1.c:
    * src/detection-plugins/sp_byte_check.c:
    * src/detection-plugins/sp_byte_jump.c:
    * src/detection-plugins/sp_clientserver.c:
    * src/detection-plugins/sp_cvs.c:
    * src/detection-plugins/sp_dsize_check.c:
    * src/detection-plugins/sp_flowbits.c:
    * src/detection-plugins/sp_ftpbounce.c:
    * src/detection-plugins/sp_icmp_code_check.c:
    * src/detection-plugins/sp_icmp_id_check.c:
    * src/detection-plugins/sp_icmp_seq_check.c:
    * src/detection-plugins/sp_icmp_type_check.c:
    * src/detection-plugins/sp_ip_fragbits.c:
    * src/detection-plugins/sp_ip_id_check.c:
    * src/detection-plugins/sp_ipoption_check.c:
    * src/detection-plugins/sp_ip_proto.c:
    * src/detection-plugins/sp_ip_tos_check.c:
    * src/detection-plugins/sp_isdataat.c:
    * src/detection-plugins/sp_pattern_match.c:
    * src/detection-plugins/sp_pcre.c:
    * src/detection-plugins/sp_react.c:
    * src/detection-plugins/sp_respond2.c:
    * src/detection-plugins/sp_respond.c:
    * src/detection-plugins/sp_rpc_check.c:
    * src/detection-plugins/sp_session.c:
    * src/detection-plugins/sp_tcp_ack_check.c:
    * src/detection-plugins/sp_tcp_flag_check.c:
    * src/detection-plugins/sp_tcp_seq_check.c:
    * src/detection-plugins/sp_tcp_win_check.c:
    * src/detection-plugins/sp_ttl_check.c:
    * src/detection-plugins/sp_urilen_check.c:
    * src/dynamic-plugins/sp_dynamic.c:
    * src/dynamic-plugins/sp_preprocopt.c:
    * src/preprocessors/Stream5/snort_stream5_session.c:
    * src/sfutil/sfhashfcn.h:
      Move hash rot macros.
    * src/dynamic-preprocessors/dcerpc/sf_dcerpc.dsp:
    * src/dynamic-preprocessors/dns/sf_dns.dsp:
    * src/dynamic-preprocessors/ftptelnet/sf_ftptelnet.dsp:
    * src/dynamic-preprocessors/libs/sfdynamic_preproc_libs.dsp:
    * src/dynamic-preprocessors/smtp/sf_smtp.dsp:
    * src/dynamic-preprocessors/ssh/sf_ssh.dsp:
    * src/dynamic-preprocessors/ssl/sf_ssl.dsp:
    * src/win32/WIN32-Prj/sf_engine.dsp:
    * src/win32/WIN32-Prj/snort.dsp:
      Update Win32 project files to include MPLS.
    * src/util.c:
      For read mode, reset errno after gathering pcaps from
      a directory.
    * etc/sid-msg.map:
      Updates.

2008-06-16 Todd Wease <twease@sourcefire.com>
    * src/cpuclock.h:
      Fixed compilation issue on HPUX machines related to performance
      profiling and the assembly instructions used for getting cpu
      clock ticks.  Thanks to Pavan Raj and Jaipal Reddy for pointing
      this out.
    * src/decode.c:
    * src/decode.h:
    * src/dynamic-plugins/sf_engine/sf_snort_packet.h:
    * src/generators.h:
    * src/log.c:
    * src/log.h:
    * src/output-plugins/spo_unified2.c:
    * src/parser.c:
    * src/preprocessors/perf-base.c:
    * src/preprocessors/perf-base.h:
    * src/preprocessors/spp_frag3.c:
    * src/preprocessors/Stream5/snort_stream5_session.c:
    * src/preprocessors/Stream5/stream5_common.h:
    * src/snort.c:
    * src/snort.h:
    * src/util.c:
    * configure.in:
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
    * doc/README.mpls:
      Added MPLS decoding support.
    * src/decode.c:
    * src/generators.h:
    * etc/gen-msg.map:
      Fixed alert message for IP datagram being greater than captured
      length.
    * src/decode.h:
    * src/detection-plugins/sp_pattern_match.c:
    * src/detection-plugins/sp_pattern_match.h:
    * src/detection-plugins/sp_pcre.c:
    * src/dynamic-plugins/sf_dynamic_common.h:
    * src/dynamic-plugins/sf_engine/sf_snort_detection_engine.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.h:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_byte.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_content.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_loop.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_pcre.c:
    * src/fpcreate.c:
    * src/fpdetect.c:
    * src/preprocessors/HttpInspect/client/hi_client.c:
    * src/preprocessors/HttpInspect/client/hi_client_norm.c:
    * src/preprocessors/HttpInspect/include/hi_client.h:
    * src/preprocessors/HttpInspect/include/hi_include.h:
    * src/preprocessors/HttpInspect/include/hi_ui_config.h:
    * src/preprocessors/HttpInspect/server/hi_server.c:
    * src/preprocessors/HttpInspect/session_inspection/hi_si.c:
    * src/preprocessors/HttpInspect/user_interface/hi_ui_config.c:
    * src/preprocessors/snort_httpinspect.c:
    * src/preprocessors/spp_httpinspect.c:
    * src/sfutil/acsmx2.c:
    * src/sfutil/acsmx2.h:
    * src/sfutil/acsmx.c:
    * src/sfutil/acsmx.h:
    * src/sfutil/bnfa_search.c:
    * src/sfutil/bnfa_search.h:
    * src/sfutil/mpse.c:
    * src/sfutil/mpse.h:
    * src/sfutil/sfksearch.c:
    * src/sfutil/sfksearch.h:
    * src/util.c:
    * src/util.h:
    * doc/README.http_inspect:
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
      New Feature for HTTP Inspect to split requests into 5 components -
      Method, URI, Header (non-cookie), Cookies, Body.  Added HTTP server
      specific configurations to normalize HTTP header and/or cookie buffers.
      Provided content and PCRE modifiers to allow searches within one or
      more of those individual buffers.  Added content modifier to allow rule
      writer to specify content to be used for fast pattern matcher.
      Updated dynamic rule API to allow searches within the new buffers.
    * src/detection-plugins/sp_flowbits.c:
    * src/dynamic-plugins/sp_dynamic.c:
    * src/parser.c:
    * src/snort.c:
    * src/snort.h:
      Provided command line switch to bail on rule parsing failure.
    * src/dynamic-preprocessors/ftptelnet/spp_ftptelnet.c:
    * src/preprocessors/spp_httpinspect.c:
      Fixed some configuration error checking.
    * src/dynamic-preprocessors/ssl/spp_ssl.c:
      Fixed false negative when using 'trustservers' option.
    * src/output-plugins/spo_database.c:
      Fixed issue where when using the 'ruletype' keyword with database
      output, events were getting logged using both the default log method
      and the ruletype log method.  Thanks to Agent Smith for pointing this
      out.
    * src/output-plugins/spo_unified2.c:
      Fixed issue in unified2 code where the timestamp of an event on
      a stream reassembled packet was using the last stream segment 
      instead of the first.
    * src/parser.c:
    * src/profiler.c:
    * src/snort.h:
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
      Provided option to rule and preprocessor profiling configurations to
      log to file instead of syslog.
    * src/preprocessors/perf-flow.c:
      Packet size distribution reported by snort flow stats do not count
      reassmbled packets anymore.
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Update Stream5 to flush bytes up to ACK if ACK falls in the middle
      of a segment instead of including entire segment in reassembled
      packet.
    * src/snort.c:
      Reset packet processor when reading multiple pcaps and pcap reset
      option is used.
    * doc/README.decode:
      Update GRE decoder alerts.

2008-06-04 Todd Wease <twease@sourcefire.com>
    * src/fpdetect.c:
    * src/detection-plugins/detection_options.c:
      Fix issue where pass rules weren't getting precedence
      over alert rules.  Thanks to Jason Haar for pointing
      this out.
    * src/snort.c:
      Reset data link for new pcap when reading multiple pcaps.
    * etc/gen-msg.map:
      Add IPv6 decoder events.

2008-05-07 Todd Wease <twease@sourcefire.com>
    * src/decode.c:
    * src/decode.h:
    * src/dynamic-plugins/sf_engine/sf_snort_packet.h:
      Fix issue in ICMP6 code that made an incorrect calculation
      when the ICMP6 type was an echo or an echo reply.
    * src/detection-plugins/detection_options.c:
    * src/detection-plugins/detection_options.h:
    * src/profiler.c:
    * src/profiler.h:
      Pattern Matcher Caching & Rule Processing Performance Improvements. 
    * src/dynamic-preprocessors/smtp/snort_smtp.c:
      Fix memory leak caused by missed or dropped traffic.
    * src/preprocessors/HttpInspect/include/hi_eo_events.h:
      Remove redundant macro.
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
    * doc/README.decoder_preproc_rules:
      Add documentation on the use of decoder and preprocessor rules.

2008-04-30 Todd Wease <twease@sourcefire.com>
    * src/decode.c:
    * src/decode.h:
    * src/dynamic-plugins/sf_engine/sf_snort_packet.h:
    * src/fpcreate.c:
    * src/fpdetect.c:
    * src/profiler.c:
      Process IP rules by fast pattern searching payload of outer IP,
      then evaluating matching rules against IP header & payload of
      inner & outer IP.  This is to address false positives and 
      false negatives in IP rules.
    * src/detection-plugins/sp_cvs.c:
    * src/detection-plugins/sp_cvs.h:
    * src/preprocessors/spp_frag3.c:
      Fix typos.  Thanks to rmkml for pointing this out.
    * src/ipv6_port.h:
    * src/log.c:
    * src/log_text.c:
      Update log to correct datagram length macro for IPv6.
    * src/detection-plugins/sp_pcre.c:
    * src/dynamic-plugins/sf_dynamic_define.h:
    * src/dynamic-plugins/sf_dynamic_engine.h:
    * src/dynamic-plugins/sf_dynamic_plugins.c:
    * src/dynamic-plugins/sf_engine/sf_snort_detection_engine.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.h:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_pcre.c:
      Expose a pcre wrapper function to detection library rules via plugin api.

2008-04-14 Todd Wease <twease@sourcefire.com>
    * configure.in:
    * src/detect.c:
    * src/detect.h:
    * src/detection-plugins/Makefile.am:
    * src/detection-plugins/detection_options.c:
    * src/detection-plugins/detection_options.h:
    * src/detection-plugins/sp_asn1.c:
    * src/detection-plugins/sp_asn1.h:
    * src/detection-plugins/sp_byte_check.c:
    * src/detection-plugins/sp_byte_check.h:
    * src/detection-plugins/sp_byte_jump.c:
    * src/detection-plugins/sp_byte_jump.h:
    * src/detection-plugins/sp_clientserver.c:
    * src/detection-plugins/sp_clientserver.h:
    * src/detection-plugins/sp_cvs.c:
    * src/detection-plugins/sp_cvs.h:
    * src/detection-plugins/sp_dsize_check.c:
    * src/detection-plugins/sp_dsize_check.h:
    * src/detection-plugins/sp_flowbits.c:
    * src/detection-plugins/sp_flowbits.h:
    * src/detection-plugins/sp_ftpbounce.c:
    * src/detection-plugins/sp_ftpbounce.h:
    * src/detection-plugins/sp_icmp_code_check.c:
    * src/detection-plugins/sp_icmp_code_check.h:
    * src/detection-plugins/sp_icmp_id_check.c:
    * src/detection-plugins/sp_icmp_id_check.h:
    * src/detection-plugins/sp_icmp_seq_check.c:
    * src/detection-plugins/sp_icmp_seq_check.h:
    * src/detection-plugins/sp_icmp_type_check.c:
    * src/detection-plugins/sp_icmp_type_check.h:
    * src/detection-plugins/sp_ip_fragbits.c:
    * src/detection-plugins/sp_ip_fragbits.h:
    * src/detection-plugins/sp_ip_id_check.c:
    * src/detection-plugins/sp_ip_id_check.h:
    * src/detection-plugins/sp_ipoption_check.c:
    * src/detection-plugins/sp_ipoption_check.h:
    * src/detection-plugins/sp_ip_proto.c:
    * src/detection-plugins/sp_ip_proto.h:
    * src/detection-plugins/sp_ip_same_check.c:
    * src/detection-plugins/sp_ip_same_check.h:
    * src/detection-plugins/sp_ip_tos_check.c:
    * src/detection-plugins/sp_ip_tos_check.h:
    * src/detection-plugins/sp_isdataat.c:
    * src/detection-plugins/sp_isdataat.h:
    * src/detection-plugins/sp_pattern_match.c:
    * src/detection-plugins/sp_pattern_match.h:
    * src/detection-plugins/sp_pcre.c:
    * src/detection-plugins/sp_pcre.h:
    * src/detection-plugins/sp_react.c:
    * src/detection-plugins/sp_react.h:
    * src/detection-plugins/sp_respond2.c:
    * src/detection-plugins/sp_respond2.h:
    * src/detection-plugins/sp_respond.c:
    * src/detection-plugins/sp_respond.h:
    * src/detection-plugins/sp_rpc_check.c:
    * src/detection-plugins/sp_rpc_check.h:
    * src/detection-plugins/sp_session.c:
    * src/detection-plugins/sp_session.h:
    * src/detection-plugins/sp_tcp_ack_check.c:
    * src/detection-plugins/sp_tcp_ack_check.h:
    * src/detection-plugins/sp_tcp_flag_check.c:
    * src/detection-plugins/sp_tcp_flag_check.h:
    * src/detection-plugins/sp_tcp_seq_check.c:
    * src/detection-plugins/sp_tcp_seq_check.h:
    * src/detection-plugins/sp_tcp_win_check.c:
    * src/detection-plugins/sp_tcp_win_check.h:
    * src/detection-plugins/sp_ttl_check.c:
    * src/detection-plugins/sp_ttl_check.h:
    * src/detection-plugins/sp_urilen_check.c:
    * src/detection-plugins/sp_urilen_check.h:
    * src/dynamic-plugins/sp_dynamic.c:
    * src/dynamic-plugins/sp_dynamic.h:
    * src/dynamic-plugins/sp_preprocopt.c:
    * src/dynamic-plugins/sp_preprocopt.h:
    * src/dynamic-preprocessors/smtp/snort_smtp.c:
    * src/event_queue.c:
    * src/fpcreate.c:
    * src/fpcreate.h:
    * src/fpdetect.c:
    * src/fpdetect.h:
    * src/parser.c:
    * src/pcrm.h:
    * src/plugbase.c:
    * src/plugbase.h:
    * src/ppm.c:
    * src/ppm.h:
    * src/preprocessors/spp_frag3.c:
    * src/preprocessors/spp_frag3.h:
    * src/preprocessors/str_search.c:
    * src/preprocessors/str_search.h:
    * src/rules.h:
    * src/sfutil/acsmx2.c:
    * src/sfutil/acsmx2.h:
    * src/sfutil/acsmx.c:
    * src/sfutil/acsmx.h:
    * src/sfutil/bnfa_search.c:
    * src/sfutil/bnfa_search.h:
    * src/sfutil/mpse.c:
    * src/sfutil/mpse.h:
    * src/sfutil/sfksearch.c:
    * src/sfutil/sfksearch.h:
      Pattern Matcher Caching & Rule Processing Performance Improvements.
    * configure.in:
    * src/dynamic-plugins/sf_dynamic_plugins.c:
    * src/event_wrapper.c:
    * src/fpcreate.c:
    * src/fpcreate.h:
    * src/fpdetect.c:
    * src/fpdetect.h:
    * src/parser/IpAddrSet.c:
    * src/parser.c:
    * src/parser.h:
    * src/pcrm.c:
    * src/plugbase.c:
    * src/plugbase.h:
    * src/preprocessors/spp_httpinspect.c:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/spp_stream5.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/preprocessors/stream_ignore.c:
    * src/preprocessors/stream_ignore.h:
    * src/profiler.c:
    * src/sfthreshold.c:
    * src/sfthreshold.h:
    * src/sfutil/acsmx2.c:
    * src/sfutil/acsmx2.h:
    * src/sfutil/bnfa_search.c:
    * src/sfutil/bnfa_search.h:
    * src/sfutil/mpse.c:
    * src/sfutil/mpse.h:
    * src/sfutil/sfksearch.c:
    * src/sfutil/sfksearch.h:
    * src/sfutil/sfportobject.c:
    * src/sfutil/sfportobject.h:
    * src/sfutil/sfthd.c:
    * src/sfutil/sfthd.h:
    * src/sfutil/sf_vartable.c:
    * src/sfutil/sf_vartable.h:
    * src/signature.c:
    * src/signature.h:
    * src/snort.c:
    * src/spo_plugbase.h:
    * src/target-based/sftarget_protocol_reference.c:
    * src/target-based/sftarget_protocol_reference.h:
    * src/target-based/sftarget_reader.c:
    * src/win32/WIN32-Prj/sf_engine.dsp:
    * src/win32/WIN32-Prj/snort.dsp:
      Added configuration option to clean up all initialization
      memory at shutdown.
    * src/decode.h:
    * src/preprocessors/snort_httpinspect.c:
      Add counter for HTTP pipeline requests.
    * src/dynamic-preprocessors/ftptelnet/pp_ftp.c:
      Fixed issue where some FTP traffic was being labeled as
      encrypted when it was not.
    * src/output-plugins/spo_database.c:
      Free SQL statement.  Thanks to Carter Browne for pointing this out.
    * snort.8:
    * doc/snort_manual.tex:
    * src/snort.c:
    * src/util.c:
      Update to indicate --pid-path specifies the directory for the
      PID file.  Thanks to Lee Clemens for pointing out the ambiguity.
    * src/snort.c:
      For --pcap-show option, print to stdout instead of stderr.
    * doc/snort_manual.tex:
    * src/snort.h:
      Set minimum max attribute hosts to 32 instead of 8192.
    * src/target-based/sf_attribute_table_parser.l:
      Allow ! character in attribute table grammar for string values.
    * src/snort.c:
    * src/util.c:
      Print log message with BPF filter passed to Snort.
    * src/sfutil/mpse.c:
      Fix issue with default case (which isn't ever hit) of pattern
      matcher performance stats not being calculated correctly.
      Thanks to Wang Zhen for pointing this out.
    * src/parser.c:
      Fixed string comparison for "portvar" and "ipvar" to use
      correct string length.  Thanks to Eric Duda for pointing 
      this out.
    * doc/INSTALL:
      Update MAC OSX install notes.
    * doc/README.arpspoof:
      Update arpspoof documentation.
    * etc/snort.conf:
      Update frag3_global configuration example.

2008-04-03 Steven Sturges <ssturges@sourcefire.com>
    * rpm/snort.spec:
      Add ssl preprocessor.  Thanks fo Andrew Pendray for noticing.

2008-03-12 Todd Wease <twease@sourcefire.com>
    * src/decode.c:
    * doc/README.gre:
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
    * doc/Makefile.am:
      Disable PPP decoding if architecture requires word alignment,
      e.g. SPARC machines.
    * src/dynamic-preprocessors/dcerpc/smb_structs.h:
      Fix endian issue when determining if SMB is using unicode strings.
    * src/dynamic-preprocessors/ftptelnet/ftpp_si.c:
      Fix issue where FTPTelnet sometimes determines incorrect direction
      with midstream session.
    * src/generators.h:
    * src/preprocessors/spp_frag3.c:
    * doc/README.frag3:
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
    * etc/gen-msg.map:
      Update frag3 to remove enforcement of ttl_limit. Add preprocessor
      alert for min_ttl anomaly.
    * doc/README.ipip:
    * doc/Makefile.am:
      Added README doc for IP in IP decoding.
    * doc/README.stream4:
    * etc/gen-msg.map:
      Fixed some typos.  Thanks to rmkml for pointing this out.

2008-03-06 Steven Sturges <ssturges@sourcefire.com>
	* src/dynamic-preprocessors/ssl/spp_ssl.c:
    * doc/README.ssl:
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
      Improve handling for change cipher records and rule options.
      Indicate that trustservers option only makes sense when
      noinspect_encrypted is used.

2008-03-05 Steven Sturges <ssturges@sourcefire.com>
    * doc/README.variables:
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
      Fix a few misspellings.  Thanks to Markus Lude for letting us know.

2008-03-04 Steven Sturges <ssturges@sourcefire.com>
    * configure.in:
    * src/win32/WIN32-Prj/snort_installer.nsi:
    * rpm/snort.spec:
    * src/win32/WIN32-Includes/config.h:
      2.8.1 RC prep
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
    * doc/README.arpspoof (added):
    * doc/README.pcap_readmode (added):
    * snort.8:
      Document new multiple pcap command line options and ARP Spoof
      preprocessor configuration.
    * doc/README.dcerpc:
    * doc/README.http_inspect:
    * doc/README.stream4:
      Update to include information about alerts generated from various
      preprocessors.
    * src/decode.c:
    * src/log_text.c:
    * src/parser.c:
    * src/profiler.c:
    * src/detection-plugins/sp_cvs.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_pcre.c:
    * src/dynamic-preprocessors/libs/sfcommon.h:
    * src/preprocessors/spp_frag3.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/sfutil/bitop_funcs.h:
    * src/sfutil/sf_iph.c:
    * src/sfutil/sfportobject.c:
    * src/target-based/sftarget_reader.c:
    * src/win32/WIN32-Includes/rpc/types.h:
      Win32 compiler warning cleanup.
    * src/decode.h:
    * src/dynamic-plugins/sf_engine/sf_snort_packet.h:
    * src/win32/WIN32-Prj/sf_engine.dsp:
      Reorganize to provide better compatibility with shared libraries.
    * src/detect.c:
    * src/detect.h:
    * src/plugbase.c:
    * src/plugbase.h:
    * src/dynamic-plugins/sf_dynamic_common.h:
    * src/dynamic-plugins/sf_dynamic_preprocessor.h:
    * src/dynamic-preprocessors/dcerpc/dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc.h:
    * src/dynamic-preprocessors/dcerpc/sf_dcerpc.dsp:
    * src/dynamic-preprocessors/dcerpc/smb_andx_decode.c:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.h:
    * src/dynamic-preprocessors/dcerpc/spp_dcerpc.c:
    * src/output-plugins/spo_alert_fast.c:
    * src/snort.c:
    * src/snort.h:
      Update to logging of DCE/RPC defragmented packets when using
      console/fast output modes.
    * src/preprocids.h:
    * src/dynamic-plugins/sf_dynamic_engine.h:
    * src/dynamic-plugins/sf_engine/Makefile.am:
    * src/dynamic-plugins/sf_dynamic_plugins.c:
    * src/dynamic-plugins/sf_engine/sf_snort_detection_engine.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.h:
    * src/dynamic-plugins/sf_preproc_example/sf_dynamic_preproc_lib.c:
      Add ability for dynamic rules to store and retrieve data on stream
      session.
    * src/detection-plugins/sp_pcre.c:
      Fix compile warning with older versions of PCRE library.
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
      Update default configuration for FTP's STRU command.

2008-01-27 Todd Wease <twease@sourcefire.com>
    * src/decode.c:
	* src/decode.h:
	* src/dynamic-plugins/sf_engine/sf_snort_packet.h:
	* src/generators.h:
	* src/preprocessors/spp_frag3.c:
	* src/snort.c:
	* src/snort.h:
	* src/util.c:
	* etc/gen-msg.map:
	  Added IP in IP encapsulation support for both IPv4 and IPv6.
	* src/dynamic-plugins/sf_dynamic_engine.h:
	* src/dynamic-plugins/sf_dynamic_plugins.c:
	* src/dynamic-plugins/sf_engine/sf_snort_detection_engine.c:
	* src/snort.c:
	  Enforce stricter versioning when loading shared objects.  Vesions
	  of shared libraries - engine and dynamic preprocessors - will not
	  load if from an older version of Snort.
	* src/dynamic-preprocessors/ssl/spp_ssl.c:
	  Fatal error if commas are not used in SSL dynamic preprocessor 
	  configuration.  Thanks to Chris Rohlf for bringing this to our
	  attention.
	* src/generators.h:
	* src/preprocessors/Stream5/snort_stream5_tcp.c:
	* etc/gen-msg.map:
	  Update Stream5 to alert on data without TCP flags when non-linux
	  policy.  Thanks to Chris Eagle, Naval Postgraduate School, for
	  bringing this to our attention.
	* src/parser.c:
	  Generate a parsing error if an empty IP list is used (this is 
	  equivalent to !any).  Thanks to Chris Rohlf for bring this to
	  our attention.
	* src/parser.c:
	* src/sfutil/sfportobject.c:
	* src/sfutil/sfportobject.h:
	  Various port object changes.
	  Update to handle open port ranges (ie, 1024:) and print error
	  lines from config file parsing.
	  Added support for handling embedded lists with negations.
	  Use more compatible strrchr() instead of rindex().
      Add stricter configuration checks - thanks to Rmkml for bringing
	  this to our attention.
	* src/target-based/sftarget_reader.c:
	  Use inet_pton() instead of inet_aton.
	* src/target-based/sftarget_reader.c:
	* src/util.c:
	  Set uid and gid of target-based thread if not already set.
	* doc/snort_manual.tex:
	* doc/snort_manual.pdf:
      Update to describe new pcre match limit options.
	* src/win32/WIN32-Prj/snort.dsp:
	  Remove system dependent Oracle paths from project.
	* src/fpcreate.c:
	  Correctly set the max_size when a longer pattern.
	* src/profiler.c:
	  Add Percent of Total column to output.
	* src/sfutil/sf_textlog.c:
	  Added format string to prevent messages with certain format
	  from crashing Snort.

2007-12-10 Todd Wease <twease@sourcefire.com>
    * configure.in:
	  Require PCRE version 6 or better
	* src/dynamic-preprocessors/smtp/Makefile.am:
	* src/dynamic-preprocessors/smtp/smtp_log.c:
	* src/dynamic-preprocessors/smtp/smtp_xlink2state.c:
	* src/dynamic-preprocessors/smtp/snort_smtp.c:
	* src/dynamic-preprocessors/smtp/snort_smtp.h:
	* src/dynamic-preprocessors/smtp/spp_smtp.c:
	* src/dynamic-preprocessors/smtp/sf_smtp.dsp
	* src/preprocessors/spp_stream4.c:
	* src/preprocessors/spp_stream5.c:
	* src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.h:
	* src/preprocessors/stream_api.h:
	  Reduce command line and response line overflow false positives
	  in SMTP preprocessor when Snort is missing packets.  Only alert
	  on one unique SMTP event per session.
    * configure.in:
	  Add check for Phil Woods pcap so that pcap stats are computed
	  correctly.  Thanks to John Hally for bringing this to our
	  attention.
	* doc/INSTALL:
      Update for building on Mac OSX 10.5.  Thanks to Martin Fong
	  for bringing this to our attention.
	* doc/README.asn1:
	* doc/README.dcerpc:
	* doc/README.dns:
	* doc/README.flow-portscan:
	* doc/README.frag3:
	* doc/README.ssh:
	* doc/README.stream5:
      Update to include information about alerts generated from various
      preprocessors.
	* doc/snort_manual.pdf:
	* doc/snort_manual.tex:
      Add info on stream_size option added with Stream5.
    * etc/gen-msg.map:
      Update to include GRE alerts
    * src/dynamic-plugins/sf_engine/sf_snort_detection_engine.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.h:
      Allow specifying metadata within a shared library rule.
    * src/decode.c:
      Update for decoding IP6 header lengths.
    * src/detect.c:  
    * src/parser.c:  
      Correctly handle rule-type keyword.  Thanks to Tung Tran for bringing
      this to our attention.
    * src/log_text.c:
    * src/log.c:
      Fix issue with printing IPv6 addresses.
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
      Update default configuration to allow optional string to STRU command.
    * src/dynamic-preprocessors/libs/sfparser.c:
    * src/dynamic-preprocessors/libs/ssl.c:
    * src/dynamic-preprocessors/libs/ssl.h:
    * src/dynamic-preprocessors/ssl/spp_ssl.c:
      Updates to better handle SSLv2 recognition.
    * src/preprocessors/snort_stream4_session.c:
    * src/preprocessors/stream.h:
      Fix misaligned structures for Sparc 64bit OpenBSD.  Thanks to Markus Lude
      for helping us track down the problem.
    * src/preprocessors/spp_stream4.c:
      Warn if configured with stream4 & target-based attributes.
    * src/preprocessors/snort_httpinspect.c:
    * src/preprocessors/HttpInspect/client/hi_client.c:
    * src/preprocessors/HttpInspect/session_inspection/hi_si.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/sfutil/sf_ip.c:
    * src/sfutil/sf_ip.h:
    * src/sfutil/sf_iph.c:
    * src/sfutil/sf_ipvar.c:
      Code cleanup for IPv6 related changes.
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Handle additional cases of multiple sequences of TCP SYN packets
      on a session that has previously been reset.
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Add checks for missing packets in reassembly.
    * src/sfutil/sfportobject.c:
    * src/sfutil/sfxhash.c:
      Code cleanup.
    * src/target-based/sf_attribute_table_parser.l:
    * src/target-based/sftarget_reader.c:
      Better handling for starting attribute reload thread
      and logging parsing errors.
    * src/fpcreate.c:  
    * src/fpdetect.c:  
	* src/detection-plugins/sp_asn1.c:
	* src/detection-plugins/sp_byte_check.c:
	* src/detection-plugins/sp_byte_jump.c:
	* src/detection-plugins/sp_clientserver.c:
	* src/detection-plugins/sp_cvs.c:
	* src/detection-plugins/sp_dsize_check.c:
	* src/detection-plugins/sp_flowbits.c:
	* src/detection-plugins/sp_ftpbounce.c:
	* src/detection-plugins/sp_icmp_code_check.c:
	* src/detection-plugins/sp_icmp_id_check.c:
	* src/detection-plugins/sp_icmp_seq_check.c:
	* src/detection-plugins/sp_icmp_type_check.c:
	* src/detection-plugins/sp_ip_fragbits.c:
	* src/detection-plugins/sp_ip_id_check.c:
	* src/detection-plugins/sp_ip_proto.c:
	* src/detection-plugins/sp_ip_same_check.c:
	* src/detection-plugins/sp_ip_tos_check.c:
	* src/detection-plugins/sp_ipoption_check.c:
	* src/detection-plugins/sp_isdataat.c:
	* src/detection-plugins/sp_pattern_match.c:
	* src/detection-plugins/sp_pcre.c:
	* src/detection-plugins/sp_react.c:
	* src/detection-plugins/sp_respond.c:
	* src/detection-plugins/sp_respond2.c:
	* src/detection-plugins/sp_rpc_check.c:
	* src/detection-plugins/sp_session.c:
	* src/detection-plugins/sp_tcp_ack_check.c:
	* src/detection-plugins/sp_tcp_flag_check.c:
	* src/detection-plugins/sp_tcp_seq_check.c:
	* src/detection-plugins/sp_tcp_win_check.c:
	* src/detection-plugins/sp_ttl_check.c:
	* src/detection-plugins/sp_urilen_check.c:
    * src/dynamic-plugins/sp_dynamic.c:
    * src/dynamic-plugins/sp_preprocopt.c:
    * src/parser.c:
    * src/snort.c:
    * src/snort.h:
      Added performance profiling stats for rule option evaluation.  Add
      limits to pcre matching that could affect performance.


2007-11-12 Todd Wease <twease@sourcefire.com>
    * src/byte_extract.c:
    * src/detection-plugins/sp_byte_check.c:
    * src/detection-plugins/sp_byte_jump.c:
      Allow byte_jump 'string' option to support variable-length
      numeric data.
    * src/cpuclock.h:
    * configure.in:
      Add support for rule and preprocessor profiling times for
      Sparc v9 processors.
    * src/decode.h:
    * src/decode.c:
    * doc/README.gre:
    * src/generators.h:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/snort.h:
    * src/util.c:
    * src/util.h:
    * configure.in:
      Update GRE decoder to support PPTP GRE v.1 header.  Add new
      GRE decoder alerts and README.  Integrate with IPv6 codebase.
    * src/decode.c:
    * src/decode.h:
    * src/dynamic-plugins/sf_engine/sf_snort_packet.h:
      Update decoder to work will all 3 versions of pflog files.
      Thanks to Ronaldo Maia for reporting this issue.
    * src/parser.c:
    * src/parser.h:
    * src/snort.c:
    * src/snort.h:
    * src/plugbase.c:
    * src/plugbase.h:
    * src/util.c:
    * src/util.h:
    * src/decode.c:
    * src/dynamic-preprocessors/dcerpc/spp_dcerpc.c:
    * src/dynamic-preprocessors/dns/spp_dns.c:
    * src/dynamic-preprocessors/ftptelnet/spp_ftptelnet.c:
    * src/dynamic-preprocessors/smtp/spp_smtp.c:
    * src/mempool.c:
    * src/preprocessors/perf.c:
    * src/preprocessors/perf-flow.c:
    * src/preprocessors/perf.h:
    * src/preprocessors/portscan.c:
    * src/preprocessors/portscan.h:
    * src/preprocessors/spp_flow.c:
    * src/preprocessors/spp_frag3.c:
    * src/preprocessors/spp_httpinspect.c:
    * src/preprocessors/spp_perfmonitor.c:
    * src/preprocessors/spp_sfportscan.c:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/spp_stream5.c:
    * src/preprocessors/Stream5/snort_stream5_icmp.c:
    * src/preprocessors/Stream5/snort_stream5_icmp.h:
    * src/preprocessors/Stream5/snort_stream5_session.c:
    * src/preprocessors/Stream5/snort_stream5_session.h:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.h:
    * src/preprocessors/Stream5/snort_stream5_udp.c:
    * src/preprocessors/Stream5/snort_stream5_udp.h:
    * src/profiler.c:
    * src/profiler.h:
    * src/sfthreshold.c:
    * src/sfthreshold.h:
    * src/sfutil/sfxhash.c:
    * src/sfutil/sfxhash.h:
    * src/tag.c:
    * src/tag.h:
      Snort can now read multiple pcaps on the command line.  The
      '-r' flag can be given multiple times, as well as options for
      reading a list of pcaps on the command line, a file containing
      pcaps to read and/or a directory to recurse through gathering
      pcaps.  Multiple filters can be used and an option to reset Snort
      to a post initialization state for each pcap read can be given.
    * src/detect.c:
    * src/fpcreate.c:
    * src/fpcreate.h:
    * src/parser.c:
    * src/parser.h:
    * src/sfutil/sfportobject.c:
    * src/sfutil/sfportobject.h:
    * src/sfutil/sfrim.h:
      Portlists code consolidation and general cleanup.
    * src/detect.c:
    * src/detection-plugins/sp_respond2.c:
    * src/detection-plugins/sp_respond.c:
    * src/dynamic-plugins/sf_dynamic_preprocessor.h:
    * src/dynamic-preprocessors/ftptelnet/ftpp_si.h:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_client_lookup.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_client_lookup.h:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_config.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_config.h:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_server_lookup.h:
    * src/dynamic-preprocessors/ftptelnet/pp_ftp.c:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
    * src/fpdetect.c:
    * src/ipv6_port.h:
    * src/output-plugins/spo_alert_sf_socket.c:
    * src/output-plugins/spo_log_ascii.c:
    * src/output-plugins/spo_unified2.c:
    * src/output-plugins/spo_unified.c:
    * src/preprocessors/HttpInspect/include/hi_si.h:
    * src/preprocessors/HttpInspect/include/hi_ui_config.h:
    * src/preprocessors/HttpInspect/include/hi_ui_server_lookup.h:
    * src/preprocessors/HttpInspect/user_interface/hi_ui_server_lookup.c:
    * src/preprocessors/portscan.c:
    * src/preprocessors/portscan.h:
    * src/preprocessors/snort_httpinspect.c:
    * src/preprocessors/snort_stream4_session.c:
    * src/preprocessors/spp_sfportscan.c:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/spp_stream5.c:
    * src/preprocessors/Stream5/snort_stream5_icmp.c:
    * src/preprocessors/Stream5/snort_stream5_icmp.h:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/preprocessors/Stream5/snort_stream5_udp.c:
    * src/preprocessors/Stream5/snort_stream5_udp.h:
    * src/preprocessors/Stream5/stream5_common.h:
    * src/preprocessors/stream_api.h:
    * src/preprocessors/stream.h:
    * src/preprocessors/stream_ignore.c:
    * src/preprocessors/stream_ignore.h:
    * src/sfthreshold.c:
    * src/sfthreshold.h:
    * src/sfutil/sf_ip.c:
    * src/sfutil/sf_ip.h:
    * src/sfutil/sf_ipvar.c:
    * src/sfutil/sfthd.c:
    * src/sfutil/sfthd.h:
    * src/tag.c:
      IPv6 data type name changes to avoid library namespace conflicts.
    * src/detection-plugins/sp_pattern_match.c:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
    * src/preprocessors/snort_stream4_udp.c:
    * src/rules.h:
    * src/sf_sdlist.c:
    * src/sf_types.h:
      Fix compiler warnings.
    * src/detection-plugins/sp_pcre.c:
    * src/fpdetect.c:
      Fixed issue where some rules will continue to match on a Uri, even
      after the first packet.
    * src/dynamic-plugins/Makefile.am:
    * src/dynamic-plugins/sf_dynamic_engine.h:
    * src/dynamic-plugins/sp_dynamic.c:
    * src/dynamic-plugins/sp_dynamic.h:
    * src/fpcreate.c:
      Enabled target-based code to properly assess dynamic rule flow.
    * src/dynamic-preprocessors/dcerpc/sf_dcerpc.dsp:
    * src/dynamic-preprocessors/dns/sf_dns.dsp:
    * src/dynamic-preprocessors/ftptelnet/sf_ftptelnet.dsp:
    * src/dynamic-preprocessors/sf_dynamic_initialize/sf_dynamic_initialize.dsp:
    * src/dynamic-preprocessors/smtp/sf_smtp.dsp:
    * src/dynamic-preprocessors/ssh/sf_ssh.dsp:
      Update Win32 project files to include target-based and GRE defines.
    * src/dynamic-preprocessors/ftptelnet/pp_ftp.c:
      Allow white space prior to FTP command.
    * src/preprocids.h:
    * doc/README.ssl:
    * doc/snort_manual.tex:
    * etc/snort.conf:
    * configure.in:
    * src/win32/WIN32-Prj/snort.dsw:
    * src/dynamic-preprocessors/ssl/Makefile.am:
    * src/dynamic-preprocessors/ssl/sf_preproc_info.h:
    * src/dynamic-preprocessors/ssl/sf_ssl.dsp:
    * src/dynamic-preprocessors/ssl/spp_ssl.c:
    * src/dynamic-preprocessors/ssl/spp_ssl.h:
    * src/win32/WIN32-Includes/config.h:
      Added SSL preprocessor.
    * src/ipv6_port.h:
      Update IP_CLEAR to clear all fields.  Update IP_COPY_VALUE to copy each
      field individually.
    * src/log.c:
    * src/output-plugins/spo_alert_fast.c:
    * src/output-plugins/spo_alert_full.c:
    * src/log_text.h:
    * src/output-plugins/spo_csv.c:
    * src/output-plugins/spo_database.c:
    * src/output-plugins/spo_log_tcpdump.c:
    * src/win32/WIN32-Prj/snort.dsp:
    * src/log_text.c:
    * src/log_text.h:
    * src/sfutil/sf_textlog.c:
    * src/sfutil/sf_textlog.h:
      Added rollover of logs upon reaching configured limit - applies to
      alert_full, alert_fast, log_tcpdump, alert_csv.
    * src/log.c:
      Added IP obfuscation for IPv6 addresses.
    * src/plugbase.c:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * doc/README.stream4:
    * doc/README.stream5:
    * doc/snort_manual.tex:
    * etc/snort.conf:
    * src/win32/WIN32-Prj/snort.dsp:
    * src/detection-plugins/sp_cvs.c:
    * src/detection-plugins/sp_cvs.h:
      CVS detection plugin.  Currently only looks for an invalid entry.  Ports
      514 and 2401 added to default ports for stream reassembly.
    * src/ppm.c:
    * src/ppm.h:
    * src/profiler.c:
    * doc/snort_manual.tex:
      Fix microseconds calculations. Add ability to use ppm with readback mode.
      Add documentation to Snort Manual.
    * src/preprocessors/HttpInspect/client/hi_client.c:
    * src/preprocessors/HttpInspect/event_output/hi_eo_log.c:
    * src/preprocessors/HttpInspect/include/hi_eo_events.h:
    * src/preprocessors/HttpInspect/include/hi_ui_config.h:
    * src/preprocessors/HttpInspect/user_interface/hi_ui_config.c:
    * src/preprocessors/snort_httpinspect.c:
    * doc/README.http_inspect:
    * doc/snort_manual.tex:
    * etc/gen-msg.map:
      Added overly long http header detection.
    * src/preprocessors/perf-base.c:
    * src/preprocessors/spp_perfmonitor.c:
    * src/snort.c:
    * src/snort.h:
    * src/util.c:
      Fixed issue where packets were being blocked when Snort, running in inline
      mode, was shutting down.
    * src/preprocessors/spp_frag3.c:
      Fixed issue where frag3 does not initialize correctly without any
      configuration arguments.  Thanks to Jason Carr for reporting this.
    * src/preprocessors/spp_sfportscan.c:
      Fix endian issue in sfportscan when IP addresses are logged.
      Thanks to Jerry Litteer for reporting this.
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/spp_stream5.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.h:
    * src/preprocessors/stream_api.h:
      Added function to stream api for returning whether or not there are
      missing segments.  Only supported in stream5.
    * src/preprocessors/str_search.c:
    * src/sfutil/mpse.c:
    * src/sfutil/mpse.h:
      Fixed issue where MPSE global counter was being reset by SMTP for each new
      pattern matcher it created.
    * src/sfutil/sf_vartable.c:
    * src/sfutil/sf_vartable.h:
    * doc/README.variables:
    * doc/snort_manual.tex:
      Fix segfault with duplicate variables in IPv6 code (enabled with
      --enable-ipv6).
    * src/target-based/Makefile.am:
    * src/target-based/sf_attribute_table_parser.l:
    * src/target-based/sftarget_reader.c:
      Target based cleanup.
    * src/util.c:
      Fixed incorrect calculation of pcap recevied and dropped.
    * src/win32/WIN32-Prj/sf_engine.dsp:
    * src/win32/WIN32-Prj/snort.dsp:
      Added GRE and target-based to default Win32 build.
    * doc/INSTALL:
    * doc/README.ftptelnet:
    * doc/README.http_inspect:
    * doc/README.sfportscan:
    * doc/README.stream4:
    * doc/README.stream5:
    * doc/README.variables:
    * doc/snort_manual.tex:
      Documentation updates. Thanks to Jeff Dell for pointing out
	  unified/unified2 errors in Snort Manual and inconsistencies in
	  sfportscan documentation.

2007-11-06 Steven Sturges <ssturges@sourcefire.com>
    * src/win32/WIN32-Includes/pcre.h:
    * src/win32/WIN32-Includes/pcreposix.h:
    * src/win32/WIN32-Libraries/pcre.lib:
      Update Win32 LibPCRE to version 7.4.

2007-11-05 Steven Sturges <ssturges@sourcefire.com>
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Fix debug to correctly call inet_ntoa.  Thanks to rmkml for reporting
      the problem.

2007-09-07 Steven Sturges <ssturges@sourcefire.com>
    * configure.in:
    * src/build.h:
    * src/win32/WIN32-Includes/config.h:
    * src/win32/WIN32-Prj/snort_installer.nsi:
    * rpm/snort.spec:
    * snort.8:
      2.8.0 Final release prep.  Update spec file to relocate installed
      schemas and be more consistent with location of docs.
    * src/parser.c:
      Initialize rule_count variables.  Thanks to Ken Steele for pointing
      it out.
    * src/signature.c:
    * src/detection-plugins/sp_urilen_check.c:
    * src/plugbase.c:
      Fix typos in comments.  Thanks rmkml for reviewing.
    * src/tag.c:
    * src/sfutil/sf_ip.c:
    * src/sfutil/sf_iph.c:
      Cleanup printing of IPv6 Addresses.
    * src/detection-plugins/sp_pcre.c:
      Initialize the found offset so that it contains correct value
      when not found.
    * src/dynamic-preprocessors/ftptelnet/pp_ftp.c:
      Improve checking on ftp commands from client.
    * src/dynamic-preprocessors/ftptelnet/spp_ftptelnet.c:
      Disable ftptelnet when compiled with IPv6.
    * src/decode.c:
    * src/snort.c:
      After logging alert for BSD IPv6 Fragmentation vulnerability,
      reset the pseudo packet that is used for logging purposes.
    * src/dynamic-preprocessors/smtp/snort_smtp.c:
      Memory cleanup of mime boundary regular expressions at Snort exit.
    * src/preprocessors/portscan.c:
    * src/preprocessors/portscan.h:
    * src/preprocessors/spp_sfportscan.c:
      Memory cleanup of portscan hash table at Snort exit.
    * src/output-plugins/spo_alert_prelude.c:
      Correctly get IP Header length for logging.
    * src/output-plugins/spo_alert_sf_socket.c:
      Complete initialization after rules are read for specific GID/SID
      alerts to log via sf socket.
    * src/output-plugins/spo_unified2.c:
      Code cleanup.
    * src/preprocessors/spp_frag3.c:
      Handle VLAN tags in fragmented traffic and include in rebuilt packets
      if part of original traffic.
    * src/preprocessors/spp_stream5.c:
      Initialize memory for flowbits after all configuration is processed,
      as config flowbitsize option might change default.  Handle byte
      alignment issue on Solaris with the flowbits data structure used
      by Stream5.  Thanks to JJC & Shane Castle for helping us troubleshoot
      these issues and testing the patches.
    * src/preprocessors/Stream5/snort_stream5_icmp.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/preprocessors/Stream5/snort_stream5_udp.c:
    * src/preprocessors/Stream5/stream5_common.c:
    * src/preprocessors/stream_api.h:
      Handle strange sequences of multiple TCP Reset packets on the same
      session when some of those Resets also contain other flags.  Thanks
      to Siim Poder for reporting the problem.

2007-08-31 Steven Sturges <ssturges@sourcefire.com>
    * src/parser.c:
      Updates to prevent variable defintions of the same name as a portvar,
      var and ipvar.
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
      Fix copying of IP address from packet when determining client config
      that resulted from IPv6 port.
    * src/output-plugins/spo_alert_prelude.c:
      Updates to write GID in alert data.  Thanks to Yoann Vandoorselaere
      for the update.
    * src/output-plugins/spo_unified2.c:
      Don't write tagged packets the same as unified.  Packets that are
      part of stream reassembly refer to the original event directly from
      the packet record header.
    * src/sfutil/sfportobject.c:
    * src/sfutil/sfportobject.h:
      Code cleanup and free data correctly on parsing errors.

2007-08-30 Steven Sturges <ssturges@sourcefire.com>
    * doc/Makefile.am:
      Include README.ipv6 & README.variables in the distribution tarball.
      Thanks to Jeff Dell for pointing out that it was missing.
    * RELEASE.NOTES:
      Fix some spelling errors.  Thanks rmkml for pointing it out.
    * etc/snort.conf:
      Update to use new portvar syntax for HTTP_PORTS, ORACLE_PORTS,
      and SHELLCODE_PORTS.  Thanks to rmkml for mentioning this.

2007-08-22 Steven Sturges <ssturges@sourcefire.com>
    * configure.in:
    * src/sf_types.h:
    * src/dynamic-preprocessors/smtp/snort_smtp.c:
      Fixes to build 2.8.0 Beta on OpenBSD.
    * doc/README.variables:
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
      Update PortList documentation.

2007-08-20 Steven Sturges <ssturges@sourcefire.com>
    * configure.in:
    * src/build.h:
    * src/win32/WIN32-Includes/config.h:
    * src/win32/WIN32-Prj/snort_installer.nsi:
    * rpm/snort.spec:
      2.8.0 Beta prep.
    * src/Makefile.am:
    * src/dynamic-preprocessors/Makefile.am:
    * src/dynamic-preprocessors/smtp/smtp_xlink2state.c:
    * src/event.h:
    * src/output-plugins/spo_log_tcpdump.c:
    * src/output-plugins/spo_unified.c:
    * src/output-plugins/spo_unified2.c:
    * src/pcap_pkthdr32.h (added):
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/preprocessors/flow/portscan/flowps_snort.c:
    * src/preprocessors/spp_frag3.c:
    * src/preprocessors/spp_sfportscan.c:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/stream.h:
    * src/preprocessors/stream_api.h:
    * src/snort_packet_header.h (removed):
    * src/win32/WIN32-Prj/snort.dsp:
    * src/snort.c:
      Renamed snort_packet_header.h to pcap_pkthdr32.h and changed instances of
      SnortPktHdr with pcap_pkthdr except in Event struct and unified code where
      pcap_pkthdr32 is used because 32 bit timevals are required.
    * src/dynamic-plugins/sf_dynamic_plugins.c:
    * src/dynamic-plugins/sf_dynamic_preprocessor.h:
    * src/dynamic-plugins/sf_preproc_example/sf_dynamic_preproc_lib.c:
    * src/plugbase.c:
    * src/plugbase.h:
    * src/util.c:
    * src/preprocessors/snort_httpinspect.c:
    * src/preprocessors/spp_flow.c:
    * src/preprocessors/spp_frag3.c:
    * src/preprocessors/spp_httpinspect.c:
    * src/preprocessors/spp_httpinspect.h:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/spp_stream5.c:
    * src/snort.c:
      Added framework for preprocessors to print stats at exit or USR1 signal.
      Preprocessors register a function that will print the stats and they will
      be printed when DropStats() is called.
    * src/detection-plugins/sp_pattern_match.c:
      Commented out 'content-list' rule option code since it is
      broken and there are no plans in the near future to fix it.
    * src/checksum.h:
    * src/decode.c:
    * src/decode.h:
    * src/detect.c:
    * src/detect.h:
    * src/detection-plugins/sp_icmp_id_check.c:
    * src/detection-plugins/sp_icmp_seq_check.c:
    * src/detection-plugins/sp_icmp_type_check.c:
    * src/detection-plugins/sp_ip_fragbits.c:
    * src/detection-plugins/sp_ip_id_check.c:
    * src/detection-plugins/sp_ip_proto.c:
    * src/detection-plugins/sp_ip_same_check.c:
    * src/detection-plugins/sp_ip_tos_check.c:
    * src/detection-plugins/sp_pattern_match.c:
    * src/detection-plugins/sp_respond.c:
    * src/detection-plugins/sp_respond2.c:
    * src/detection-plugins/sp_session.c:
    * src/detection-plugins/sp_ttl_check.c:
    * src/dynamic-plugins/sf_dynamic_plugins.c:
    * src/dynamic-plugins/sf_dynamic_preprocessor.h:
    * src/dynamic-plugins/sf_engine/Makefile.am:
    * src/dynamic-plugins/sf_engine/sf_snort_packet.h:
    * src/dynamic-preprocessors/dynamic_preprocessors.dsp:
    * src/dynamic-preprocessors/Makefile.am:
    * src/dynamic-preprocessors/sf_dynamic_initialize/sf_dynamic_initialize.dsp:
    * src/dynamic-preprocessors/Makefile.am:
    * src/dynamic-preprocessors/dcerpc/sf_dcerpc.dsp:
    * src/dynamic-preprocessors/dns/sf_dns.dsp:
    * src/dynamic-preprocessors/ftptelnet/sf_ftptelnet.dsp:
    * src/dynamic-preprocessors/ftptelnet/Makefile.am:
    * src/dynamic-preprocessors/smtp/sf_smtp.dsp:
    * src/dynamic-preprocessors/ssh/sf_ssh.dsp:
    * src/dynamic-preprocessors/ftptelnet/ftpp_include.h:
    * src/dynamic-preprocessors/ftptelnet/ftpp_si.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_si.h:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_client_lookup.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_client_lookup.h:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_config.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_config.h:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_server_lookup.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_server_lookup.h:
    * src/dynamic-preprocessors/ftptelnet/pp_ftp.c:
    * src/dynamic-preprocessors/ftptelnet/pp_telnet.c:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
    * src/dynamic-preprocessors/ftptelnet/spp_ftptelnet.c:
    * src/fpdetect.c:
    * src/fpdetect.h:
    * src/generators.h:
    * src/ipv6.c (removed):
    * src/ipv6.h (removed):
    * src/ipv6_port.h (added):
    * src/log.c:
    * src/Makefile.am:
    * src/output-plugins/spo_alert_arubaaction.c:
    * src/output-plugins/spo_alert_fast.c:
    * src/output-plugins/spo_alert_full.c:
    * src/output-plugins/spo_alert_prelude.c:
    * src/output-plugins/spo_alert_sf_socket.c:
    * src/output-plugins/spo_alert_syslog.c:
    * src/output-plugins/spo_alert_unixsock.c:
    * src/output-plugins/spo_csv.c:
    * src/output-plugins/spo_database.c:
    * src/output-plugins/spo_log_ascii.c:
    * src/output-plugins/spo_log_tcpdump.c:
    * src/output-plugins/spo_unified.c:
    * src/output-plugins/spo_unified2.c:
    * src/parser/IpAddrSet.c:
    * src/parser/IpAddrSet.h:
    * src/parser.c:
    * src/parser.h:
    * src/plugbase.c:
    * src/preprocessors/flow/portscan/flowps_snort.c:
    * src/preprocessors/HttpInspect/include/hi_include.h:
    * src/preprocessors/HttpInspect/include/hi_si.h:
    * src/preprocessors/HttpInspect/include/hi_ui_config.h:
    * src/preprocessors/HttpInspect/include/hi_ui_server_lookup.h:
    * src/preprocessors/HttpInspect/session_inspection/hi_si.c:
    * src/preprocessors/HttpInspect/user_interface/hi_ui_config.c:
    * src/preprocessors/HttpInspect/user_interface/hi_ui_server_lookup.c:
    * src/preprocessors/portscan.c:
    * src/preprocessors/portscan.h:
    * src/preprocessors/snort_httpinspect.c:
    * src/preprocessors/snort_stream4_session.c:
    * src/preprocessors/snort_stream4_udp.c:
    * src/preprocessors/spp_frag3.c:
    * src/preprocessors/spp_httpinspect.c:
    * src/preprocessors/spp_sfportscan.c:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/spp_stream5.c:
    * src/preprocessors/Stream5/snort_stream5_icmp.c:
    * src/preprocessors/Stream5/snort_stream5_icmp.h:
    * src/preprocessors/Stream5/snort_stream5_session.c:
    * src/preprocessors/Stream5/snort_stream5_session.h:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.h:
    * src/preprocessors/Stream5/snort_stream5_udp.c:
    * src/preprocessors/Stream5/snort_stream5_udp.h:
    * src/preprocessors/Stream5/stream5_common.h:
    * src/preprocessors/stream_api.h:
    * src/preprocessors/stream.h:
    * src/preprocessors/stream_ignore.c:
    * src/preprocessors/stream_ignore.h:
    * src/rules.h:
    * src/sfthreshold.c:
    * src/sfthreshold.h:
    * src/sfutil/ipobj.c:
    * src/sfutil/Makefile.am:
    * src/sfutil/sf_ip.c (added):
    * src/sfutil/sf_ip.h (added):
    * src/sfutil/sf_iph.c (added):
    * src/sfutil/sf_iph.h (added):
    * src/sfutil/sf_ipvar.c (added):
    * src/sfutil/sf_ipvar.h (added):
    * src/sfutil/sfthd.c:
    * src/sfutil/sfthd.h:
    * src/sfutil/sf_vartable.c (added):
    * src/sfutil/sf_vartable.h (added):
    * src/snort.c:
    * src/snort.h:
    * src/tag.c:
    * src/util.c:
    * src/win32/WIN32-Prj/build_all.dsp:
    * src/win32/WIN32-Prj/sf_engine.dsp:
    * src/win32/WIN32-Prj/snort.dsp:
    * src/win32/WIN32-Prj/snort.dsw:
    * src/win32/WIN32-Prj/snort_installer.nsi:
    * doc/README.ipv6:
      Added 1st phase of support for IPv6.  Added support for ip variables
      and improved IP address list handling.  See README.ipv6 for specifics
      on what portions of Snort fully support IPv6.  Certain preprocessors
      are not supported -- and cannot be turned on with an IPv6 enabled
      snort.
    * src/output-plugins/spo_unified.c:
      Added configuration option to not append timestamps to unified log/alert
      files.
    * src/output-plugins/spo_unified2.c (added):
    * src/output-plugins/spo_unified2.h (added):
    * src/plugbase.c:
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
      Added unified2 logging/output format.
    * src/cpuclock.h (added):
    * src/detect.c:
    * src/fpdetect.c:
    * src/fpdetect.h:
    * src/Makefile.am:
    * src/parser.c:
    * src/ppm.c (added):
    * src/ppm.h (added):
    * src/profiler.h:
    * src/rules.h:
    * src/snort.c:
      Added support for packet performance monitoring.  Allows Snort to be
      configured to only spend a certain time period on a given packet
      and/or rule and automatically suspend performance-intensive rules.
      See README.ppm for details.
    * src/bounds.h:
    * src/byte_extract.c:
    * src/byte_extract.h:
    * src/debug.c:
    * src/debug.h:
    * src/decode.c:
    * src/decode.h:
    * src/detection-plugins/sp_asn1.c:
    * src/detection-plugins/sp_asn1_detect.c:
    * src/detection-plugins/sp_asn1_detect.h:
    * src/detection-plugins/sp_byte_check.c:
    * src/detection-plugins/sp_byte_jump.c:
    * src/detection-plugins/sp_clientserver.c:
    * src/detection-plugins/sp_flowbits.c:
    * src/detection-plugins/sp_isdataat.c:
    * src/detection-plugins/sp_pattern_match.c:
    * src/detection-plugins/sp_pattern_match.h:
    * src/detection-plugins/sp_pcre.c:
    * src/detection-plugins/sp_react.c:
    * src/detection-plugins/sp_respond.c:
    * src/detection-plugins/sp_respond2.c:
    * src/detection-plugins/sp_session.c:
    * src/dynamic-plugins/sf_dynamic_engine.h:
    * src/dynamic-plugins/sf_dynamic_preprocessor.h:
    * src/dynamic-plugins/sf_engine/bmh.c:
    * src/dynamic-plugins/sf_engine/bmh.h:
    * src/dynamic-plugins/sf_engine/sf_snort_detection_engine.c:
    * src/dynamic-plugins/sf_engine/sf_snort_packet.h:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.h:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_byte.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_content.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_loop.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_pcre.c:
    * src/dynamic-plugins/sf_preproc_example/sf_dynamic_preproc_lib.c:
    * src/dynamic-plugins/sp_dynamic.c:
    * src/dynamic-plugins/sp_dynamic.h:
    * src/dynamic-plugins/sp_preprocopt.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc.h:
    * src/dynamic-preprocessors/dcerpc/dcerpc_util.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc_util.h:
    * src/dynamic-preprocessors/dcerpc/smb_andx_decode.c:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/spp_dcerpc.c:
    * src/dynamic-preprocessors/dns/spp_dns.c:
    * src/dynamic-preprocessors/ftptelnet/ftp_client.h:
    * src/dynamic-preprocessors/ftptelnet/ftp_cmd_lookup.c:
    * src/dynamic-preprocessors/ftptelnet/ftp_cmd_lookup.h:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_config.h:
    * src/dynamic-preprocessors/ftptelnet/pp_ftp.c:
    * src/dynamic-preprocessors/ftptelnet/pp_telnet.c:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.h:
    * src/dynamic-preprocessors/ftptelnet/spp_ftptelnet.c:
    * src/dynamic-preprocessors/ssh/spp_ssh.c:
    * src/log.c:
    * src/log.h:
    * src/mstring.c:
    * src/mstring.h:
    * src/preprocessors/HttpInspect/anomaly_detection/hi_ad.c:
    * src/preprocessors/HttpInspect/client/hi_client.c:
    * src/preprocessors/HttpInspect/client/hi_client_norm.c:
    * src/preprocessors/HttpInspect/include/hi_ad.h:
    * src/preprocessors/HttpInspect/include/hi_client.h:
    * src/preprocessors/HttpInspect/include/hi_include.h:
    * src/preprocessors/HttpInspect/include/hi_mi.h:
    * src/preprocessors/HttpInspect/include/hi_norm.h:
    * src/preprocessors/HttpInspect/include/hi_server.h:
    * src/preprocessors/HttpInspect/include/hi_util.h:
    * src/preprocessors/HttpInspect/mode_inspection/hi_mi.c:
    * src/preprocessors/HttpInspect/normalization/hi_norm.c:
    * src/preprocessors/HttpInspect/server/hi_server.c:
    * src/preprocessors/perf.c:
    * src/preprocessors/perf-flow.c:
    * src/preprocessors/perf-flow.h:
    * src/preprocessors/perf.h:
    * src/preprocessors/portscan.c:
    * src/preprocessors/spp_arpspoof.c:
    * src/preprocessors/spp_bo.c:
    * src/preprocessors/spp_flow.c:
    * src/preprocessors/spp_frag3.c:
    * src/preprocessors/spp_perfmonitor.c:
    * src/preprocessors/spp_rpc_decode.c:
    * src/preprocessors/spp_sfportscan.c:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/spp_stream5.c:
    * src/preprocessors/Stream5/snort_stream5_icmp.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/preprocessors/Stream5/snort_stream5_udp.c:
    * src/preprocessors/str_search.c:
    * src/preprocessors/str_search.h:
    * src/sfutil/asn1.c:
    * src/sfutil/asn1.h:
    * src/sfutil/bitop_funcs.h:
    * src/sfutil/mpse.c:
    * src/sfutil/mpse.h:
    * src/snort.c:
      Changed packet payload pointers to use const qualifier to
      eliminate inadvertant writes to the packet buffer.
    * src/preprocessors/HttpInspect/include/hi_util_kmap.h:
    * src/preprocessors/HttpInspect/include/hi_util_xmalloc.h:
    * src/preprocessors/HttpInspect/util/hi_util_kmap.c:
    * src/preprocessors/spp_httpinspect.c:
    * src/dynamic-preprocessors/ftptelnet/hi_util_kmap.h:
    * src/dynamic-preprocessors/ftptelnet/hi_util_xmalloc.h:
    * src/dynamic-preprocessors/ftptelnet/hi_util_kmap.c:
      Cleanup memory at Snort exit from session & client configurations.
    * src/debug.h:
    * src/preprocids.h:
    * src/generators.h:
      Added defines for SKYPE.
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_rc4.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_content.c:
      Fixed a few typos in comments. Thanks to rmkml for pointing them out.
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
      Cleaned up a few typos in various sections.  Thanks to rmkml, Joel
      Ebrahimi for pointing out the misspellings & errors.
    * src/decode.h:
    * src/detect.c:
    * src/fpcreate.c:
    * src/fpcreate.h:
    * src/fpdetect.c:
    * src/fpdetect.h:
    * src/parser.c:
    * src/preprocessors/perf-base.c:
    * src/preprocessors/perf-base.h:
    * src/preprocessors/spp_frag3.c:
    * src/preprocessors/spp_frag3.h:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/spp_stream5.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.h:
    * src/preprocessors/Stream5/snort_stream5_udp.c:
    * src/preprocessors/Stream5/snort_stream5_udp.h:
    * src/preprocessors/Stream5/stream5_common.c:
    * src/preprocessors/Stream5/stream5_common.h:
    * src/preprocessors/stream_api.h:
    * src/rules.h:
    * src/sfutil/Makefile.am:
    * src/sfutil/sfrt.c (added):
    * src/sfutil/sfrt.h (added):
    * src/sfutil/sfrt_dir.c (added):
    * src/sfutil/sfrt_dir.h (added):
    * src/sfutil/sfrt_trie.h (added):
    * src/signature.c:
    * src/signature.h:
    * src/snort.c:
    * src/snort.h:
    * src/target-based/Makefile.am (added):
    * src/target-based/sf_attribute_table_parser.l (added):
    * src/target-based/sf_attribute_table.y (added):
    * src/target-based/sftarget_hostentry.c (added):
    * src/target-based/sftarget_hostentry.h (added):
    * src/target-based/sftarget_protocol_reference.c (added):
    * src/target-based/sftarget_protocol_reference.h (added):
    * src/target-based/sftarget_reader.c (added):
    * src/target-based/sftarget_reader.h (added):
    * src/util.c:
      Added experimental support for Target-Based processing for Stream
      reassembly, IP Frag reassembly, and rule processing.  Enable via
      --enable-targetbased option to configure.  A thread is created to
      reload the attribute table upon receipt of a signal 30.
    * src/detect.c:
    * src/detect.h:
    * src/detection-plugins/sp_clientserver.c:
    * src/detection-plugins/sp_clientserver.h:
    * src/fpcreate.c:
    * src/fpcreate.h:
    * src/fpdetect.c:
    * src/fpdetect.h:
    * src/parser.c:
    * src/parser.h:
    * src/pcrm.c:
    * src/pcrm.h:
    * src/preprocessors/Stream5/snort_stream5_udp.c:
    * src/rules.h:
    * src/sfutil/sfportobject.c (added):
    * src/sfutil/sfportobject.h (added):
    * src/sfutil/sfrim.c (added):
    * src/sfutil/sfrim.h (added):
    * src/signature.c:
    * src/signature.h:
    * src/snort.c:
    * src/util.c:
      Added Port Lists & Port Range functionality and added port variable
      handling.  
    * preproc_rules/preprocessor.rules:
    * preproc_rules/decoder.rules:
    * preproc_rules/Makefile.am:
    * configure.in:
    * etc/snort.conf:
    * src/detection-plugins/sp_asn1.c:
    * src/detection-plugins/sp_byte_check.c:
    * src/detection-plugins/sp_byte_jump.c:
    * src/detection-plugins/sp_dsize_check.c:
    * src/detection-plugins/sp_flowbits.c:
    * src/detection-plugins/sp_icmp_code_check.c:
    * src/detection-plugins/sp_icmp_id_check.c:
    * src/detection-plugins/sp_icmp_seq_check.c:
    * src/detection-plugins/sp_icmp_type_check.c:
    * src/detection-plugins/sp_ip_fragbits.c:
    * src/detection-plugins/sp_ip_id_check.c:
    * src/detection-plugins/sp_ip_optioncheck.c:
    * src/detection-plugins/sp_ip_proto.c:
    * src/detection-plugins/sp_ip_same_check.c:
    * src/detection-plugins/sp_ip_tos_check.c:
    * src/detection-plugins/sp_isdataat.c:
    * src/detection-plugins/sp_pattern_match.c:
    * src/detection-plugins/sp_pcre.c:
    * src/detection-plugins/sp_react.c:
    * src/detection-plugins/sp_respond.c:
    * src/detection-plugins/sp_respond2.c:
    * src/detection-plugins/sp_rpc_check.c:
    * src/detection-plugins/sp_session.c:
    * src/detection-plugins/sp_tcp_ack_check.c:
    * src/detection-plugins/sp_tcp_flag_check.c:
    * src/detection-plugins/sp_tcp_seq_check.c:
    * src/detection-plugins/sp_tcp_win_check.c:
    * src/detection-plugins/sp_ttl_check.c:
    * src/detection-plugins/sp_urilen_check.c:
    * src/dynamic-plugins/sp_dynamic.c:
    * src/event_queue.c:
    * src/event_wrapper.c:
    * src/event_wrapper.h:
    * src/parser.c:
    * src/plugbase.c:
    * src/plugbase.h:
      Added support to provide action control (alert, drop, pass, etc)
      over preprocessor and decoder generated events, as well as references
      and classifications via a rule.  These rules do not include IP
      addresses as the individual preprocessor/decoder configuration
      dictates the traffic to which an event applies.  In conjunction
      with this, certain post-processing rule options (tag, logto, etc)
      may be added to those rules, while other options that relate to data
      inspection (content, byte_test, etc) may not.  Enable via 
      --enable-decoder-preprocessor-rules option to configure.
    * src/dynamic-plugins/sf_dynamic_plugins.c:
      Search for other shared library extensions on OpenBSD.  Thanks to
      Nikns Siankin for the request.
    * src/dynamic-plugins/sf_engine/Makefile.am:
    * src/dynamic-preprocessors/dcerpc/Makefile.am:
    * src/dynamic-preprocessors/dns/Makefile.am:
    * src/dynamic-preprocessors/ftptelnet/Makefile.am:
    * src/dynamic-preprocessors/smtp/Makefile.am:
    * src/dynamic-preprocessors/ssh/Makefile.am:
      Fixes to correct shared library extension on MAC OS.
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.h:
    * src/preprocessors/Stream5/stream5_common.h:
    * src/generators.h:
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
      Added basic TCP session hijacking detection.  Detection based on MAC
      address used during TCP 3-way handshake and MAC address in subsequent
      packets.
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * doc/README.stream5:
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
      Added stream_size rule option (only supported by Stream5).
    * src/dynamic-preprocessors/ftptelnet/pp_ftp.c:
    * src/generators.h:
      Improved detection for encrypted ftp sessions, reducing false positives.
      Added detection of subnegotiation begin commands without matching
      subnegotiation end (evasion attempt).
    * src/dynamic-preprocessors/smtp/smtp_config.c:
    * src/dynamic-preprocessors/smtp/smtp_config.h:
    * src/dynamic-preprocessors/smtp/smtp_log.c:
    * src/dynamic-preprocessors/smtp/smtp_log.h:
    * src/dynamic-preprocessors/smtp/smtp_normalize.c:
    * src/dynamic-preprocessors/smtp/smtp_normalize.h:
    * src/dynamic-preprocessors/smtp/smtp_util.c:
    * src/dynamic-preprocessors/smtp/smtp_util.h:
    * src/dynamic-preprocessors/smtp/smtp_xlink2state.c:
    * src/dynamic-preprocessors/smtp/smtp_xlink2state.h:
    * src/dynamic-preprocessors/smtp/snort_smtp.c:
    * src/dynamic-preprocessors/smtp/snort_smtp.h:
    * src/dynamic-preprocessors/smtp/spp_smtp.c:
    * src/dynamic-preprocessors/smtp/spp_smtp.h:
    * doc/README.SMTP:
    * etc/snort.conf:
    * src/generators.h:
      Rework much of preprocessor to improve searches, additional
      vulnerability checks.  Updates include changes to handle case
      insensitive searches.  Alert on header name length (Exim exploit) and
      check for valid mime headers.  Add port 587 (see RFC 2476) to
      default ports.  Improved normalization to separate commands and data.
      Updates to config parsing and console startup output.
    * src/parser.c:
      Handle duplicate rules by using the newer revision or the earlier
      appearing rule (if same revision).
    * src/sf_types.h (added):
    * src/preprocessors/flow/flow_cache.c:
    * src/preprocessors/flow/flow_cache.h:
    * src/preprocessors/flow/portscan/flowps.c:
    * src/preprocessors/flow/portscan/flowps_snort.c:
    * src/preprocessors/flow/portscan/scoreboard.c:
    * src/preprocessors/flow/portscan/server_stats.c:
    * src/preprocessors/flow/portscan/unique_tracker.c:
    * src/preprocessors/perf-base.c:
    * src/preprocessors/perf.c:
    * src/preprocessors/perf-event.c:
    * src/preprocessors/perf-event.h:
    * src/profiler.c:
    * src/sfutil/util_math.c:
    * src/sfutil/util_math.h:
    * src/snort.h:
    * src/snprintf.h:
    * src/util.c:
    * src/util.h:
    * src/win32/WIN32-Includes/stdint.h:
    * src/win32/WIN32-Includes/WinPCAP/time_calls.h:
      Updated logging to print 64bit values on various platforms in a more
      portable manner.
    * configure.in:
    * src/decode.c:
    * src/preprocessors/perf-base.c:
    * src/preprocessors/spp_perfmonitor.c:
    * src/snort.c:
    * src/snort.h:
    * src/util.c:
    * src/util.h:
    * src/win32/WIN32-Includes/config.h:
      Fixed issue with various versions of pcap reporting received &
      dropped stats differently.  Pcap versions 0.9 & higher accumulate
      stats, whereas earlier versions do not.
    * src/sfutil/acsmx2.c:
    * src/sfutil/acsmx2.h:
    * src/sfutil/acsmx.c:
    * src/sfutil/acsmx.h:
    * src/sfutil/bnfa_search.c:
    * src/sfutil/bnfa_search.h:
    * src/sfutil/sfghash.c:
    * src/sfutil/sfhashfcn.c:
    * src/sfutil/sfhashfcn.h:
    * src/sfutil/sfprimetable.c (added):
    * src/sfutil/sfprimetable.h (added):
    * src/sfutil/sfksearch.c:
    * src/sfutil/sfksearch.h:
    * src/sfutil/sfxhash.c:
    * src/sfutil/sfxhash.h:
      Improve performance of pattern match engines to not evaluate a rule
      with a pattern that has already been seen and the rule already
      processed.  This changes takes into account if that rule fails because of
      an unset flowbit (which may have been set by another rule).  Changed hash
      table hash functions to use power of two computations instead of prime
      numbers.
    * src/util.c:
      Added PCRE library version information to Snort startup banner.

2007-07-27 Steven Sturges <ssturges@sourcefire.com>
    * etc/snort.conf:
      Turn off flow since Stream5 is now enabled by default.
    * src/snort.c:
      Fix printing of threshold counts until after all rules are read.
      This issue did not affect thresholding, only display of thresholding.
      Thanks to Jeffrey Denton for reporting the problem.
    * src/sfutil/ipobj.c:
      Fix free of invalid pointer when using a negated IP list.
      This is used by sfportscan preprocessor configuration parsing.
      Thanks to Anders Ostrem for reporting the problem.
    * src/preprocessors/Stream5/snort_stream5_session.c:
      Fixed issue when experimental ICMP tracking is used without using
      the TCP or UDP session tracking.  ICMP was attempting to lookup 
      TCP or UDP sessions from uninitialized session cache.  Thanks to
      Koji Shikata for reporting the problem.
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Fixed invalid session pointer when rule tries to use flowbits after
      session ends.  Thanks to rmkml for initially reporting the problem.

2007-07-06 Steven Sturges <ssturges@sourcefire.com>
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Fixed potential invalid memory access when require 3whs option is used.

2007-06-28 Steven Sturges <ssturges@sourcefire.com>
    * src/sfutil/acsmx2.c:
    * src/sfutil/bnfa_search.c:
      Revert previous changes as they resulted in some false negatives
      with mixed case patterns and rules.  Will address in a future release.
    * src/detection-plugins/sp_react.c:
      Fixed problem with segfault with flexresp.  Thanks to Keith Pachulski
      for reporting the issue.

2007-06-20 Steven Sturges <ssturges@sourcefire.com>
    * src/sfutil/acsmx2.c:
    * src/sfutil/acsmx.h:
    * src/sfutil/bnfa_search.c:
      Performance improvement to track the last state of a pattern that
      match, so if it hits that state again immediately, don't go
      re-evaluate all of the same rules.
    * src/decode.c:
    * src/detect.c:
    * src/snort.h:
    * src/util.c:
      Properly handle UDP checksum if checksum value is 0 in header (do not
      calculate).  Add stat that tracks number of failed checksums.
    * src/detection-plugins/sp_pcre.c:
      Add /P flag to PCRE detection to check HTTP inspect's normalized
      client request body.
    * src/dynamic-preprocessors/Makefile.am:
    * src/dynamic-examples/Makefile.am:
      Fix header file replication.
    * src/output-plugins/spo_alert_prelude.c:
      Update to write data at Snort exit.  Thanks Yoann Vandoorselaere for
      the patch.
    * src/parser.c:
      Update to max line length.  Mark 'stateless' option to be deprecated,
      use flow:stateless.

2007-06-19 Steven Sturges <ssturges@sourcefire.com>
    * src/byte_extract.h:
    * src/event_queue.h:
    * src/event_wrapper.h:
    * src/inline.h:
    * src/ipv6.c:
    * src/ipv6.h:
    * src/packet_time.h:
    * src/plugin_enum.h:
    * src/preprocids.h:
    * src/sfthreshold.h:
    * src/snort_packet_header.h:
    * src/detection-plugins/sp_asn1.h:
    * src/detection-plugins/sp_asn1_detect.h:
    * src/detection-plugins/sp_flowbits.h:
    * src/detection-plugins/sp_ip_proto.c:
    * src/dynamic-examples/Makefile.am:
    * src/dynamic-examples/dynamic-preprocessor/sf_preproc_info.h:
    * src/dynamic-examples/dynamic-preprocessor/spp_example.c:
    * src/dynamic-examples/dynamic-rule/detection_lib_meta.h:
    * src/dynamic-examples/dynamic-rule/rules.c:
    * src/dynamic-examples/dynamic-rule/sid109.c:
    * src/dynamic-examples/dynamic-rule/sid637.c:
    * src/dynamic-preprocessors/ftptelnet/hi_util_kmap.c:
    * src/dynamic-preprocessors/ftptelnet/hi_util_kmap.h:
    * src/dynamic-preprocessors/ftptelnet/hi_util_xmalloc.c:
    * src/dynamic-preprocessors/ftptelnet/sf_preproc_info.h:
    * src/dynamic-preprocessors/smtp/sf_preproc_info.h:
    * src/preprocessors/portscan.c:
    * src/preprocessors/portscan.h:
    * src/preprocessors/snort_httpinspect.c:
    * src/preprocessors/snort_httpinspect.h:
    * src/preprocessors/snort_stream4_session.h:
    * src/preprocessors/snort_stream4_udp.h:
    * src/preprocessors/spp_flow.h:
    * src/preprocessors/spp_httpinspect.c:
    * src/preprocessors/spp_httpinspect.h:
    * src/preprocessors/spp_sfportscan.c:
    * src/preprocessors/spp_sfportscan.h:
    * src/preprocessors/spp_stream5.c:
    * src/preprocessors/str_search.c:
    * src/preprocessors/str_search.h:
    * src/preprocessors/stream.h:
    * src/preprocessors/HttpInspect/anomaly_detection/hi_ad.c:
    * src/preprocessors/HttpInspect/client/hi_client.c:
    * src/preprocessors/HttpInspect/client/hi_client_norm.c:
    * src/preprocessors/HttpInspect/event_output/hi_eo_log.c:
    * src/preprocessors/HttpInspect/include/hi_ad.h:
    * src/preprocessors/HttpInspect/include/hi_client.h:
    * src/preprocessors/HttpInspect/include/hi_client_norm.h:
    * src/preprocessors/HttpInspect/include/hi_eo.h:
    * src/preprocessors/HttpInspect/include/hi_eo_events.h:
    * src/preprocessors/HttpInspect/include/hi_eo_log.h:
    * src/preprocessors/HttpInspect/include/hi_include.h:
    * src/preprocessors/HttpInspect/include/hi_mi.h:
    * src/preprocessors/HttpInspect/include/hi_norm.h:
    * src/preprocessors/HttpInspect/include/hi_return_codes.h:
    * src/preprocessors/HttpInspect/include/hi_server.h:
    * src/preprocessors/HttpInspect/include/hi_si.h:
    * src/preprocessors/HttpInspect/include/hi_ui_config.h:
    * src/preprocessors/HttpInspect/include/hi_ui_iis_unicode_map.h:
    * src/preprocessors/HttpInspect/include/hi_ui_server_lookup.h:
    * src/preprocessors/HttpInspect/include/hi_util.h:
    * src/preprocessors/HttpInspect/include/hi_util_hbm.h:
    * src/preprocessors/HttpInspect/include/hi_util_kmap.h:
    * src/preprocessors/HttpInspect/include/hi_util_xmalloc.h:
    * src/preprocessors/HttpInspect/mode_inspection/hi_mi.c:
    * src/preprocessors/HttpInspect/normalization/hi_norm.c:
    * src/preprocessors/HttpInspect/server/hi_server.c:
    * src/preprocessors/HttpInspect/session_inspection/hi_si.c:
    * src/preprocessors/HttpInspect/user_interface/hi_ui_config.c:
    * src/preprocessors/HttpInspect/user_interface/hi_ui_iis_unicode_map.c:
    * src/preprocessors/HttpInspect/user_interface/hi_ui_server_lookup.c:
    * src/preprocessors/HttpInspect/utils/hi_util_hbm.c:
    * src/preprocessors/HttpInspect/utils/hi_util_kmap.c:
    * src/preprocessors/HttpInspect/utils/hi_util_xmalloc.c:
    * src/preprocessors/Stream5/snort_stream5_icmp.c:
    * src/preprocessors/Stream5/snort_stream5_icmp.h:
    * src/preprocessors/Stream5/snort_stream5_session.h:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.h:
    * src/preprocessors/Stream5/snort_stream5_udp.c:
    * src/preprocessors/Stream5/snort_stream5_udp.h:
    * src/preprocessors/Stream5/stream5_common.c:
    * src/preprocessors/Stream5/stream5_common.h:
    * src/preprocessors/flow/common_defs.h:
    * src/preprocessors/flow/flow.c:
    * src/preprocessors/flow/flow.h:
    * src/preprocessors/flow/flow_cache.c:
    * src/preprocessors/flow/flow_cache.h:
    * src/preprocessors/flow/flow_callback.c:
    * src/preprocessors/flow/flow_callback.h:
    * src/preprocessors/flow/flow_class.c:
    * src/preprocessors/flow/flow_class.h:
    * src/preprocessors/flow/flow_config.h:
    * src/preprocessors/flow/flow_error.h:
    * src/preprocessors/flow/flow_hash.c:
    * src/preprocessors/flow/flow_hash.h:
    * src/preprocessors/flow/flow_print.c:
    * src/preprocessors/flow/flow_print.h:
    * src/preprocessors/flow/flow_stat.c:
    * src/preprocessors/flow/flow_stat.h:
    * src/preprocessors/flow/int-snort/flow_packet.c:
    * src/preprocessors/flow/int-snort/flow_packet.h:
    * src/preprocessors/flow/portscan/flowps.c:
    * src/preprocessors/flow/portscan/flowps.h:
    * src/preprocessors/flow/portscan/flowps_snort.c:
    * src/preprocessors/flow/portscan/flowps_snort.h:
    * src/preprocessors/flow/portscan/scoreboard.c:
    * src/preprocessors/flow/portscan/scoreboard.h:
    * src/preprocessors/flow/portscan/server_stats.c:
    * src/preprocessors/flow/portscan/server_stats.h:
    * src/preprocessors/flow/portscan/unique_tracker.c:
    * src/preprocessors/flow/portscan/unique_tracker.h:
    * src/sfutil/acsmx2.h:
    * src/sfutil/asn1.c:
    * src/sfutil/asn1.h:
    * src/sfutil/ipobj.c:
    * src/sfutil/ipobj.h:
    * src/sfutil/sfeventq.c:
    * src/sfutil/sfeventq.h:
    * src/sfutil/sfghash.c:
    * src/sfutil/sfghash.h:
    * src/sfutil/sfhashfcn.c:
    * src/sfutil/sfhashfcn.h:
    * src/sfutil/sflsq.c:
    * src/sfutil/sflsq.h:
    * src/sfutil/sfmemcap.c:
    * src/sfutil/sfmemcap.h:
    * src/sfutil/sfsnprintfappend.c:
    * src/sfutil/sfsnprintfappend.h:
    * src/sfutil/sfthd.c:
    * src/sfutil/sfthd.h:
    * src/sfutil/sfxhash.c:
    * src/sfutil/sfxhash.h:
    * src/sfutil/util_math.c:
    * src/sfutil/util_math.h:
    * src/sfutil/util_net.c:
    * src/sfutil/util_net.h:
    * src/sfutil/util_str.c:
    * src/sfutil/util_str.h:
    * src/win32/WIN32-Code/inet_aton.c:
    * src/win32/WIN32-Code/name.h:
      Update copyright dates & info and add GPL header.

2007-06-01 Steven Sturges <ssturges@sourcefire.com>
    * src/util.c:
      Update to hourly timestats from Bill Parker.

2007-06-01 Steven Sturges <ssturges@sourcefire.com>
    * src/preprocessors/spp_frag3.c:
      Fix configuration parsing to validate parameters for memcap,
      max_frags, prealloc_frags.  Thanks to Joel Ebrahimi for pointing
      out the issue.

2007-05-30 Steven Sturges <ssturges@sourcefire.com>
    * src/dynamic-preprocessors/smtp/smtp_util.c:
    * src/dynamic-preprocessors/smtp/smtp_util.h:
    * src/dynamic-preprocessors/smtp/smtp_xlink2state.c:
    * src/dynamic-preprocessors/smtp/snort_smtp.c:
      Cleanup xlink2state processing and remove potential read beyond
      end of packet.
    * src/preprocessors/stream_api.h:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Update handling of timed out session cleanup when the 'same' (IPs/ports)
      session is picked up midstream.

2007-05-23 Steven Sturges <ssturges@sourcefire.com>
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
    * doc/README.stream5:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/preprocessors/Stream5/stream5_common.h:
      Update Stream5 to use 65535 << 14 as max allowable value for
      the 'max_window' option.
    * src/decode.c:
    * src/detect.c:
    * src/snort.c:
    * src/snort.h:
      When checking for IPv6 BSD frag vulnerability, use a pseudo packet
      with false IPv4 headers for logging purposes rather than writing
      the IPv4 header within the original packet buffer.
    * src/preprocessors/spp_frag3.c:
      Update to not change original packet buffer when rebuilding fragments
      with IP options.
    * src/preprocessors/spp_rpc_decode.c:
    * src/preprocessors/spp_rpc_decode.h:
      Update to use the altdecode buffer for normalization.

2007-05-22 Steven Sturges <ssturges@sourcefire.com>
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
      Update for 2.7.0.
    * configure.in:
    * src/debug.c:
    * src/debug.h:
    * src/dynamic-plugins/sf_dynamic_plugins.c:
    * src/dynamic-plugins/sf_dynamic_preprocessor.h:
    * src/dynamic-preprocessors/dcerpc/dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/smb_andx_decode.c:
    * src/win32/WIN32-Includes/config.h:
      Check for wchar.h and don't try to use it if not present.
      Fixes builds on OpenBSD 3.5 and others.
    * src/dynamic-plugins/sf_dynamic_detection.h:
    * src/dynamic-plugins/sf_dynamic_plugins.c:
    * src/dynamic-plugins/sp_preprocopt.c:
    * src/dynamic-plugins/sp_preprocopt.h:
    * src/dynamic-preprocessors/ftptelnet/ftp_bounce_lookup.c:
    * src/dynamic-preprocessors/ftptelnet/ftp_cmd_lookup.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_client_lookup.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_server_lookup.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_config.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_config.h:
    * src/dynamic-preprocessors/ftptelnet/ppftp.c:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.h:
    * src/dynamic-preprocessors/ftptelnet/spp_ftptelnet.c:
    * src/dynamic-preprocessors/smtp/smtp_util.c:
    * src/dynamic-preprocessors/smtp/smtp_util.h:
    * src/dynamic-preprocessors/smtp/snort_smtp.c:
    * src/event_queue.c:
    * src/event_queue.h:
    * src/ipv6.c:
    * src/ipv6.h:
    * src/mempool.c:
    * src/parser.c:
    * src/preprocessors/spp_frag3.c:
    * src/preprocessors/spp_httpinspect.c:
    * src/preprocessors/Stream5/snort_stream5_icmp.c:
    * src/preprocessors/Stream5/snort_stream5_session.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/preprocessors/Stream5/snort_stream5_udp.c:
    * src/sfutil/asn1.c:
    * src/sfutil/asn1.h:
    * src/sfutil/sfeventq.c:
    * src/sfutil/sfeventq.h:
    * src/sfutil/sfksearch.c:
    * src/sfutil/sfksearch.h:
    * src/sfutil/sfxhash.c:
    * src/snort.c:
      Added code to cleanup memory at Snort exit/restart.
    * src/output-plugins/spo_log_tcpdump.c:
      Update to timestamp writing on 64bit platforms.
    * src/dynamic-preprocessors/smtp/smtp_normalize.c:
      Update normalization for postfix and sendmail servers that
      normalize any space except '\n'.
    * src/preprocessors/str_search.c:
    * src/sfutil/bnfa_search.c:
    * src/sfutil/mpse.c:
      Use BNFA, smaller memory footprint for searches from SMTP.
    * src/preprocessors/HttpInspect/client/hi_client.c:
    * src/preprocessors/HttpInspect/client/hi_client_norm.c:
    * src/preprocessors/HttpInspect/include/hi_eo_log.h:
    * src/preprocessors/HttpInspect/include/hi_si.h:
    * src/preprocessors/HttpInspect/normalization/hi_norm.c:
      Update way in which Body vs URI's are normalized, checked for
      anomalies and alerted on.
    * src/preprocessors/snort_stream4_udp.c:
      Fix use of ignore_any keyword when dealing with portscan
      and/or rules that have flow/flowbits.
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Update to timestamp handling and anomaly detection with invalid
      timestamps on RST packets.
    * src/snort.c:
    * src/snort.h:
      Add --loop option to be used with -r for pcap readback mode.

2007-05-09 Adam Keeton <akeeton@sourcefire.com>
    * src/preprocessors/HttpInspect/client/hi_client_norm.c:
    * src/preprocessors/HttpInspect/include/hi_si.h:
    * src/preprocessors/HttpInspect/normalization/hi_norm.c:
      Added code to prevent URI-related alerts from firing when the
      body is being normalized.

2007-05-08 Adam Keeton <akeeton@sourcefire.com>
    * src/preprocessors/HttpInspect/client/hi_client.c:
      Fixed pointer initialization relating to POST normalization.

2007-04-27 Steven Sturges <ssturges@sourcefire.com>
    * src/decode.h:
    * src/detection-plugins/sp_pattern_match.c:
    * src/detection-plugins/sp_pattern_match.h:
    * src/dynamic-plugins/sf_dynamic_common.h:
    * src/dynamic-plugins/sf_engine/sf_snort_detection_engine.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.h:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_content.c:
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
      Provide new rule keyword modifier for content option that allows a
      rule to search for a pattern in the body of an HTTP client request.
    * src/util.c:
    * src/preprocessors/snort_httpinspect.c:
    * src/preprocessors/spp_httpinspect.c:
    * src/preprocessors/HttpInspect/client/hi_client.c:
    * src/preprocessors/HttpInspect/client/hi_client_norm.c:
    * src/preprocessors/HttpInspect/include/hi_client.h:
    * src/preprocessors/HttpInspect/include/hi_include.h:
    * src/preprocessors/HttpInspect/include/hi_ui_config.h:
    * src/preprocessors/HttpInspect/include/hi_util_xmalloc.h:
    * src/preprocessors/HttpInspect/normalization/hi_norm.c:
    * src/preprocessors/HttpInspect/user_interface/hi_ui_config.c:
    * src/preprocessors/HttpInspect/user_interface/hi_ui_server_lookup.c:
    * src/preprocessors/HttpInspect/utils/hi_util_kmap.c:
      Update to normalize the body of a client request to allow rules to
      check specifically for parameters of a POST or GET request.  Also
      add stats that are part of the hourly stats that track various
      HTTP encodings and normalizations that have occured.
    * src/preprocessors/spp_stream4.c:
      Fix potential memory leak.
    * doc/README.ipv6:
      Updates for clarity.
    * doc/faq.tex:
    * configure.in:
      Add minimal PCRE version.
    * etc/gen-msg.map:
    * src/decode.c:
    * src/generators.h:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Handle TCP window scale option that is > 14.  Added decoder alert for
      this and adjust the scale per RFC 1323 in Stream5.
    * etc/snort.conf:
      Make Stream5 the default stream engine.
    * src/decode.c:
      Add alert for multiple GRE encapsulations.
    * src/ipv6.c:
      Additional structure name changes to avoid conflicts on Win32.
    * src/parser.c:
      Update the maximum number of entries in an IP List to 1024 (was 128).
      Added ability to configure Timestats interval, default is 3600 seconds
      (1 hour) when enabled via --enable-timestats.
    * src/snort.c:
    * src/snort.h:
    * src/util.h:
      Revised signal handler for Timestats.
    * src/util.c:
      Update Timestats to include Wifi, GRE, Frag & TCP Stream info.  Thanks
      to Bill Parker for the update.
    * src/detection-plugins/sp_icmp_code_check.c:
    * src/detection-plugins/sp_icmp_type_check.c:
      Update to parsing of icmp rule options for better grammar enforcement.
    * src/detection-plugins/sp_respond.c:
    * src/detection-plugins/sp_respond2.c:
      Specify TCP window of 0 for RST packets that are sent.
    * src/dynamic-plugins/sf_dynamic_plugins.c:
    * src/dynamic-plugins/sf_dynamic_preprocessor.h:
    * src/dynamic-preprocessors/sf_dynamic_preproc_lib.c:
      Make Preprocess() function available to dynamic preprocessors.  Thanks
      Vladimir Shcherbakov for the request.
    * src/dynamic-preprocessors/dcerpc/dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc.h:
    * src/dynamic-preprocessors/dcerpc/smb_andx_decode.c:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.c:
      Code cleanup and a minor reorganization.
    * src/dynamic-preprocessors/smtp/snort_smtp.c:
      Fix truncated buffer in when compiled in debug mode.
    * src/preprocessors/perf-base.c:
    * src/preprocessors/perf-base.h:
    * src/preprocessors/snort_stream4_session.c:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/stream_api.h:
    * src/preprocessors/Stream5/snort_stream5_session.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Update to track additional stats for TCP session cache and session states.
    * src/preprocessors/spp_perfmonitor.c:
      Fix behaviour of 'accumlate' option.
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Update for 64bit platforms.
    * src/preprocessors/spp_stream5.c:
    * src/preprocessors/Stream5/snort_stream5_session.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/preprocessors/Stream5/snort_stream5_udp.c:
    * src/preprocessors/Stream5/snort_stream5_icmp.c:
    * doc/README.stream5:
      Updates to config validation.  Code cleanup for readability.  Update
      TCP Window Scale use and sequence validation to be RFC 1323 compliant.
      Document min/max values for parameters, etc.

2007-04-13 Steven Sturges <ssturges@sourcefire.com>
    * src/decode.h:
    * src/decode.c:
    * src/ipv6.c:
      Changed structure declaration and usage to not conflict with OpenBSD.

2007-03-28 Steven Sturges <ssturges@sourcefire.com>
    * rpm/snort.spec:
      Remove smp_flags from spec file to not parallelize building.
    * doc/README.ipv6
    * etc/gen-msg.map:
    * src/Makefile.am:
    * src/decode.c:
    * src/decode.h:
    * src/generators.h:
    * src/ipv6.c (added):
    * src/ipv6.h (added):
    * src/parser.c:
    * src/snort.c:
    * src/snort.h:
    * src/win32/WIN32-Prj/snort.dsp:
      Added ability for Snort to track fragmented ICMPv6 to check for the
      remote BSD exploit (Bugtraq ID 22901, CVE-2007-1365).
    * src/win32/WIN32-Code/syslog.c:
    * src/win32/WIN32-Code/win32_service.c:
    * src/plugbase.c:
    * src/preprocessors/perf-base.c:
    * src/preprocessors/stream_ignore.c:
    * src/profiler.c:
    * src/snort.c:
      Cleanup to use safe snprintf and strncpy functions, check return values
      of SafeMemcpy, use calloc or SnortAlloc, and other static size buffer
      bounds checks.
    * src/parser.c:
      Fix issue with printing rule information twice.
    * src/profiler.h:
    * src/preprocessors/spp_flow.c:
      Fix miscalculation of processor time attributable to flow.
    * src/dynamic-plugins/sp_dynamic.c:
    * src/dynamic-plugins/sp_dynamic.h:
    * src/dynamic-plugins/sf_engine/sf_snort_detection_engine.c:
      Added hasXXX functions for Content, ByteTest, and PCRE.
    * src/dynamic-preprocessors/dcerpc/dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc.h:
    * src/dynamic-preprocessors/dcerpc/dcerpc_config.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc_util.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc_util.h:
    * src/dynamic-preprocessors/dcerpc/sf_preproc_info.h:
    * src/dynamic-preprocessors/dcerpc/smb_andx_decode.c:
    * src/dynamic-preprocessors/dcerpc/smb_andx_decode.h:
    * src/dynamic-preprocessors/dcerpc/smb_andx_structs.h:
    * src/dynamic-preprocessors/dcerpc/smb_structs.h:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.h:
    * src/dynamic-preprocessors/dcerpc/spp_dcerpc.c:
      Code cleanup to perform bounds checking, validation of memcpy
      success, remove potential memory leak.  Code readability improvements
      and update DCE endianness checks.
    * src/dynamic-preprocessors/dns/sf_preproc_info.h:
    * src/dynamic-preprocessors/dns/spp_dns.c:
      Code cleanup for initialization of memory allocations and add
      early termination when at end of packet payload.
    * src/dynamic-preprocessors/ftptelnet/ftpp_si.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_si.h:
    * src/dynamic-preprocessors/ftptelnet/hi_util_kmap.c:
    * src/dynamic-preprocessors/ftptelnet/hi_util_xmalloc.c:
    * src/dynamic-preprocessors/ftptelnet/pp_ftp.c:
    * src/dynamic-preprocessors/ftptelnet/sf_preproc_info.h:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
      Code cleanup for initialization of memory allocations and remove
      dead/unused code for directory and user state tracking.
    * src/dynamic-preprocessors/smtp/sf_preproc_info.h:
    * src/dynamic-preprocessors/smtp/smtp_config.c:
    * src/dynamic-preprocessors/smtp/smtp_log.c:
    * src/dynamic-preprocessors/smtp/smtp_normalize.c:
    * src/dynamic-preprocessors/smtp/smtp_normalize.h:
    * src/dynamic-preprocessors/smtp/snort_smtp.c:
      Code cleanup for initialization of memory allocations, fix normalization
      to prevent read beyond packet payload.  Generate SMTP command overflow
      even if packet payload doesn't contain complete command (missing LF).
    * src/preprocessors/spp_frag3.c:
      Further update to handle iptables (and other datalink layers) that
      do not have ethernet headers to be included in rebuilt fragment.
    * src/preprocessors/Stream5/snort_stream5_icmp.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/preprocessors/Stream5/snort_stream5_udp.c:
    * src/preprocessors/Stream5/stream5_common.c:
    * src/preprocessors/Stream5/stream5_common.h:
    * doc/README.stream5:
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
      Add verification of options for ICMP, TCP, UDP configurations are
      within reasonable limits.  Reorganize reassembly flush initialization.
      Print list of UDP rules that are effectively ignored with ignore_any_rules
      option.  Update session timeout handling.
    * src/sfutil/sfxhash.c:
    * src/sfutil/sfxhash.h:
    * src/preprocessors/snort_stream4_session.c:
    * src/preprocessors/Stream5/snort_stream5_session.c:
      Allow use of limit on number of nodes in hash table instead of
      relying on memcap for limiting sessions.
    * src/bounds.h:
    * src/debug.c:
    * src/detect.c:
    * src/fpdetect.c:
    * src/log.c:
    * src/parser.c:
    * src/pcrm.c:
    * src/plugbase.c:
    * src/profiler.c:
    * src/sfthreshold.c:
    * src/snort.c:
    * src/ubi_BinTree.c:
    * src/util.c:
    * src/util.h:
    * src/detection-plugins/sp_pattern_match.c:
    * src/detection-plugins/sp_react.c:
    * src/detection-plugins/sp_session.c:
    * src/dynamic-plugins/sf_dynamic_engine.h:
    * src/dynamic-plugins/sf_dynamic_plugins.c:
    * src/dynamic-plugins/sf_dynamic_preprocessor.h:
    * src/dynamic-preprocessors/ssh/spp_ssh.c:
    * src/output-plugins/spo_alert_prelude.c:
    * src/output-plugins/spo_alert_syslog.c:
    * src/output-plugins/spo_alert_unixsock.c:
    * src/output-plugins/spo_database.c:
    * src/output-plugins/spo_log_ascii.c:
    * src/output-plugins/spo_log_tcpdump.c:
    * src/output-plugins/spo_unified.c:
    * src/parser/IpAddrSet.c:
    * src/preprocessors/perf-base.c:
    * src/preprocessors/perf.c:
    * src/preprocessors/snort_httpinspect.c:
    * src/preprocessors/HttpInspect/client/hi_client.c:
    * src/preprocessors/HttpInspect/event_output/hi_eo_log.c:
    * src/preprocessors/HttpInspect/utils/hi_util_kmap.c:
    * src/preprocessors/snort_stream4_session.c:
    * src/preprocessors/snort_stream4_udp.c:
    * src/preprocessors/spp_bo.c:
    * src/preprocessors/spp_frag3.c:
    * src/preprocessors/spp_perfmonitor.c:
    * src/preprocessors/spp_sfportscan.c:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/spp_stream5.c:
    * src/preprocessors/stream_api.h:
    * src/preprocessors/stream_ignore.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/preprocessors/Stream5/snort_stream5_udp.c:
    * src/preprocessors/flow/flow_print.c:
    * src/preprocessors/flow/flow_print.h:
    * src/sfutil/acsmx2.c:
    * src/sfutil/ipobj.c:
    * src/sfutil/sfghash.c:
    * src/sfutil/sfmemcap.c:
    * src/sfutil/sfxhash.c:
      Cleanup to use safe snprintf and strncpy functions, check return values
      of SafeMemcpy, use calloc or SnortAlloc, and other static size buffer
      bounds checks.  Add handling for FatalError not returning for static
      code analysis tools.
    * src/sfutil/sfthd.c:
      Fix memory leak in global config.  Thanks Boris Lytochkin for pointing
      this out.

2007-02-20 Steven Sturges <ssturges@sourcefire.com>
    * src/util.c:
      Update copyright date to include 2007.

2007-02-17 Steven Sturges <ssturges@sourcefire.com>
    * src/parser.c:
      Code cleanup, remove tab characters going to syslog.
    * src/detection-plugins/sp_clientserver.c:
      Handle flow keyword with Stream5 UDP sessions.
    * src/dynamic-preprocessors/Makefile.am:
    * src/dynamic-preprocessors/dcerpc/dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/smb_andx_decode.c:
      Add bounds checking to ReassembleSMBWriteX; use Safememcpy for calculated
      length buffer copies.

2007-02-09 Steven Sturges <ssturges@sourcefire.com>
    * configure.in:
      Added support for libpcap that depends on libpfring.  Thanks to
      Jason Wallace for the patch.  Also updated description as to why
      libpcap check might fail and what files might be missing, thanks
      to James Affeld for that suggestion.
    * src/preprocessors/spp_stream5.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Update configuration parsing and validation checks and fix issue
      with static flushpoints not really being static.
    * src/output-plugins/spo_database.c:
      Code cleanup to check that a query was not truncated when using
      snprintf and guarantee NULL terminated string.

2007-02-07 Steven Sturges <ssturges@sourcefire.com>
    * src/decode.c:
    * src/detection-plugins/sp_ip_same_check.c:
    * src/detection-plugins/sp_pattern_match.c:
    * src/detection-plugins/sp_react.c:
    * src/dynamic-plugins/sf_dynamic_plugins.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_loop.c:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.c:
    * src/dynamic-preprocessors/dns/spp_dns.c:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
    * src/dynamic-preprocessors/smtp/smtp_config.c:
    * src/dynamic-preprocessors/smtp/smtp_util.c:
    * src/dynamic-preprocessors/ssh/spp_ssh.c:
    * src/parser.c:
    * src/plugbase.c:
    * src/preprocessors/flow/flow_print.c:
    * src/preprocessors/flow/portscan/flowps_snort.c:
    * src/preprocessors/flow/portscan/scoreboard.c:
    * src/preprocessors/HttpInspect/event_output/hi_eo_log.c:
    * src/preprocessors/snort_httpinspect.c:
    * src/preprocessors/spp_bo.c:
    * src/preprocessors/spp_stream4.c:
    * src/snort.c:
    * src/tag.c:
    * src/win32/WIN32-Code/misc.c:
      Code & warning cleanup.
    * src/parser.c:
      Add file and line number to an error message.  Thanks to
      rmkml for pointing out the omission.

2007-02-05 Steven Sturges <ssturges@sourcefire.com>
    * src/dynamic-plugins/sf_dynamic_engine.h:
    * src/dynamic-plugins/sf_dynamic_plugins.c:
    * src/dynamic-plugins/sf_dynamic_preprocessor.h:
    * src/dynamic-plugins/sf_engine/sf_snort_detection_engine.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.c:
    * src/dynamic-plugins/sp_preprocopt.c:
    * src/dynamic-preprocessors/ftptelnet/ftp_bounce_lookup.c:
    * src/dynamic-preprocessors/ftptelnet/ftp_cmd_lookup.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_si.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_client_lookup.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_config.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_server_lookup.c:
    * src/dynamic-preprocessors/ftptelnet/pp_ftp.c:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
    * src/dynamic-preprocessors/ftptelnet/spp_ftptelnet.c:
    * src/dynamic-preprocessors/smtp/smtp_config.c:
    * src/fpdetect.c:
    * src/output-plugins/spo_csv.c:
    * src/output-plugins/spo_database.c:
    * src/output-plugins/spo_log_ascii.c:
    * src/parser/IpAddrSet.c:
    * src/parser.c:
    * src/plugbase.c:
    * src/preprocessors/HttpInspect/client/hi_client.c:
    * src/preprocessors/HttpInspect/client/hi_client_norm.c:
    * src/preprocessors/HttpInspect/event_output/hi_eo_log.c:
    * src/preprocessors/HttpInspect/mode_inspection/hi_mi.c:
    * src/preprocessors/HttpInspect/normalization/hi_norm.c:
    * src/preprocessors/HttpInspect/server/hi_server.c:
    * src/preprocessors/HttpInspect/session_inspection/hi_si.c:
    * src/preprocessors/HttpInspect/user_interface/hi_ui_config.c:
    * src/preprocessors/HttpInspect/user_interface/hi_ui_iis_unicode_map.c:
    * src/preprocessors/HttpInspect/user_interface/hi_ui_server_lookup.c:
    * src/preprocessors/snort_httpinspect.c:
    * src/preprocessors/spp_bo.c:
    * src/preprocessors/spp_httpinspect.c:
    * src/preprocessors/spp_sfportscan.c:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/sfutil/acsmx2.c:
    * src/sfutil/ipobj.c:
    * src/signature.c:
    * src/snort.c:
    * src/tag.c:
    * src/ubi_BinTree.c:
    * src/util.h:
      More code cleanup, eliminate warnings on Win32 platform.

2007-02-02 Steven Sturges <ssturges@sourcefire.com>
    * doc/README.stream5:
      Cleanup spelling, etc.
    * src/bounds.h:
    * src/preprocessors/spp_frag3.c:
      Fix issue when Snort is inline using iptables, without either the
      ipconntrack or NAT modules.  This should not occur using the recommended
      snort inline configuration, since the OS is supposed to handle IP
      fragment reassembly.  The Ethernet header doesn't exist in the packet
      received by Snort, causing snort to dereference an invalid pointer.
      Thanks to Panda Software and Joel Ebrahimi for reporting the issue."
    * src/parser.c:
      Fix benign warning when using -E on Win32.
    * src/plugbase.c:
    * src/preprocessors/spp_telnet_negotiation.c (removed):
    * src/preprocessors/spp_telnet_negotiation.h (removed):
    * src/preprocessors/Makefile.am:
    * src/win32/WIN32-Prj/snort.dsp:
      Removed deprecated telnet preprocessor.
    * src/profiler.c:
    * src/profiler.h:
      Added profiling code for 64 bit Intel and PPC platforms.
    * src/decode.h:
    * src/detect.c:
    * src/fpdetect.c:
    * src/log.c:
    * src/mstring.c:
    * src/parser.c:
    * src/plugbase.c:
    * src/profiler.c:
    * src/profiler.h:
    * src/sfthreshold.c:
    * src/signature.c:
    * src/snort.c:
    * src/strlcatu.c:
    * src/strlcpyu.c:
    * src/ubi_BinTree.c:
    * src/util.c:
    * src/util.h:
    * src/detection-plugins/sp_flowbits.c:
    * src/detection-plugins/sp_pattern_match.c:
    * src/detection-plugins/sp_pcre.c:
    * src/detection-plugins/sp_react.c:
    * src/detection-plugins/sp_respond.c:
    * src/detection-plugins/sp_ttl_check.c:
    * src/dynamic-plugins/sf_dynamic_engine.h:
    * src/dynamic-plugins/sf_dynamic_plugins.c:
    * src/dynamic-plugins/sf_dynamic_preprocessor.h:
    * src/dynamic-plugins/sp_dynamic.c:
    * src/dynamic-plugins/sp_preprocopt.c:
    * src/dynamic-plugins/sf_engine/bmh.c:
    * src/dynamic-plugins/sf_engine/sf_snort_detection_engine.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_loop.c:
    * src/dynamic-plugins/sf_preproc_example/sf_dynamic_preproc_lib.c:
    * src/dynamic-preprocessors/dns/spp_dns.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_si.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_config.c:
    * src/dynamic-preprocessors/ftptelnet/hi_util_kmap.c:
    * src/dynamic-preprocessors/ftptelnet/pp_ftp.c:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
    * src/dynamic-preprocessors/ftptelnet/spp_ftptelnet.c:
    * src/dynamic-preprocessors/smtp/smtp_config.c:
    * src/dynamic-preprocessors/smtp/smtp_util.c:
    * src/dynamic-preprocessors/smtp/snort_smtp.c:
    * src/dynamic-preprocessors/ssh/spp_ssh.c:
    * src/output-plugins/spo_alert_fast.c:
    * src/output-plugins/spo_database.c:
    * src/output-plugins/spo_log_ascii.c:
    * src/output-plugins/spo_log_tcpdump.c:
    * src/output-plugins/spo_unified.c:
    * src/preprocessors/perf-base.c:
    * src/preprocessors/perf-flow.c:
    * src/preprocessors/perf.c:
    * src/preprocessors/portscan.c:
    * src/preprocessors/snort_httpinspect.c:
    * src/preprocessors/snort_stream4_udp.c:
    * src/preprocessors/spp_perfmonitor.c:
    * src/preprocessors/spp_sfportscan.c:
    * src/preprocessors/spp_stream5.c:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/str_search.c:
    * src/preprocessors/stream.h:
    * src/preprocessors/HttpInspect/client/hi_client.c:
    * src/preprocessors/HttpInspect/event_output/hi_eo_log.c:
    * src/preprocessors/HttpInspect/user_interface/hi_ui_iis_unicode_map.c:
    * src/preprocessors/HttpInspect/utils/hi_util_kmap.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/preprocessors/flow/flow.h:
    * src/preprocessors/flow/int-snort/flow_packet.h:
    * src/preprocessors/flow/portscan/flowps.c:
    * src/preprocessors/flow/portscan/flowps_snort.c:
    * src/sfutil/acsmx.c:
    * src/sfutil/acsmx2.c:
    * src/sfutil/bitop_funcs.h:
    * src/sfutil/getopt_long.c:
    * src/sfutil/ipobj.c:
    * src/sfutil/sfghash.c:
    * src/sfutil/sflsq.c:
    * src/sfutil/sfsnprintfappend.c:
    * src/sfutil/sfxhash.c:
    * src/win32/WIN32-Code/misc.c:
    * src/win32/WIN32-Code/syslog.c:
    * src/win32/WIN32-Code/win32_service.c:
      Code cleanup, change malloc/calloc to SnortAlloc, use safer functions
      SnortSnprintf, SnortStrncpy, etc.  Check pointers before use.
    * src/win32/WIN32-Code/win32_service.c:
      Fix issue with service initialization and parameter validation.
      Thanks Hideki Saito for pointing out the problem.
    * src/dynamic-preprocessors/dcerpc/dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc.h:
    * src/dynamic-preprocessors/dcerpc/dcerpc_config.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc_util.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc_util.h:
    * src/dynamic-preprocessors/dcerpc/smb_andx_decode.c:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/spp_dcerpc.c:
      Code cleanup, update calculating for valid length to handle
      alternate padding.  Update to use safer functions.
    * src/preprocessors/portscan.c:
    * src/preprocessors/portscan.h:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/spp_stream5.c:
    * src/preprocessors/stream_api.h:
    * src/preprocessors/Stream5/snort_stream5_udp.c:
      Allow portscan to work with Stream5 UDP session tracking (because
      it replaces flow preprocessor).  Added API function to get direction
      of packet (not supported in Stream4).
    * src/preprocessors/spp_stream5.c:
    * src/preprocessors/Stream5/snort_stream5_icmp.c:
    * src/preprocessors/Stream5/snort_stream5_icmp.h:
    * src/preprocessors/Stream5/snort_stream5_session.c:
    * src/preprocessors/Stream5/snort_stream5_session.h:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/preprocessors/Stream5/snort_stream5_udp.c:
    * src/preprocessors/Stream5/stream5_common.h:
      Stream5 config parsing improvements.  Check option parameters for
      reasonable values (prevent huge memcaps, etc).

2007-01-29 Steven Sturges <ssturges@sourcefire.com>
    * src/debug.c:
    * configure.in:
      Handle platforms that don't support vswprintf and vwprintf.  Thanks
      Nikns Siankin for pointing that out for OpenBSD.
    * src/profiler.h:
    * src/profiler.c:
    * src/rules.h:
      Use 64 bit values to store profiling counters.
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
      Added a table for content modifiers and links to their respective
      sections.  Removed old preprocessor sections and moved ASN.1 from
      preprocessor to detection plugins section.  Added section for Stream5.
    * src/win32/WIN32-Prj/snort.dsp:
      Always use DYNAMIC_PLUGIN.
    * src/win32/WIN32-Includes/config.h:
    * src/win32/WIN32-Includes/LibnetNT.h:
      Code cleanup.
    * src/detection-plugins/sp_flowbits.c:
    * src/preprocessors/spp_stream5.c:
      Fix issue with flowbits for UDP streams.
    * src/detection-plugins/sp_flowbits.c:
      Add check when stream4 or stream5 are not enabled to still support
      flowbits.  Will be removed when Flow preprocessor and Stream4 are
      deprecated.  Thanks to Nathan Ching for pointing out the issue.
    * src/snort.c:
      Fix to allow dynamic rules to load correctly.
    * doc/README.stream4:
    * doc/README.stream5:
      Cleanup.

2007-01-18 Steven Sturges <ssturges@sourcefire.com>
    * etc/generators:
    * src/generators.h:
      Remove generator IDs that are no longer used.
    * doc/README.tag
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
      Added info on snort.conf config option tagged_packet_limit and added
      README.tag info file for the tag option in rules.
    * doc/README.http_inspect:
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
      Emphasized in httpinspect documentation that a flow_depth between
      1 and 1460 will only inspect at most that many bytes of a server's
      response, stream reassembled or not and that rules written to inspect
      more than flow_depth bytes will be ineffective.  Thanks to Christian
      Seifert for pointing this out.

2007-01-17 Steven Sturges <ssturges@sourcefire.com>
    * configure.in:
    * snort.8:
    * RELEASE.NOTES:
    * etc/snort.conf:
    * rpm/snort.spec:
    * src/win32/WIN32-Includes/config.h:
    * src/win32/WIN32-Prj/snort_installer.nsi:
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
      Update for 2.7.0 Beta
    * src/dynamic-plugins/sf_engine/Makefile.am:
    * src/win32/Makefile.am:
    * src/win32/WIN32-Code/getopt.c:
    * src/win32/WIN32-Code/getopt_long.c:
    * src/win32/WIN32-Includes/config.h:
    * src/win32/WIN32-Includes/getopt.h:
    * src/win32/WIN32-Includes/getopt1.h:
    * src/win32/WIN32-Includes/stdint.h:
    * src/win32/WIN32-Prj/.cvsignore:
    * src/win32/WIN32-Prj/sf_engine.dsp:
    * src/win32/WIN32-Prj/snort.dsp:
    * src/win32/WIN32-Prj/snort.dsw:
      Update Win32 build enviornment for 2.7.0.
    * doc/README.stream5:
    * doc/README.ftptelnet:
      Fix a few typos and add better descriptions for alerts.
    * etc/gen-msg.map:
    * etc/generators.h:
      Add Stream5 alert.
    * etc/snort.conf:
    * src/preprocessors/spp_frag2.c (removed):
    * src/preprocessors/spp_frag2.h (removed):
    * src/preprocessors/Makefile.am:
    * src/plugbase.c:
    * src/plugbase.h:
      Remove deprecated Frag2.
    * src/sfutil/mwm.c (removed):
    * src/sfutil/mwm.h (removed): 
      Remove deprecated mwm pattern matcher.
    * src/detection-plugins/sp_ipoption_check.c:
    * src/decode.h:
    * src/decode.c:
    * src/log.c:
      Add handling of IP Option ESEC (Extended Security).
    * src/debug.h:
    * src/bounds.h:
    * src/fpcreate.h:
    * src/fpdetect.h:
    * src/tag.c:
    * src/detection-plugins/sp_respond2.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_include.h:
    * src/preprocessors/portscan.h:
    * src/preprocessors/snort_stream4_udp.c:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/HttpInspect/include/hi_include.h:
    * src/preprocessors/flow/common_defs.h:
    * src/sfutil/bitop_funcs.h:
      Move definition of INLINE for inline functions to a common place.
    * src/debug.c:
    * src/debug.h:
    * src/dynamic-plugins/sf_dynamic_preprocessor.h:
      Add DebugWideMessageFunc for use with Wide Character sets, however
      it does not write to syslog.
    * src/debug.c:
    * src/decode.c:
    * src/detect.c:
    * src/detect.h:
    * src/fpcreate.c:
    * src/fpdetect.c:
    * src/log.c:
    * src/mstring.c:
    * src/parser.c:
    * src/pcrm.c:
    * src/plugbase.c:
    * src/profiler.h:
    * src/sf_sdlist.c:
    * src/sfthreshold.c:
    * src/sfthreshold.h:
    * src/signature.c:
    * src/snort.c:
    * src/snort.h:
    * src/tag.c:
    * src/util.c:
    * src/util.h:
    * src/detection-plugins/sp_ip_fragbits.c:
    * src/detection-plugins/sp_pcre.c:
    * src/detection-plugins/sp_rpc_check.c:
    * src/dynamic-plugins/sf_dynamic_plugins.c:
    * src/dynamic-plugins/sp_preprocopt.c:
    * src/dynamic-plugins/sf_engine/sf_snort_detection_engine.c:
    * src/dynamic-plugins/sf_engine/sf_snort_packet.h:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.h:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_loop.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc_util.c:
    * src/dynamic-preprocessors/dcerpc/smb_andx_decode.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_si.c:
    * src/dynamic-preprocessors/ftptelnet/pp_ftp.c:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
    * src/dynamic-preprocessors/smtp/smtp_confic.c:
    * src/dynamic-preprocessors/ssh/spp_ssh.c:
    * src/dynamic-preprocessors/ssh/spp_ssh.h:
    * src/preprocessors/spp_arpspoof.c:
    * src/preprocessors/spp_flow.c:
    * src/preprocessors/spp_frag3.c:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/str_search.c:
    * src/preprocessors/stream_ignore.c:
    * src/sfutil/acsmx.c:
    * src/sfutil/acsmx.h:
    * src/sfutil/acsmx2.c:
    * src/sfutil/acsmx2.h:
    * src/sfutil/asn1.c:
    * src/sfutil/asn1.h:
    * src/sfutil/bnfa_search.c:
    * src/sfutil/bnfa_search.h:
    * src/sfutil/ipobj.c:
    * src/sfutil/mpse.c:
    * src/sfutil/mpse.h:
    * src/sfutil/mwm.c:
    * src/sfutil/mwm.h:
    * src/sfutil/sfeventq.c:
    * src/sfutil/sfghash.c:
    * src/sfutil/sfghash.h:
    * src/sfutil/sfhashfcn.c:
    * src/sfutil/sfksearch.c:
    * src/sfutil/sfksearch.h:
    * src/sfutil/sflsq.c:
    * src/sfutil/sflsq.h:
    * src/sfutil/sfmemcap.c:
    * src/sfutil/sfsnprintfappend.c:
    * src/sfutil/sfthd.c:
    * src/sfutil/sfxhash.c:
    * src/sfutil/sfxhash.h:
    * src/sfutil/util_match.c:
    * src/sfutil/util_net.c:
      Code cleanup, change malloc to calloc, use safer functions
      SnortAlloc, SnortStrdup.  Check pointers before use.
    * src/sfutil/acsmx.c:
    * src/sfutil/acsmx.h:
    * src/sfutil/acsmx2.c:
    * src/sfutil/acsmx2.h:
    * src/sfutil/bnfa_search.c:
    * src/sfutil/bnfa_search.h:
    * src/sfutil/mpse.c:
    * src/sfutil/mpse.h:
    * src/sfutil/mwm.c:
    * src/sfutil/mwm.h:
      Added caller usable state tracking to pattern matcher.
    * src/parser.c:
    * src/parser.h:
    * src/dynamic-plugins/sp_preprocopt.c:
    * src/dynamic-plugins/sp_preprocopt.h:
      To better handle rule options that are provided by dynamic
      preprocessors, make 2 passes through snort.conf at startup.
    * src/parser.c:
    * src/snort.c:
      Improve dynamicengine keyword and commandline option to allow for
      specifying directory or file.
    * src/detect.c:
    * src/event_queue.c:
    * src/event_queue.h:
    * src/event_wrapper.c:
    * src/event_wrapper.h:
    * src/fpcreate.c:
    * src/parser.c:
    * src/signature.c:
    * src/signature.h:
      Unify logging to a single code path and added ability to have
      rule stubs for preprocessor and decoder events.
    * src/snort.c:
      Fix code that looks for .snortrc.  Thanks to Benjamin Bennett
      for pointing out the issue.
    * src/preprocessors/portscan.c:
    * src/preprocessors/spp_sfportscan.c:
      Fix false alert where destination IP was not in range reported by
      sfportscan alert.
    * src/preprocessors/spp_sfportscan.c:
      Reset threshold checking at end of portscan alerting so that other
      events generated for packet wouldn't use old value returned from
      testing portscan thresholding/suppression.  Thanks to Andreas
      Ostling for pointing this out.
    * src/preprocessors/spp_frag3.c:
      Cleanup of GRE code for GRE nested fragments.
    * src/preprocessors/spp_stream5.c:
    * src/preprocessors/Stream5/snort_stream5_icmp.c:
    * src/preprocessors/Stream5/snort_stream5_icmp.h:
    * src/preprocessors/Stream5/snort_stream5_session.c:
    * src/preprocessors/Stream5/snort_stream5_session.h:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.h:
    * src/preprocessors/Stream5/snort_stream5_udp.c:
    * src/preprocessors/Stream5/snort_stream5_udp.h:
    * src/preprocessors/Stream5/stream5_common.c:
    * src/preprocessors/Stream5/stream5_common.h:
      Added memcap for TCP reassembly packet storage.  Reduced memory
      consumption of session tracking data structures.  Added target-based
      reassembly for HPUX 11, HPUX 10.2, Windows 2003, Windows Vista.
      Added target-based support for processing of TCP timestamps, TCP
      Resets, and repeated SYN packets.  Improved Session cache management.
      Update flushpoint management.  Improved handling of midstream
      session establishment.  Code cleanup to use safe functions for
      memory allocation.  Set tcp policy for both sides of session,
      rather that by first packet seen, correctly does target-based
      reassembly for each side.  Simplify code handling sessions to ignore.

2007-01-07 Steven Sturges <ssturges@sourcefire.com>
    * src/decode.c:
    * src/decode.h:
      Fixed issue where GRE decoder was attempting to assign a potentially
      negative value to an unsigned integer.  This value, which would then
      be positive, was then checked to see if it was less than zero, which
      would indicate whether the calculated length of the header was greater
      than the length of the rest of the packet capture.  This would always
      return false and the assumed length of the packet would potentially
      be larger than the actual length, leading to a potential dereferning
      of invalid memory.  Thanks to Chris Rohlf for pointing this out.

2006-12-04 Steven Sturges <ssturges@sourcefire.com>
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_config.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_config.h:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
      Configuration validation update.
    * src/dynamic-preprocessors/dcerpc/dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/sf_preproc_info.h:
    * src/dynamic-preprocessors/dcerpc/smb_andx_decode.c:
      Additional updates for bounds checking.
    * src/detection-plugins/sp_isdataat.c:
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
      Added an option to specify rawbytes for the buffer.

2006-11-30 Steven Sturges <ssturges@sourcefire.com>
    * src/tag.c:
      Fix logging of tagged packets when -G (event source ID) is used.
    * src/event.h:
    * src/snort_packet_header.h:
    * src/output-plugins/spo_unified.c:
      Fix unified to work correctly on 64bit platforms.  Thanks Nikns Siankin
      for the report.  Nikns provides a patch to barnyard that may be
      required to use this functionality on a 64bit systems.  Grab the
      patch from here: http://secure.lv/~nikns/stuff/barnyard_64bit.diff
    * src/snort.c:
    * src/snort.h:
      Reorganize code for inline fail-open to create pattern matcher rule
      groups in the thread.
    * src/util.c:
      Code cleanup
    * src/dynamic-preprocessors/dcerpc/dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc_util.c:
    * src/dynamic-preprocessors/dcerpc/sf_preproc_info.h:
    * src/dynamic-preprocessors/dcerpc/smb_andx_decode.c:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.c:
      Fix segfault caused by integer overflow and add additional checks
      to protect against other underflow/overflow conditions.
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/stream.h:
      Add capability to have multiple application layer preprocessors store
      data within the stream to better handle autodetection and multi-protocol
      packets.  Fix additional issue with high CPU and reprocessing rebuilt
      packets that are split across a sequence wrap.  

2006-11-22 Steven Sturges <ssturges@sourcefire.com>
    * preprocessors/spp_stream4.c:
      Fix problem with snort using high CPU and reprocessing the same
      rebuilt packets at session end or ACK in middle of packet when
      there are gaps in the packet sequence.

2006-11-16 Andrew Mullican <amullican@sourcefire.com>
    * etc/gen-msg.map:
      Add DCE/RPC preprocessor alert.

2006-11-07 Steven Sturges <ssturges@sourcefire.com>
    * src/dynamic-preprocessors/dcerpc/dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc_config.c:
    * src/dynamic-preprocessors/dcerpc/smb_andx_decode.c:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.h:
    * src/dynamic-preprocessors/dcerpc/spp_dcerpc.c:
      Updates for printing of options and handling of memcap.
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
      Add print for config option.
    * src/preprocessors/spp_stream5.c:
    * src/preprocessors/Stream5/snort_stream5_session.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/preprocessors/Stream5/snort_stream5_udp.c:
      Add UDP session tracking stats.  Improved TCP Timestamp handling.
      Seperate MacOS policy from BSD, as they differ slightly.  Improved
      performance of session pruning.
    * src/snort.c:
      Updates to inline thread initialization.  

2006-10-30 Steven Sturges <ssturges@sourcefire.com>
    * src/dynamic-preprocessors/dcerpc/dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.c:
      Fix debug prints.
    * src/detection-plugins/sp_isdataat.c:
      Fix problem with this option not being marked as relative when
      'relative' is used.  This change should've been made with changes
      for not rechecking non-relative options on 2006-08-16.

2006-10-27 Steven Sturges <ssturges@sourcefire.com>
    * src/preprocessors/snort_httpinspect.c:
    * src/preprocessors/HttpInspect/include/hi_ui_config.h:
      Output user-selected server profile at startup.
    * src/parser.c:
      Detect corrupt files and handle mixed windows and unix line endings.
    * doc/README.dcerpc:
      Update description of DCE/RPC auto-detect.
    * src/dynamic-preprocessors/dcerpc/smb_andx_decode.c:
    * src/dynamic-preprocessors/dcerpc/smb_andx_decode.h:
    * src/dynamic-preprocessors/dcerpc/smb_andx_structs.h:
    * src/dynamic-preprocessors/dcerpc/smb_structs.h:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.c:
      Fix various bugs relating to unicode, ntohs, bounds-checking,
      and SMB chained AndX commands.
    * src/dynamic-preprocessors/dcerpc/dcerpc_config.c:
      Print out mempcap and max_frag_size on startup.

2006-10-23 Steven Sturges <ssturges@sourcefire.com>
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
      Updated stream4 documentation in the Snort manual to reflect
      new UDP options and inline option updates.  Corrected error with
      event_queue parameter - changed max_events to max_queue.
    * doc/faq.tex:
      Updated FAQ to reflect disuse of ACID in favor of BASE.
      Added references to FLoP and Mudpit as output systems for Snort.
      Added references to two IDS books.
    * doc/README.decode:
      Added README file for the Snort decoder
    * doc/README.stream4:
      Made minor changes to language
    * etc/snort.conf:
      Added commented out decoder options with description -
      enable_decode_oversized_alerts and enable_decode_oversized_drops
    * doc/README.http_inspect:
    * src/preprocessors/HttpInspect/user_interface/hi_ui_config.c:
      Updated tab_uri_delimiter section in document to reflect deprecation.  
      Removed the deprecated tab_uri_delimiter from server profiles since
      it's redundant with whitespace_chars.
    * src/preprocessors/snort_httpinspect.c:
      Allow user-specified ports to override internal defaults.
    * src/detection-plugins/sp_pattern_match.c:
      Fix error message with max pattern size.
    * src/dynamic-preprocessors/dns/spp_dns.c:
    * src/dynamic-preprocessors/dns/spp_dns.h:
      Fix spelling of obsolete in macros.
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
      Fix spelling of DETECT_ANOMALIES macro.
    * src/profiler.c:
      Removed tabs from preprocessor stats output.  Tabs aren't compliant
      with syslog RFC.
    * doc/README.ftptelnet:
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
      Added documentation on Telnet configuration option detect_anomalies
    * src/preprocessors/spp_stream4.c:
      Fixed potential for infinite loop when only part of a packet being
      used in reassembly is ACK'd.
    * src/preprocessors/perf-base.c:
      Fixed packet count stats when in readback mode.

2006-10-13 Steven Sturges <ssturges@sourcefire.com>
    * src/detection-plugins/sp_flowbits.c:
      Fixed an off-by-one error message that prevented the maximum number
      of flowbits from being used.  Include number of flowbits used in
      summary of flowbits usage.
    * src/dynamic-preprocessors/dns/spp_dns.c:
    * src/dynamic-preprocessors/dns/spp_dns.h:
      Fix parser to properly error if misconfigured ports.
    * src/decode.c:
    * src/decode.h:
    * src/parser.c:
      Added new config option "enable_decode_oversized_alerts" and
      "enable_decode_oversized_drops" to allow alerting on packets with
      extra bytes at the end of their payload

2006-10-12 Steven Sturges <ssturges@sourcefire.com>
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
    * RELEASE.NOTES:
      Prepare for 2.6.1 RC.
    * configure.in:
    * src/parser.c:
    * src/snort.c:
    * src/snort.h:
      Start a thread if running in inline mode that passes traffic through
      once pcap is opened and snort is not ready to start inspection (ie,
      loading rules, creating pattern matcher, etc).  Thread is terminated
      when snort is ready to process packets.
      Compiled in via --enable-inline-init-failopen option to configure
      script.  Disable by --disable-inline-init-failopen commandline option or
      'config disable_inline_init_failopen' in snort.conf/user.conf in the
      case that the interface is fail-closed.  Requires libpthread.
    * src/parser.c:
      Require a sid for every rule.
    * src/dynamic-preprocessors/ssh/spp_ssh.c:
      Verifies that the stream preprocessor is enabled.
      Version string bounds checking now uses the length of the version
      string versus the length of the entire payload.
    * src/preprocessors/snort_stream4_udp.c:
      Update UDP session stats (packet count, start/end time, bytes, etc).
    * doc/README.stream4:
    * doc/Makefile.am:
      Finally a description for Stream4.  Thanks Todd!
    * src/parser.c:
    * src/signature.c:
      Allow for variable metadata in rule options.  Ignore unknown metadata
      fields.
    * etc/gen-msg.map:
    * src/decode.c:
    * src/generators.h:
      Added additional TCP length checking and UDP length checking and new
      decode alerts for anomalous lengths.

2006-10-09 Steven Sturges <ssturges@sourcefire.com>
    * src/preprocessors/spp_stream4.c:
      Fix problem with reassembly of server side traffic.  Thanks
      rmkml and Crusoe Researchers for notifying us of the issue.
    * src/preprocessors/spp_stream4.c:
    * src/generators.h:
    * etc/gen-msg.map:
      Fix Stream4 to handle duplicate SYN packets by purging existing
      packets queued for reassembly after the seq of the SYN.  Also,
      properly handle retransmitted data that is overlapping the current
      packet and when trimmed overlapping the next packet.

2006-10-04 Steven Sturges <ssturges@sourcefire.com>
    * src/decode.c:
      Fixed issue in GRE code where data could
      potentially be dereferenced past the end 
      of the packet.
    * src/parser.c:
      Fix log message.
    * src/preprocessors/perf-base.c:
    * src/preprocessors/perf-base.h:
    * src/preprocessors/snort_stream4_session.c:
    * src/preprocessors/snort_stream4_session.h:
    * src/preprocessors/snort_stream4_udp.c:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/stream.h:
      Add stats tracking for UDP sessions to perfmonitor and stream4's
      session stats (keepstats option).  Update Stream4 to purge
      UDP session cache on a timeout basis, similar to the way TCP
      session cache is purged.  Remove cache_clean_percent option.
    * src/dynamic-preprocessors/dcerpc/dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc.h:
    * src/dynamic-preprocessors/dcerpc/smb_andx_decode.c:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.h:
    * src/dynamic-preprocessors/dcerpc/spp_dcerpc.c:
      Fixes for CORE SMB fragmentation.  Also, fix for perf-profiling.

2006-09-27 Steven Sturges <ssturges@sourcefire.com>
    * src/preprocessors/snort_stream4_session.c:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/stream.h:
    * src/sfutil/sfxhash.c:
    * src/sfutil/sfxhash.h:
      Fix issue with use of Stream4 cache_clean_percent option
      that resulted in a segfault when the max session limit was
      reached.  Thanks to Jason Ish for reporting the problem.
    * src/preprocessors/snort_httpinspect.c:
    * src/preprocessors/HttpInspect/include/hi_ui_config.h:
    * src/preprocessors/HttpInspect/user_interface/hi_ui_config.c:
    * doc/README.http_inspect:
      Split the IIS profile in the HTTP inspect preprocessor into
      IIS, ISS4, and ISS5_0.  ISS 4.0 and ISS 5.0  both support double
      decoding, but ISS 5.1 and beyond do not.  Double decoding alerts
      are now disabled in the ISS profile, but remain enabled for the
      IIS 4.0 and IIS 5.0 profiles.  Thanks to Pratap Ramamurthy for
      pointing out that IIS 5.1 does not support double decoding
    * src/snort.c:
    * src/snort.h:
    * src/util.c:
    * src/util.h:
      Fixed issue where iface_ADDRESS variable wasn't getting set before
      configuration file was read. Now all up interfaces will get a
      variable created.  Note that these will NOT get set if the
      readmode flag is set.  Thanks to Paul Melson for reporting the
      problem.
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/stream.h:
      Handle reassembly of first packet for midstream pickups (first packet
      wasn't part of an established session at that point, so some rules
      might fail).
    * src/preprocessors/Stream5/snort_stream5_session.c:
      Fix handling of cache clean by percent.
    * src/detection-plugins/sp_pattern_match.c:
    * src/detection-plugins/sp_pattern_match.h:
      Fix problem with relative options not being marked as relative (for
      distance/within keywords).

2006-09-21 Steven Sturges <ssturges@sourcefire.com>
    * src/generators.h:
    * src/snort.c:
    * src/sfutil/bitop_funcs.h:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Update for GRE additions and compilation on Win32.
    * src/preprocessors/spp_stream4.c:
      Fix issue with alerts missing in DEBUG mode.
    * src/preprocessors/HttpInspect/client/hi_client.c:
    * src/preprocessors/HttpInspect/include/hi_ui_config.h:
      Fix signedness issue that caused HttpInspect to miss certain
      oversized chunk alerts.
    * src/sfutil/ipobj.c:
      Fix parsing that prevented multiple IP lists from being parsed
      correctly.  This fixes a problem with sfportscan configuration when
      'watch_ip', 'ignore_scanners', and 'ignore_scanned' options are
      used together.  Thanks to Rob Sharp and Husnu Demir for reporting
      the bug.

2006-09-18 Steven Sturges <ssturges@sourcefire.com>
    * configure.in:
    * doc/INSTALL:
    * gen-msg.map:
    * src/decode.c:
    * src/decode.h:
    * src/generators.h:
    * src/snort.c:
    * src/snort.h:
    * src/util.c:
    * src/dynamic-plugins/sf_engine/sf_snort_packet.h:
    * src/preprocessors/spp_frag3.c:
    * src/preprocessors/spp_stream4.c:
      Added support to decode GRE encapsulated traffic.  Only IP as transport
      protocol is supported and only one layer of encapsulation will be
      decoded - packets with multiple GRE headers will be discarded.  Thanks
      Todd Wease (and welcome to the Snort team!) for this contribution.
    * configure.in:
    * doc/README.ARUBA:
    * doc/Makefile.am:
    * doc/snort_manual.tex:
    * src/plugbase.c:
    * src/output-plugins/Makefile.am:
    * src/output-plugins/spo_alert_arubaaction.c:
    * src/output-plugins/spo_alert_arubaaction.h:
      Added support for communcation with an Aruba Networks wireless
      mobility authentication/access control system.
    * configure.in:
      GCC 4.x.x has strict aliasing on by default with optimization level 2.
      However, Snort uses aliases in a number of places.  configure now checks
      the gcc compiler version for 4 and disables strict aliasing with
      -fno-strict-aliasing.  Thanks to Ronald Henderson and Keith Konecnik
      for simultaneously (and independently) discovering and reporting this
      issue.

2006-09-15 Steven Sturges <ssturges@sourcefire.com>
    * src/detection-plugins/sp_pattern_match.c:
      Cleanly fail with content patterns that are > 2048 bytes.
    * src/dynamic-preprocessors/dcerpc/dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc_config.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc_util.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc_util.h:
    * src/dynamic-preprocessors/dcerpc/smb_andx_decode.c:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.h:
      Fix memcap to be global.  Turn off memcap alerts by default.
      Add config item to enable alerting on exceeded memcap.
    * src/sfutil/acsmx2.c:
    * src/sfutil/acsmx2.h:
    * src/sfutil/acsmx.c:
    * src/sfutil/mpse.c:
      Code cleanup

2006-09-13 Steven Sturges <ssturges@sourcefire.com>
    * src/decode.c:
    * src/decode.h:
    * src/log.c:
    * src/log.h:
    * src/generators.h:
    * etc/gen-msg.map:
      Added code to print original datagram for all ICMP error types if
      alerted on.
      Fix to print original datagram on alert if original datagram was ICMP.
      Thanks to John Papapanos for pointing out the above 2 issues.
      Added additional decoder alerts for ICMP error types.
      Removed fragtracking of ICMP original datagram - it never made sense
      since only an ICMP response to the first frag is ever returned.
      Fixed issue where data and size pointers were not set correctly for
      ICMP error types.
    * src/dynamic-preprocessors/ftptelnet/ftpp_si.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_si.h:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
      Remove checks for duplicate alerts within a given session, as
      this is now handled within the general alerting mechanism
      and session tracking.
    * src/parser.c:
      When a variable was redefined, a call to LogMessage() was missing a
      parameter.  Thanks to Greg Baran for pointing this out.

2006-09-11 Steven Sturges <ssturges@sourcefire.com>
    * src/dynamic-preprocessors/dcerpc/dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc.h:
    * src/dynamic-preprocessors/dcerpc/dcerpc_util.c:
    * src/dynamic-preprocessors/dcerpc/smb_andx_decode.c:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.c:
      Fix to remove uses of strlen or wcslen.  Properly validate andXOffset.
      Fix bug in DCE/RPC fragment reassembly.

2006-09-07 Steven Sturges <ssturges@sourcefire.com>
    * src/util.c:
      Fix output for the USR1 signal when calculating statistics for
      pcap counts.  Keep a tally of packets seen/dropped/etc and
      use deltas, rather than the 'most recent' value when determining
      percentages after each USR1 signal.  Thanks to Colin Grady for
      pointing out the issue.
    * src/parser.c:
      Allow for a line without an end of line marker in snort.conf.

2006-09-06 Steven Sturges <ssturges@sourcefire.com>
    * src/decode.c:
    * src/detect.c:
    * src/log.c:
    * src/snort.c:
    * src/detection-plugins/sp_respond.c:
    * src/detection-plugins/sp_respond2.c:
    * src/preprocessors/spp_frag2.c:
    * src/preprocessors/spp_frag3.c:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Fix memory leak in ascii and cmg output modules.
      Remove calls to ClearDumpBuf() from related calls
      PrintIPPkt() and PrintNetData(), as it is no longer
      needed.

2006-08-31 Steven Sturges <ssturges@sourcefire.com>
    * rpm/snort.spec:
    * etc/snort.conf:
      Add DNS preprocessor to packaging and config.
    * doc/Makefile.am:
    * doc/README.stream5:
      Add Stream5 README.

2006-08-30 Steven Sturges <ssturges@sourcefire.com>
    * src/sfutil/ipobj.c:
      Additional fix for parsing of IP lists that are not space seperated.
    * src/dynamic-preprocessors/ftptelnet/pp_ftp.c:
      Treat spaces as part of a filename in 'string' parameter validation.
      Thanks Bamm Visscher for pointing out the issue.
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/stream.h:
    * src/preprocessors/snort_stream4_session.c:
    * src/preprocessors/snort_stream4_session.h:
      Remove the ifdef'd splay tree code for packet and session storage.
      It has been replaced by a hash table and is no longer needed.
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/stream.h:
    * src/preprocessors/stream_api.h:
    * src/preprocessors/spp_stream5.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.h:
    * src/preprocessors/Stream5/stream5_common.h:
      Add a few functions to the Stream API to allow a protocol
      analyzer to change the reassembly characteristics (direction,
      flush policy) for an individual session.
    * configure.in:
    * doc/Makefile.am:
    * doc/README.dns:
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
    * etc/gen-msg.map:
    * src/build.h:
    * src/debug.h:
    * src/generators.h:
    * src/dynamic-preprocessors/Makefile.am:
    * src/dynamic-preprocessors/dns/Makefile.am:
    * src/dynamic-preprocessors/dns/sf_preproc_info.h:
    * src/dynamic-preprocessors/dns/spp_dns.c:
    * src/dynamic-preprocessors/dns/spp_dns.h:
      Add a dynamic preprocessor to decode and analyze DNS responses
      over TCP and UDP.  The TCP portion is stateful and requires
      stream is enabled.

2006-08-29 Steven Sturges <ssturges@sourcefire.com>
    * src/detection-plugins/sp_pattern_match.c:
      Fix unchecked free.  Thanks Krzysztof Burghardt for
      pointing out the problem.
    * src/sfutil/acsmx2.c:
      Fixed off by one to sparse index calculation and off by 2 ps
      increment for SparseBands.

200-08-24 Steven Sturges <ssturges@sourcefire.com>
    * src/fpcreate.c:
    * src/sfutil/mpse.c:
    * src/sfutil/Makefile.am:
      Fix issues with using lowmem.  It was reporting an out of
      memory error.  This was broken with the addition of the
      smaller memory Aho-Corasick pattern matcher.

2006-08-17 Steven Sturges <ssturges@sourcefire.com>
    * doc/README.dcerpc:
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
    * etc/snort.conf:
    * src/dynamic-preprocessors/dcerpc/dcerpc_config.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc_util.h:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.h:
      Change config option max_memory to memcap for DCE/RPC.

2006-08-16 Steven Sturges <ssturges@sourcefire.com>
    * src/rules.h:
    * src/detection-plugins/sp_asn1.c:
    * src/detection-plugins/sp_byte_check.c:
    * src/detection-plugins/sp_byte_jump.c:
    * src/detection-plugins/sp_pattern_match.c:
    * src/detection-plugins/sp_pcre.c:
      Resolve issue with rechecking rule options that follow a content or
      PCRE that are relative.  Only recheck if the next option is relative.
      Thanks to Randy Smith for pointing out the issue.
    * configure.in:
      Enable dynamicplugins by default.  Can override
      with --disable-dynamicplugin.
    * snort.8:
    * doc/snort_manual.pdf:
    * doc/snort_manual.tex:
    * doc/Makefile.am:
    * doc/README.ssh:
    * doc/README.dcerpc:
    * etc/snort.conf:
    * src/win32/WIN32-Prj/snort_installer.nsi:
      Added SSH and DCE/RPC preprocessor sections and description of
      new command line options.

2006-08-15 Steven Sturges <ssturges@sourcefire.com>
    * src/dynamic-preprocessors/dcerpc/sf_dcerpc.dsp:
      Remove obsolete file.
    * src/preprocessors/Stream5/Makefile.am:
      Update to include header files.
    * src/preprocessors/Stream5/stream5_common.c:
    * src/preprocessors/flow/flow_cache.c:
    * src/sfutil/util_math.c:
    * src/sfutil/util_math.h:
      Cleanup Win32 warnings.
    * src/sfutil/mpse.c:
    * src/win32/WIN32-Prj/snort.dsp:
    * src/win32/WIN32-Prj/snort.dsw:
      Remove references to MWM and sfksearch.

2006-08-14 Steven Sturges <ssturges@sourcefire.com>
    * configure.in:
    * etc/gen-msg.map:
    * etc/snort.conf:
    * src/detection-plugins/sp_flowbits.c:
    * src/detection-plugins/sp_flowbits.h:
    * src/dynamic-plugins/sf_dynamic_engine.h:
    * src/dynamic-plugins/sp_dynamic.c:
    * src/dynamic-plugins/sp_dynamic.h:
    * src/dynamic-plugins/sf_engine/sf_snort_detection_engine.c:
    * src/dynamic-preprocessors/sf_dynamic_initialize/sf_dynamic_initialize.dsp:
    * src/dynamic-preprocessors/Makefile.am:
    * src/preprocessors/Makefile.am:
    * src/preprocessors/spp_stream5.c:
    * src/preprocessors/spp_stream5.h:
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
    * src/preprocessors/Stream5/snort_stream5_tcp.h:
    * src/preprocessors/Stream5/snort_stream5_udp.c:
    * src/preprocessors/Stream5/snort_stream5_udp.h:
    * src/preprocessors/Stream5/snort_stream5_icmp.c:
    * src/preprocessors/Stream5/snort_stream5_icmp.h:
    * src/preprocessors/Stream5/Makefile.am:
    * src/preprocessors/stream_api.h:
    * src/generators.h:
    * src/plugbase.h:
    * src/Makefile.am:
    * src/plugin_enum.h:
      New target-based Stream module.  Moved flow & flowbits to
      be part of Stream API.
    * src/debug.h:
    * src/generators.h:
    * src/preprocids.h:
    * src/dynamic-preprocessors/Makefile.am:
    * src/dynamic-preprocessors/dcerpc/Makefile.am:
    * src/dynamic-preprocessors/dcerpc/dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc.h:
    * src/dynamic-preprocessors/dcerpc/dcerpc_util.c:
    * src/dynamic-preprocessors/dcerpc/dcerpc_util.h:
    * src/dynamic-preprocessors/dcerpc/dcerpc_config.c:
    * src/dynamic-preprocessors/dcerpc/sf_dcerpc.dsp:
    * src/dynamic-preprocessors/dcerpc/sf_preproc_info.h:
    * src/dynamic-preprocessors/dcerpc/smb_andx_decode.c:
    * src/dynamic-preprocessors/dcerpc/smb_andx_decode.h:
    * src/dynamic-preprocessors/dcerpc/smb_andx_structs.h:
    * src/dynamic-preprocessors/dcerpc/smb_file_decode.c:
    * src/dynamic-preprocessors/dcerpc/smb_file_decode.h:
    * src/dynamic-preprocessors/dcerpc/smb_file_structs.h:
    * src/dynamic-preprocessors/dcerpc/smb_structs.h:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/snort_dcerpc.h:
    * src/dynamic-preprocessors/dcerpc/spp_dcerpc.c:
    * src/dynamic-preprocessors/dcerpc/spp_dcerpc.h:
      New dynamic DCE/RPC protocol normalizer.
    * src/dynamic-preprocessors/Makefile.am:
    * src/dynamic-preprocessors/ssh/sf_ssh.dsp:
    * src/dynamic-preprocessors/ssh/Makefile.am:
    * src/dynamic-preprocessors/ssh/spp_ssh.c:
    * src/dynamic-preprocessors/ssh/spp_ssh.h:
    * src/dynamic-preprocessors/ssh/sf_preproc_info.h:
      New dynamic ssh protocol normalizer.
    * src/detection-plugins/sp_clientserver.c:
    * src/preprocessors/Makefile.am:
    * src/preprocessors/snort_stream4_session.c:
    * src/preprocessors/snort_stream4_udp.c:
    * src/preprocessors/snort_stream4_udp.h:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/stream.h:
      Stream4 UDP session tracking support.  Reassembly performance
      improvements.  Add ability to block TCP sessions.
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.h:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_rc4.c:
      Added RC4 dynamic rule option.
    * src/fpcreate.c:
    * src/fpcreate.h:
    * src/fpdetect.c:
    * src/pcrm.c:
    * src/sfutil/Makefile.am:
    * src/sfutil/bnfa_search.c:
    * src/sfutil/bnfa_search.h:
    * src/sfutil/mpse.c:
    * src/sfutil/mpse.h:
      Added smaller memory consumption pattern matcher.
    * src/decode.h:
    * src/fpdetect.c:
    * src/inline.c:
      Improved handling for stateless rules.
    * configure.in:
    * src/parser.c:
    * src/parser.h:
    * src/rules.h:
    * src/snort.c:
    * src/snort.h:
      Remove use of ifdefs for rule state.
    * src/parser.c:
    * src/snort.c:
    * src/snort.h:
      Add ability to give directory or specific library for dynamic
      engine.
    * src/dynamic-preprocessors/ftptelnet/ftpp_eo_events.h:
    * src/dynamic-preprocessors/ftptelnet/ftpp_eo_log.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_config.h:
    * src/dynamic-preprocessors/ftptelnet/pp_ftp.c:
    * src/dynamic-preprocessors/ftptelnet/pp_telnet.c:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
      Add alerts and normalization for telnet subnegotiation begin
      that doesn't have a matching end.  Could result in an evasion
      over the FTP command channel.
    * src/snort.c:
    * src/snort.h:
    * src/util.c:
      Added counter for segments queued for reassembly.
    * src/snort.c:
    * src/dynamic-plugins/sf_dynamic_detection.h:
    * src/dynamic-plugins/sf_dynamic_engine.h:
    * src/dynamic-plugins/sf_dynamic_plugins.c:
    * src/dynamic-plugins/sf_dynamic_preprocessor.h:
      Improved handling of different versions of same shared library.
    * src/detect.c:
    * src/dynamic-plugins/sf_engine/bmh.c:
    * src/dynamic-plugins/sf_engine/bmh.h:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.c:
    * src/dynamic-preprocessors/smtp/smtp_xlink2state.c:
    * src/dynamic-preprocessors/smtp/snort_smtp.h:
    * src/output-plugins/spo_alert_fast.c:
    * src/preprocessors/spp_frag3.c:
    * src/preprocessors/spp_perfmonitor.c:
    * src/sfutil/acsmx.c:
      Code cleanup, 2.6.1 Beta prep.

2006-08-09 Steven Sturges <ssturges@sourcefire.com>
    * doc/faq.tex:
    * doc/faq.pdf:
      Add information on snort responding to kill signal.

2006-08-02 Steven Sturges <ssturges@sourcefire.com>
    * src/output-plugins/spo_alert_prelude.c:
      Update to provide links to Snort classification reference information.
      Thanks Yoann Vandoorselaere.
    * src/sfutil/ipobj.c:
      Fix parsing of IP lists that are not space seperated.
    * src/configure.in:
      Update for HPUX 11.
    * src/snort.c:
    * src/util.c:
      Fix race condition with daemonization.
    * src/dynamic-plugins/sf_dynamic_plugins.c:
      Update for shared library extensions on HP & MAC.  Thanks J. Aaron
      Pendergrass for raising the HP issues and testing.

2006-07-25 Andrew Mullican
    * src/preprocessors/HttpInspect/client/hi_client.c:
      Fix to HttpInspect to check for non-RFC whitespace (ie, CR) after URI.
    * src/preprocessors/spp_frag3.c:
      Eliminate spurious log messages.

2006-07-20 Steven Sturges <ssturges@sourcefire.com>
    * src/dynamic-preprocessors/smtp/snort_smtp.c:
    * src/dynamic-preprocessors/smtp/snort_smtp.h:
      No longer require HELO (or EHLO) first in an SMTP conversation.
      Some servers (such as ArGoSoft) don't require it.
    * src/dynamic-preprocessors/ftptelnet/pp_telnet.c:
      Handle normalization when Subnegotiation Begin doesn't have a
      matching Subnegotiation End command by normalizing just the
      begin.  Thanks to Pratap Ramamurthy for pointing out the
      potential issue.

2006-07-14 Steven Sturges <ssturges@sourcefire.com>
    * src/decode.h:
    * src/detect.c:
    * src/fpdetect.c:
      Handle pass rule that hits a pipelined URI and an alert
      that matches a secondary pipelined URI.
    * src/preprocessors/spp_frag3.c:
      Fix issue with First policy when dealing with whole overlaps.
      Thanks Russ S for sending in the bug report.
    * src/preprocessors/spp_stream4.c:
      Performance improvement for logging tagged packets.  Thanks Victor
      Julien for pointing out the area for improvement.
    * src/dynamic-preprocessors/smtp/snort_smtp.c:
      Fix potential access violation.

2006-07-12 Steven Sturges <ssturges@sourcefire.com>
    * src/output-plugins/spo_database.c:
      Update to gracefully disconnect from Oracle DB.  Thanks to
      Nikns Siankin for the patch.
    * src/output-plugins/spo_csv.c:
      Fix issue with parsing config other than default.
    * src/decode.c:
    * src/parser.c:
    * src/snort.h:
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
      Change default inline behaviour to not drop packets with decoder
      errors, invalid IP & TCP options and invalid checksums.  Drop
      behaviour can be enabled by using new options, noted in the
      Snort Manual.

2006-06-30 Steven Sturges <ssturges@sourcefire.com>
    * schemas/Makefile.am:
      Add create_db2 srcipt to be included in distro.
    * src/mstring.c:
      Address potential read overflow.
    * src/sfthreshold.c:
    * src/tag.c:
    * src/win32/WIN32-Includes/stdint.h:
    * src/win32/WIN32-Includes/NETINET/IN_SYSTM.h:
      Code cleanup.
    * src/snort.c:
    * src/util.c:
      Fix issue with daemonization on MAC OSX and parent not exiting
      cleanly.
    * src/snort.c:
    * src/snort.h:
    * src/util.c:
    * src/util.h:
    * snort.8:
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
      Provide support for locking the PID file so that no additional snort
      process is able to start using the same PID file.  Can be overridden
      with --nolock-pidfile.
    * src/detection-plugins/sp_pattern_match.c:
      Fix issue with replace option and replaced data always being placed
      at the beginning of the packet.
    * src/dynamic-preprocessors/ftptelnet/pp_ftp.c:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
      Fix issue with parsing default server configuration on Win32 platform.
    * src/dynamic-preprocessors/smtp/smtp_config.c:
    * src/dynamic-preprocessors/smtp/smtp_util.c:
    * src/dynamic-preprocessors/smtp/smtp_util.h:
    * src/dynamic-preprocessors/smtp/snort_smtp.c:
    * src/dynamic-preprocessors/smtp/snort_smtp.h:
    * src/preprocessors/str_search.c:
    * src/preprocessors/str_search.h:
      Fix potential read beyond end of buffer and update configuration to
      use less memory.
    * src/preprocessors/spp_stream4.c:
      Fix reassembly issue.
    * src/preprocessors/snort_httpinspect.c:
    * src/preprocessors/HttpInspect/client/hi_client.c:
    * src/preprocessors/HttpInspect/include/hi_ui_config.h:
    * src/preprocessors/HttpInspect/user_interface/hi_ui_config.c:
      Handle additional whitespace characters on a per server configured
      basis.  Defaults are to treat Htab (\t, 9), VTab (\v, 11),
      Form Feed (\f, 12), and CR (\r, 13) as whitespace.
    * src/sfutil/ipobj.c:
      Revise IP list parsing code.

2006-05-31 Steven Sturges <ssturges@sourcefire.com>
    * src/inline.c:
      Update to handle signals received when no traffic is flowing
      when snort is compiled with inline ipq.  Thanks Victor Julien
      for the patch.
    * configure.in:
      Fix issue with using postgresql and dynamic plugins.
      Thanks Nikns Siankin for pointing out the issue.
    * src/sfutil/ipobj.c:
      Fix problem when parsing multiple hosts in an IP list.

2006-05-24 Steven Sturges <ssturges@sourcefire.com>
    * etc/gen-msg.map:
    * src/generators.h:
    * src/preprocessors/spp_stream4.c:
      Fix potential evasion in Stream4.  Thanks Brandon Franklin for the
      find.
    * src/snort.c:
    * src/parser.c:
    * src/dynamic-plugins/sf_engine/bmh.c:
    * src/preprocessors/HttpInspect/utils/hi_util_hbm.c:
    * src/preprocessors/flow/flow_cache.c:
    * src/preprocessors/flow/portscan/flowps_snort.c:
    * src/sfutil/acsmx2.c:
    * src/sfthreshold.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.c:
    * src/output-plugins/spo_log_tcpdump.c:
    * src/preprocessors/spp_perfmonitor.c:
    * src/preprocessors/spp_sfportscan.c:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/flow/portscan/server_stats.c:
    * src/preprocessors/flow/portscan/server_stats.h:
      Further code review cleanup.  Cleanup possible null pointer
      dereferences, memory leaks, etc.
    * src/preprocessors/HttpInspect/client/hi_client.c:
      Fix to HttpInspect to check for non-RFC whitespace (ie, CR) after URI.
      Thanks to Blake Hartstein for mentioning the problem.

2006-05-17 Steven Sturges <ssturges@sourcefire.com>
    * src/detection-plugins/sp_rpc_check.c:
    * src/dynamic-plugins/sf_engine/bmh.c:
    * src/dynamic-plugins/sf_engine/bmh.h:
    * src/preprocessors/spp_sfportscan.c:
    * src/preprocessors/HttpInspect/user_interface/hi_ui_iis_unicode_map.c:
    * src/preprocessors/HttpInspect/utils/hi_util_hbm.c:
    * src/sfutil/acsmx.c:
    * src/sfutil/event_wrapper.c:
    * src/sfutil/mwm.c:
    * src/sfutil/sfthd.c:
      Further code review cleanup.  Cleanup possible null pointer
      dereferences, memory leaks, etc.
    * src/decode.h:
    * src/preprocessors/spp_frag2.c:
    * src/preprocessors/spp_frag3.c:
    * src/preprocessors/spp_sfportscan.c:
    * src/preprocessors/spp_stream4.c:
      Move SPARC_TWIDDLE to common place.

2006-05-12 Steven Sturges <ssturges@sourcefire.com>
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
    * doc/README.sfportscan:
      Proofreading updates.
    * src/preprocessors/spp_perfmonitor.c:
    * src/preprocessors/perf.c:
    * src/preprocessors/perf.h:
      Correctly close performance stats file on HUP and exit.
    * src/snort.c:
    * src/snort.h:
    * configure.in:
      Signal handler updates for SEGV and HUP.  Define CATCHSEGV in
      snort.c to trap segv signals.  Can also define NOCOREFILE to
      prevent snort from leaving a core file on receipt of a segv.
    * src/parser.c:
      Fix variable definition parsing code to handle user supplied
      value if variable isn't defined.  Thanks to Jeremey Hewlett for
      pointing out the problem.
    * src/snort.c:
    * src/detection-plugins/sp_session.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_si.c:
    * src/output-plugins/spo_csv.c:
    * src/output-plugins/spo_unified.c:
    * src/preprocessors/perf.c:
    * src/preprocessors/perf.h:
    * src/preprocessors/spp_frag3.c:
    * src/preprocessors/spp_perfmonitor.c:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/HttpInspect/utils/hi_util_kmap.c:
    * src/sfutil/mwm.c:
      Further code review cleanup.  Cleanup possible null pointer
      dereferences, memory leaks, etc.

2006-05-01 Steven Sturges <ssturges@sourcefire.com>
    * rpm/snort.spec:
    * etc/snort.conf:
      Include a default path for the dynamicpreprocessors and engine.
    * src/detect.c:
    * src/parser.c:
    * src/pcrm.c:
    * src/sfthreshold.c:
    * src/dynamic-preprocessors/ftptelnet/hi_util_kmap.c:
    * src/output-plugins/spo_csv.c:
    * src/output-plugins/spo_database.c:
    * src/output-plugins/spo_log_tcpdump.c:
    * src/output-plugins/spo_unified.c:
    * src/preprocessors/spp_perfmonitor.c:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/HttpInspect/user_interface/hi_ui_iis_unicode_map.c:
    * src/preprocessors/HttpInspect/utils/hi_util_kmap.c:
    * src/preprocessors/flow/flow_cache.c:
    * src/preprocessors/flow/portscan/server_stats.c:
    * src/sfutil/ipobj.c:
    * src/sfutil/mpse.c:
    * src/sfutil/sfghash.c:
    * src/sfutil/sfksearch.c:
    * src/sfutil/sfxhash.c:
      Code review cleanup.  Cleanup possible null pointer dereferences,
      memory leaks, etc.  Thanks to Adam Keeton (and welcome to the project)!

2006-04-27 Steven Sturges <ssturges@sourcefire.com>
    * RELEASE.NOTES:
      Add information about memory consumption with pattern matching
      engines.
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
      Update to list all options for pattern matching and note that
      Wu-Manber is going to be deprecated.
    * src/util.c:
      Update output info to account for packets buffered by pcap but
      not yet received by snort.  Corrected protocol breakdown.
    * src/output-plugins/spo_database.c:
      Update to correctly strip timestamp precision for MySQL.
      Thanks Axton Grams for the patch and Nikns Siankin and
      Vlatko Kosturjak for testing.
      Update to handle when interface isn't specified in config or
      commandline (finial initialization done post PCAP initialization).
      Thanks Jonathan Miner for pointing out the problem.
    * schemas/create_db2:
      Updated to include gid in schema and version 107 to
      match the other schemas.  Thanks Vlatko Kosturjak for the
      update.
    * src/preprocessors/str_search.c:
    * src/preprocessors/str_search.h:
      Fix compilation problems with Sun CC and others that support C99
      standard.  Thanks Chris Kern for noticing the problem.
    * src/preprocessors/spp_stream4.c:
    * src/sfutil/acsmx2.h:
      Fix compilation problems with Sun CC compiler.

2006-04-11 Steven Sturges <ssturges@sourcefire.com>
    * src/fpdetect.c:
    * src/profiler.h:
    * src/rules.h:
    * src/detection-plugins/sp_flowbits.c:
      Update rule performance profiling to handle flowbits:noalert
      option correctly (it is a match even though there wasn't an
      alert).
    * src/output-plugins/spo_database.c:
      Updates to be ANSI SQL compiliant.  Thanks Vlatko Kosturjak
      for the updates.
    * src/preprocessors/spp_stream4.c:
      Fix incorrectly ignored Reset packets with overlapped/retransmitted
      data.
    * src/inline.c:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/stream.h:
    * src/preprocessors/stream_api.h:
      Allow retransmitted packets through in inline mode if they have not
      been ACK'd by other side.

2006-03-29 Steven Sturges <ssturges@sourcefire.com>
    * src/dynamic-preprocessors/ftptelnet/pp_ftp.c:
      Do not check beyond 4 characters for an FTP command.
    * src/dynamic-preprocessors/smtp/snort_smtp.c:
      Free SMTP session memory.
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/stream.h:
      Updates to previous checks for duplicate alerts.  Better
      performance.  Fix cleanup when stream is flushed.

2006-03-24 Steven Sturges <ssturges@sourcefire.com>
    * src/snort.c:
      Update to fix signal handling issue with libprelude and to
      disable segv signal handler when compiled for Debug mode.
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
      Display warnings with configurations that are required
      for other detection capabilities (ie, normalization is
      required for ayt threshold and encryption detection).
    * src/dynamic-preprocessors/smtp/smtp_config.c:
      Clear default ports if ports are specified.
      Correctly handle specifying valid commands as invalid.
    * src/dynamic-preprocessors/smtp/snort_smtp.c:
      Fix alerts possibly giving incorrect information.
      Move debug code inside DEBUG ifdef; fix possible SEGV in
      debug code. Disable detection for to-be-rebuilt packets.
    * src/preprocessors/spp_frag3.c:
      Correctly calculate the number of preallocated frags when
      preallocating based on a memory limit.
    * configure.in:
    * src/snort.c:
      Remove pcap_setnonblock() call.  Was causing performance
      problems on certain OSs.  Reverts change made with previous
      checkins.
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/stream.h:
    * src/preprocessors/stream_api.h:
    * src/fpdetect.c:
      Fix potential issue for duplicate alerts on the same data in
      the original packet and the Stream reassembled packet.
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
      Proofreading...

2006-03-15 Steven Sturges <ssturges@sourcefire.com>
    * schemas/create_mssql:
    * schemas/create_mysql:
    * schemas/create_oracle.sql:
    * schemas/create_postgresql:
      Updated to include gid in schemas.  Schema version 107.  
      Thanks Nikns Siankin for the updates and all the testing.
    * src/profiler.h:
      Add support for AMD processor.  Thanks Alex Kirk for trying this out.
    * configure.in:
    * src/snort.c:
      Use pcap_setnonblock() if available to help with snort exiting
      on SIGTERM (and others) when no traffic is flowing.
    * src/decode.c:
      Fix pflog decoding for OpenBSD platforms.
    * src/dynamic-plugins/sf_engine/Makefile.am:
    * doc/INSTALL:
      Updates for FreeBSD 6.x compilation.  Thanks Richard Bejtlich for
      testing.
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
      Fixed a few typos and added a warning about the to be deprecated
      telnet decode preprocessor.

2006-03-07 Steven Sturges <ssturges@sourcefire.com>
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
      Fixed potential segfault condition in stateless mode.
    * src/preprocessors/spp_frag3.c:
      Added Fatal error messages for unknown config options.
    * src/snort.c:
    * src/preprocessors/spp_perfmonitor.c:
      Code cleanup

2006-03-02 Steven Sturges <ssturges@sourcefire.com>
    * configure.in:
    * src/output-plugins/spo_alert_prelude.c:
      Additional fixes from Yoann Vandoorselaere.  Require libprelude
      version 0.9.6.
    * src/preprocessors/spp_perfmonitor.c:
      Initialize the pcap counters the first time we get a packet.
    * src/fpdetect.c:
      Fix leaking of classification info between rules and
      preprocessor/decoder alerts.

2006-02-28 Steven Sturges <ssturges@sourcefire.com>
    * src/dynamic-preprocessors/Makefile.am:
      Install required header files when --enable-dynamicplugin used
      with configure.
    * src/preprocessors/spp_stream4.c:
      If ignoring a packet because it is a duplicate (retransmitted),
      drop it if in inline mode.  Original packet was either dropped
      or passed through.

2006-02-27 Steven Sturges <ssturges@sourcefire.com>
    * src/detection-plugion/sp_flowbits.c:
      Update parsing to handle spaces and correct keyword checking.

2006-02-23 Steven Sturges <ssturges@sourcefire.com>
    * src/snort.c:
    * src/snort.h:
    * src/fpdetect.c:
    * src/parser.c:
    * src/event_queue.h:
    * doc/README:
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
    * snort.8:
      Changed command line options --flush-all-events to --process-all-events
      and --alert-on-drop to --treat-drop-as-alert.  Updated docs/manpage.
    * src/output-plugins/spo_unified.c:
      Fix unified log file rollover to correctly write magic numbers.
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
    * src/dynamic-preprocessors/ftptelnet/ftp_bounce_lookup.c:
      Update some comments relative to endianness.
    * src/dynamic-preprocessors/smtp/snort_smtp.c:
    * src/dynamic-preprocessors/smtp/spp_smtp.c:
      Fix issues with SMTP preprocessor causing rules to not fire.
      Thanks Andy Mullican for the fix.

2006-02-22 Steven Sturges <ssturges@sourcefire.com>
    * src/preprocessors/spp_frag3.c:
    * doc/README.frag3:
      Added option to preallocate frags based on a memcap (combination
      of memcap and prealloc_frags options).  Perform preallocation
      post-pcap open because of memory issues with certain versions
      of pcap.

2006-02-21 Steven Sturges <ssturges@sourcefire.com>
    * src/output-plugins/spo_alert_prelude.c:
      packet_to_data()
      Standardize AdditionalData fields name. Support more packet fields,
      remove unused one. Send rule revision and TCP/IP options code/value
      as AdditionalData.  Thanks Yoann Vandoorselaere for the updates.
      event_to_reference()
      Double check that system->url is not NULL.
      Support ICMP headers, patch from Andrea Barisani.
    * src/snort.c:
    * src/snort.h:
    * src/util.c:
      Updates to signal handlers to better deal with reentrant
      issues in syslog and libc.
    * src/dynamic-plugins/sf_dynamic_plugins.c:
      Print warning if dynamic library directory doesnt exist or is empty.
      Thanks Andy Mullican for the fix.

2006-02-20 Steven Sturges <ssturges@sourcefire.com>
    * src/sfutil/sfeventq.c:
      Fix issue when more than max events are added to event queue.
    * src/parser.c:
    * src/plugbase.c:
    * src/plugbase.h:
    * src/snort.c:
    * src/output-plugins/spo_unified.c:
    * src/output-plugins/spo_log_tcpdump.c:
      Fix issue with output plugins that depend on datalink and
      snaplen (which are set in OpenPcap).  Caused by reordering
      of initialization on 2006-01-26.  Thanks Matt Bedynek and
      Jeremy Hewlett for the find.

2006-02-17 Steven Sturges <ssturges@sourcefire.com>
    * doc/INSTALL:
      Updated to include current options and added a
      section for compilation on MAC OSX.
    * src/signature.c:
      Strip whitespaces from reference system and id. This fixes a
      reference lookup problem resulting in an invalid URL in case
      the reference begins with a space character (example:
      reference: x,y; would fail).  Thanks Yoann Vandoorselaere
      for the patch.

2006-02-16 Steven Sturges <ssturges@sourcefire.com>
    * src/preprocessors/spp_frag3.c:
      Fix ip options handling.  Thanks to Vyacheslav Burdjanadze for
      finding the issue.
    * src/dynamicpreprocessors/ftptelnet/snort_ftptelnet.c:
      Fix processing of configuration without options.
    * src/snort.c:
      Fix OpenPcap merge issue.

2006-02-15 Steven Sturges <ssturges@sourcefire.com>
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
      Update perfmonitor section.  Thanks to Passreality for
      pointing out the omissions.
    * src/preprocessors/spp_stream4.c:
      Only increment memory counter once per allocation.

2006-02-14 Steven Sturges <ssturges@sourcefire.com>
    * doc/snort_manual.tex:
    * doc/snort_manual.pdf:
      Updates to manual for 2.6.0
    * src/win32/WIN32-Prj/snort.dsp:
      Added missing files.

2006-02-13 Steven Sturges <ssturges@sourcefire.com>
    * src/parser.c:
      Handle longer lines for config
    * src/sfutil/acsmx2.c:
      Change visual name of Aho-Corasick sparse bands.
    * src/preprocessors/spp_frag3.c:
      When a timeout occurs on a Fragmented session, purge the existing
      fragments and treat it as a new session.  Allows for proper
      defragmentation, per OS target configuration.

2006-02-09 Steven Sturges <ssturges@sourcefire.com>
    * src/util.c:
      Fix -M flag to log Fatal and regular Error messages to syslog as
      well.  Thanks Andy Mullican.
    * snort.8:
    * doc/README:
    * src/snort.c:
      Add info on additional commandline switches.
    * src/preprocessors/spp_stream4.c:
      Fix compilation issue on some platforms.

2006-02-08 Steven Sturges <ssturges@sourcefire.com>
    * src/parser.c:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
    * src/dynamic-preprocessors/ftptelnet/spp_ftptelnet.c:
      Allow default configuration without options

2006-02-06 Steven Sturges <ssturges@sourcefire.com>
    * etc/snort.conf:
    * src/dynamic-examples/dynamic-preprocessor/Makefile.am:
    * src/dynamic-examples/dynamic-rule/Makefile.am:
    * src/dynamic-plugins/sf_engine/Makefile.am:
    * src/dynamic-preprocessors/ftptelnet/Makefile.am:
    * src/dynamic-preprocessors/smtp/Makefile.am:
      Add info to snort.conf on how to load dynamic libraries
      and update Makefiles to use path similar t othat of
      snort.conf.
    * src/parser.c:
      Fixed error message when dynamic<xxx> token is used.

2006-02-03 Steven Sturges <ssturges@sourcefire.com>
    * src/dynamic-examples/dynamic-preprocessor/Makefile.am:
    * src/dynamic-examples/dynamic-rule/Makefile.am:
    * src/dynamic-plugins/sf_engine/Makefile.am:
    * src/dynamic-preprocessors/ftptelnet/Makefile.am:
    * src/dynamic-preprocessors/smtp/Makefile.am:
    * src/dynamic-plugins/sf_dynamic_plugins.c:
      Fix installation directories
    * src/preprocessors/Makefile.am:
    * src/preprocessors/stream_api.h:
    * src/preprocessors/stream_api.c:
      Fixes for MacOS X compilation.

2006-02-02 Steven Sturges <ssturges@sourcefire.com>
    * src/detect.c:
    * src/event_queue.c:
    * src/event_queue.h:
    * src/fpdetect.c:
    * src/parser.c:
    * src/snort.c:
    * src/snort.h:
    * src/sfutil/sfeventq.c:
      Changed rule ordering to better handle drop and pass rules
      when other alerts trigger on the same packet.  Thanks Marc
      Norton for the changes.
    * src/profiler.c:
    * src/profiler.h:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.h:
      Win32 fixes.
    * src/snort.c:
      Fix SigHup processing.
    * src/util.c:
      Code Cleanup.
    * src/detection-plugins/sp_pattern_match.c:
      Return non-zero when search goes out-of-bounds.
    * src/preprocessors/snort_httpinspect.c:
      Fix from Chris Sherwin for pipelined requests.
    * src/preprocessors/spp_frag3.c:
      Change noisy LogMessage to Debug.

2006-01-30 Steven Sturges <ssturges@sourcefire.com>
    * src/dynamic-plugins/sf_engine/sf_snort_detection_engine.c:
    * src/dynamic-plugins/sf_engine/sf_snort_packet.h:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.h:
      Include config.h if required.
    * configure.in:
    * src/Makefile.am:
    * src/dynamic-examples/.cvsignore:
    * src/dynamic-examples/Makefile.am:
    * src/dynamic-examples/dynamic-preprocessor/.cvsignore:
    * src/dynamic-examples/dynamic-preprocessor/Makefile.am:
    * src/dynamic-examples/dynamic-preprocessor/sf_preproc_info.h:
    * src/dynamic-examples/dynamic-preprocessor/spp_example.c:
    * src/dynamic-examples/dynamic-rule/.cvsignore:
    * src/dynamic-examples/dynamic-rule/Makefile.am:
    * src/dynamic-examples/dynamic-rule/detection_lib_meta.h:
    * src/dynamic-examples/dynamic-rule/rules.c:
    * src/dynamic-examples/dynamic-rule/sid109.c:
    * src/dynamic-examples/dynamic-rule/sid637.c:
      Added examples for manual of dynamic preprocessor and dynamic rule
      library.
    * src/dynamic-preprocessors/ftptelnet/Makefile.am:
    * src/dynamic-preprocessors/smtp/Makefile.am:
      More fixes to cleanup.

2006-01-26 Steven Sturges <ssturges@sourcefire.com>
    * src/preprocessors/spp_stream4.c:
      Fixed a few retranmission alerts that are not toggled
      off by diasble_evasion_alerts config.
    * src/parser.c:
    * src/snort.c:
    * src/snort.h:
    * src/util.c:
    * src/util.h:
      Addressed some startup issues when running daemon mode.
      Configuration is validated prior to daemonizing, therefore
      if config errors exist, snort will exit, returning error to
      initialization script/process.  Parent process doesn't exit
      until config file is read and a child is forked and has
      created its pid file.  Thanks to Marc Norton and Chris Sherwin
      for their work on this.
      Fixed issue with opening pcap prior to reading it from a
      config file.  Thanks Martin Olsson for noting this.
    * src/dynamic-preprocessors/Makefile.am:
    * src/dynamic-preprocessors/smtp/Makefile.am:
    * src/dynamic-preprocessors/ftptelnet/Makefile.am:
      Fixed builds on FreeBSD.

2006-01-24 Steven Sturges <ssturges@sourcefire.com>
    * src/win32/Makefile.am:
      Win32 Updates.
    * doc/Makefile.am:
      Added files.
    * src/win32/WIN32-Prj/snort.dsp:
      Removed deprecated src files.
    * src/win32/WIN32-Prj/snort_installer.nsi:
      Added dynamic modules, updated version number.

2006-01-23 Steven Sturges <ssturges@sourcefire.com>
    * src/preprocessors/spp_flow.c:
      Fixed error message when parsing flow configuration.
    * src/snort.c:
    * src/snort.h:
      Fixed issue with creating PID files.
    * src/util.c:
      Fixed issue with DropStats and unopened pcap.
    * src/Makefile.am:
    * src/dynamic-plugins/Makefile.am:
    * src/dynamic-plugins/sf_engine/Makefile.am:
    * src/dynamic-preprocessors/Makefile.am:
    * src/dynamic-preprocessors/smtp/Makefile.am:
    * src/dynamic-preprocessors/ftptelnet/Makefile.am:
    * src/sfutil/Makefile.am:
      Updates to handle make dist and make distcheck.
      Win32 Updates.

2006-01-20 Steven Sturges <ssturges@sourcefire.com>
    * schemas/create_mysql:
    * src/output-plugins/spo_database.c:
      Updated to write GID when logging events.  Thanks to Graham Keeling
      for the patch and Kevin Johnson for helping test.
    * src/snort.c:
    * doc/README:
    * snort.8:
      Added info on new command line options.
    * src/snort.c:
      Updated CreatePidFile to use interface name if available when in
      inline mode (and using a bridging interface).

2006-01-19 Steven Sturges <ssturges@sourcefire.com>
    * src/util.c:
      Updated Timestats to print packet stats per hour and breakdown
      per protocol.  Thanks Bill Parker for the update.  To use this
      feature, use --enable-timestats.
    * src/sfutil/sfthd.c:
      Fix parameter ordering in test routine.  Thanks Yin Zhaohui for the find.
    * src/detect.c:
      Fixed DEBUG_WRAP statement.  Thanks Yin Zhaohui for pointing this out.

2006-01-19 Steven Sturges <ssturges@sourcefire.com>
    * autojunk.sh:
    * configure.in:
      Added use of libtool to build dynamically loadable modules,
      --enable-dynamicplugin.  
      Added performance profiling, --enable-perfprofiling.
      Added separation of rules being enabled from them appearing in
      snort.conf, --enable-rulestate.  
      Added pthread linkage, --enable-pthread.
    * src/win32/WIN32-Prj/snort.dsp:
    * src/win32/WIN32-Prj/snort.dsw:
    * src/win32/WIN32-Prj/build_all.dsp:
      Added dynamically loadable modules and updated workspace for
      other project files (new preprocessors, DLLs, and utility project
      to build everything).
    * RELEASE.NOTES:
    * doc/Makefile.am:
    * doc/README:
      Updated for new files and 2.6.0 release preparation.
    * doc/README.PerfProfiling:
    * src/profiler.c:
    * src/profiler.h:
      Added performance profiling metrics.  Can measure both rules
      and preprocessor performance.  Enable via --enable-perfprofiling.
      See profiler.h for MACROs to use and various preprocessors for
      examples.
    * doc/README.SMTP:
    * src/dynamic-preprocessors/smtp/.cvsignore:
    * src/dynamic-preprocessors/smtp/Makefile.am:
    * src/dynamic-preprocessors/smtp/sf_preproc_info.h:
    * src/dynamic-preprocessors/smtp/sf_smtp.dsp:
    * src/dynamic-preprocessors/smtp/smtp_config.c:
    * src/dynamic-preprocessors/smtp/smtp_config.h:
    * src/dynamic-preprocessors/smtp/smtp_log.c:
    * src/dynamic-preprocessors/smtp/smtp_log.h:
    * src/dynamic-preprocessors/smtp/smtp_normalize.c:
    * src/dynamic-preprocessors/smtp/smtp_normalize.h:
    * src/dynamic-preprocessors/smtp/smtp_util.c:
    * src/dynamic-preprocessors/smtp/smtp_util.h:
    * src/dynamic-preprocessors/smtp/smtp_xlink2state.c:
    * src/dynamic-preprocessors/smtp/smtp_xlink2state.h:
    * src/dynamic-preprocessors/smtp/snort_smtp.c:
    * src/dynamic-preprocessors/smtp/snort_smtp.h:
    * src/dynamic-preprocessors/smtp/spp_smtp.c:
    * src/dynamic-preprocessors/smtp/spp_smtp.h:
    * src/preprocessors/spp_xlink2state.c (removed):
    * src/preprocessors/spp_xlink2state.h (removed):
    * src/preprocessors/xlink2state.c (removed):
    * src/preprocessors/xlink2state.h (removed):
      Added dynamically loadable SMTP preprocessor.  Thanks Andy Mullican
      for the work and research.  Renders xlink2state mini preprocessor
      defunct.
    * doc/README.ftptelnet:
    * src/dynamic-preprocessors/ftptelnet/.cvsignore:
    * src/dynamic-preprocessors/ftptelnet/Makefile.am:
    * src/dynamic-preprocessors/ftptelnet/ftp_bounce_lookup.c:
    * src/dynamic-preprocessors/ftptelnet/ftp_bounce_lookup.h:
    * src/dynamic-preprocessors/ftptelnet/ftp_client.h:
    * src/dynamic-preprocessors/ftptelnet/ftp_cmd_lookup.c:
    * src/dynamic-preprocessors/ftptelnet/ftp_cmd_lookup.h:
    * src/dynamic-preprocessors/ftptelnet/ftp_server.h:
    * src/dynamic-preprocessors/ftptelnet/ftpp_eo.h:
    * src/dynamic-preprocessors/ftptelnet/ftpp_eo_events.h:
    * src/dynamic-preprocessors/ftptelnet/ftpp_eo_log.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_eo_log.h:
    * src/dynamic-preprocessors/ftptelnet/ftpp_include.h:
    * src/dynamic-preprocessors/ftptelnet/ftpp_return_codes.h:
    * src/dynamic-preprocessors/ftptelnet/ftpp_si.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_si.h:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_client_lookup.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_client_lookup.h:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_config.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_config.h:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_server_lookup.c:
    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_server_lookup.h:
    * src/dynamic-preprocessors/ftptelnet/ftpp_util_kmap.h:
    * src/dynamic-preprocessors/ftptelnet/hi_util_kmap.c:
    * src/dynamic-preprocessors/ftptelnet/hi_util_kmap.h:
    * src/dynamic-preprocessors/ftptelnet/hi_util_xmalloc.c:
    * src/dynamic-preprocessors/ftptelnet/hi_util_xmalloc.h:
    * src/dynamic-preprocessors/ftptelnet/pp_ftp.c:
    * src/dynamic-preprocessors/ftptelnet/pp_ftp.h:
    * src/dynamic-preprocessors/ftptelnet/pp_telnet.c:
    * src/dynamic-preprocessors/ftptelnet/pp_telnet.h:
    * src/dynamic-preprocessors/ftptelnet/sf_ftptelnet.dsp:
    * src/dynamic-preprocessors/ftptelnet/sf_preproc_info.h:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.h:
    * src/dynamic-preprocessors/ftptelnet/spp_ftptelnet.c:
    * src/dynamic-preprocessors/ftptelnet/spp_ftptelnet.h:
    * src/preprocessors/spp_telnet_negotiation.c:
      Added dynamically loadable FTP/Telnet preprocessor.  Thanks
      Steven Sturges for the work and research.  Replaces telnet
      decoder.
    * doc/README.sfportscan:
    * src/preprocessors/spp_sfportscan.c:
      Updated for preprocessor protocol ordering. 
      Added performance measurements.
      Added ACK scan detection and false positive prevention with
      sessions picked up midstream and dropped packets.
    * etc/gen-msg.map:
    * etc/generators:
    * src/generators.h:
      Added generator IDs for new preprocessors.
    * etc/snort.conf:
      Added examples for new preprocessors
    * src/Makefile.am:
      Added performance metric modules, new subdirs.
    * src/build.h:
      Seperated build version from snort.h.
    * src/debug.h:
      Added new preprocessors.
    * src/decode.c:
    * src/detect.c:
      Performance measurments of packet decoder, detection, rule evaluation
      and preprocessors.
    * src/decode.h:
    * src/detect.h
      Change to use dynamicly sized preprocessor array since more than 32
      preprocessors may be loaded.
    * src/inline.c:
    * src/inline.h:
      Updated to always set drop flag for packets that are dropped
      for logging purposes.
    * src/plugbase.c:
    * src/plugbase.h:
    * src/plugin_enum.h:
    * src/preprocids.h:
      Support for new preprocessors, added checks to verify preprocessor
      configuration.  Removed deprecated preprocessors.  Added cleanup
      and shutdown functionality for preprocessors.  Move preprocessor
      bitmasks from plugbase.h into preprocids.h.  Added protocol stack
      based ordering of preprocessors, so that IP-layer preprocessors are
      run before TCP/UDP layer ones.
    * src/snort.c:
    * src/snort.h:
      Added longname option support.  Added dynamic module commandline
      options, see README for details.  Updated signal handling and
      exit/restart code.  Switched to using pcap_dispatch from pcap_loop
      for better control of packet processing.  Added performance measurements.
      Fixed -T flag and commandline help functionality.  Added -M flag
      to write messages/warnings to syslog (doesn't write alert data there)
      when not in daemon mode.
    * src/tag.c:
      Put limit on tagging to alleviate overloaded databases that result
      in every packet being tagged on high bandwidth sensors.  Prevents
      database DoS with tagging rules.
    * src/util.c:
    * src/util.h:
      Fixed issue with reentrant signal handlers.  At exit because of signal,
      snort now logs to snort_exit file instead of syslog.  Updated pid
      file creation when in Inline mode.
    * src/detection-plugins/Makefile.am:
    * src/detection-plugins/sp_asn1.c
    * src/detection-plugins/sp_asn1_detect.c:
    * src/detection-plugins/sp_asn1_detect.h:
    * src/detection-plugins/sp_urilen_check.c:
    * src/detection-plugins/sp_urilen_check.h:
      Modularized ASN1 detection code.
      Added URI Length check rule keyword.  Thanks to Chris Sherwin
      for the new functionality.
    * src/dynamic-plugins/.cvsignore:
    * src/dynamic-plugins/Makefile.am:
    * src/dynamic-plugins/sf_dynamic_common.h:
    * src/dynamic-plugins/sf_dynamic_detection.h:
    * src/dynamic-plugins/sf_dynamic_engine.h:
    * src/dynamic-plugins/sf_dynamic_meta.h:
    * src/dynamic-plugins/sf_dynamic_plugins.c:
    * src/dynamic-plugins/sf_dynamic_preprocessor.h:
    * src/dynamic-plugins/sp_dynamic.c:
    * src/dynamic-plugins/sp_dynamic.h:
    * src/dynamic-plugins/sp_preprocopt.c:
    * src/dynamic-plugins/sp_preprocopt.h:
    * src/dynamic-plugins/sf_engine/.cvsignore:
    * src/dynamic-plugins/sf_engine/Makefile.am:
    * src/dynamic-plugins/sf_engine/bmh.c:
    * src/dynamic-plugins/sf_engine/bmh.h:
    * src/dynamic-plugins/sf_engine/sf_snort_detection_engine.c:
    * src/dynamic-plugins/sf_engine/sf_snort_packet.h:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.h:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_byte.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_content.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_hdropts.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_loop.c:
    * src/dynamic-plugins/sf_engine/sf_snort_plugin_pcre.c:
    * src/win32/WIN32-Prj/sf_engine.dsp:
    * src/rules.h:
      Added dynamically loadable rule detection capability.  
      Can write compiled rules that are "blackboxed", yet still loaded
      at runtime.  Thanks Andy Mullican, Steven Sturges and Marc Norton.
    * src/fpcreate.c:
    * src/fpcreate.h:
    * src/fpdetect.c:
      Performance measurments, added support for dynamic rule detection,
      and fix issue with non-content rules not being evaluated.
    * src/parser.c:
    * src/parser.h:
      Added dynamic rule and preprocessor parsing, rule state parsing,
      performance profiling parsing.
    * src/signature.c:
    * src/signature.h:
      Added 'gid' and 'metadata' fields to rules.
    * src/detection-plugins/sp_pcre.c:
      Provide ability to turn off PCRE checks via config nopcre.
    * src/dynamic-plugins/sf_preproc_example/sf_dynamic_preproc_lib.c:
    * src/dynamic-plugins/sf_preproc_example/sf_dynamic_preproc_lib.h:
    * src/dynamic-preprocessors/.cvsignore:
    * src/dynamic-preprocessors/Makefile.am:
    * src/dynamic-preprocessors/dynamic_preprocessors.dsp:
    * src/dynamic-preprocessors/initialize_headers.sh:
    * src/dynamic-preprocessors/sf_dynamic_initialize/.cvsignore:
    * src/dynamic-preprocessors/sf_dynamic_initialize/sf_dynamic_initialize.dsp:
      Added dynamically loadable preprocessor support.  Simplifies
      development of preprocessors for quicker release of new preprocessor
      code.  Thanks Andy Mullican, Steven Sturges and Marc Norton.
    * src/preprocessors/perf-base.c:
    * src/preprocessors/perf-base.h:
    * src/preprocessors/perf.c:
      Added metric for inline blocked packets.
    * src/preprocessors/perf-flow.c:
    * src/preprocessors/perf-flow.h:
      Added better performance tracking for flow data for ports under 1024
      and those above.
    * src/preprocessors/portscan.c:
      Added code to ignore certain ports.  Added performance measurements.
    * src/preprocessors/snort_httpinspect.c:
      Updated for stream API.  Added performance measurements.
    * src/preprocessors/spp_frag2.c:
      Updated for preprocessor protocol ordering. 
      To be deprecated in next release.  Added performance measurements.
    * src/preprocessors/spp_arpspoof.c:
    * src/preprocessors/spp_bo.c:
    * src/preprocessors/spp_flow.c:
    * src/preprocessors/spp_frag3.c:
    * src/preprocessors/spp_httpinspect.c:
    * src/preprocessors/spp_perfmonitor.c:
    * src/preprocessors/spp_rpc_decode.c:
    * src/preprocessors/spp_sfportscan.c:
      Updated for preprocessor protocol ordering. 
      Added performance measurements.
    * src/preprocessors/Makefile.am:
    * src/preprocessors/spp_portscan.c (removed):
    * src/preprocessors/spp_portscan.h (removed):
    * src/preprocessors/spp_portscan2.c (removed):
    * src/preprocessors/spp_portscan2.h (removed):
    * src/preprocessors/spp_conversation.c (removed):
    * src/preprocessors/spp_conversation.h (removed):
      Deprecated old portscan preprocessors.
    * src/preprocessors/str_search.c:
    * src/preprocessors/str_search.h:
      Modularized this code for use by the dynamic SMTP preprocessor.
    * src/detection-plugins/sp_flowbits.c:
    * src/detection-plugins/sp_flowbits.h:
    * src/event_wrapper.c:
    * src/output-plugins/spo_alert_sf_socket.c:
    * src/output-plugins/spo_log_tcpdump.c:
    * src/output-plugins/spo_unified.c:
    * src/preprocessors/stream.h:
    * src/preprocessors/stream_api.h:
    * src/preprocessors/stream_ignore.c:
    * src/preprocessors/stream_ignore.h:
    * src/preprocessors/snort_stream4_session.c:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/spp_stream4.h:
      Added api for Stream4 to help with development of next generation
      Stream processing.  Flowbits are now stored as part of the Stream.
      Updated output plugins to use Stream api for logging reassembled
      packets.  Added performance measurements.
    * src/sfutil/Makefile.am:
    * src/sfutil/getopt.h:
    * src/sfutil/getopt1.h:
    * src/sfutil/getopt_long.c:
      Added longname commandline option support.
    * src/sfutil/ipobj.c:
    * src/sfutil/ipobj.h:
      Updated IP Set to include port sets.
    * src/sfutil/mpse.c:
      Added performance measurements.
    * src/snort_packet_header.h:
    * src/win32/WIN32-Includes/libnet/gnuc.h:
    * src/debug.c:
    * src/detection-plugins/sp_pattern_match.c:
    * src/output-plugins/spo_alert_prelude.c:
    * src/preprocessors/flow/flow_cache.c:
    * src/preprocessors/flow/portscan/flowps.c:
    * src/preprocessors/flow/portscan/flowps_snort.c:
    * src/preprocessors/flow/portscan/server_stats.c:
    * src/sfutil/bitop.h:
    * src/sfutil/bitop_funcs.h:
    * src/sfutil/mwm.h:
    * src/sfutil/sfghash.h:
    * src/sfutil/sfksearch.c:
    * src/sfutil/sfksearch.h:
    * src/.cvsignore:
      Misc code cleanup.

2006-01-09 Steven Sturges <ssturges@sourcefire.com>
    * src/sfutil/mwm.c:
      Fixed bug with multiple recurring patterns in Wu-Manbher implementation.
      Thanks to Evan Stawnyczy for pointing it out and Marc Norton for the
      fix.
    * src/parser/IpAddrSet.c:
      Fixed problem with parsing conf file and rules when DNS is not working.
      Thanks Martin Olsson for mentioning this and testing the fix.
    * src/preprocessors/spp_perfmonitor.c:
    * src/preprocessors/perf-base.c:
      Handle wrapping on 64-bit platforms

2005-11-17 Andrew Mullican <amullican@sourcefire.com>
    * src/sfutil/sfxhash.c:
    * src/preprocessors/portscan.c:
      Add tracker without using bogus data, to avoid internal buffer overrun.
      Thanks Sandro Poppi for the find.

2005-11-11 Steven Sturges <ssturges@sourcefire.com>
    * src/snort.c:
      Allow value of 0 to be used with -G flag
    * src/preprocessors/spp_bo.c:
      Code Cleanup
    * src/preprocessors/spp_frag3.c:
      Fix memory leak and mishandling of IP Options.  Thanks Yin
      Zhaohui for the find.

2005-10-16 Steven Sturges <ssturges@sourcefire.com>
    * etc/gen-msg.map:
    * etc/snort.conf:
    * src/generators.h:
    * src/preprocessors/spp_bo.c:
      Fixed potential buffer overflow in BackOrifice preprocessor and
      added an alert on attempt to overflow buffer in snort.  Thanks
      Andy Mullican for the fix.

2005-10-11 Steven Sturges <ssturges@sourcefire.com>
    * src/win32/WIN32-Prj/snort_installer.nsi:
      Updated to mention WinPCAP 3.1 with correct website.  Thanks
      Gianluca Varenni for mentioning the discrepancy.

2005-10-04 Steven Sturges <ssturges@sourcefire.com>
    * src/win32/WIN32-Libraries/libnet/LibnetNT.lib:
    * src/win32/WIN32-Prj/LibnetNT.dll:
      Rebuilt and updated LibnetNT linked with WinPCAP 3.1.

2005-09-23 Steven Sturges <ssturges@sourcefire.com>
    * src/output-plugins/spo_log_database.c:
    * schemas/create_mysql:
      Fixes to address schema being a keyword in MySQL 5.0.  Thanks Wes Young,
      Adolfo Gomez, and Aleem Mawji for the updates.

2005-09-19 mfr <roesch@sourcefire.com>
    * src/output-plugins/spo_log_tcpdump.c:
      don't try to actually open the log file when in test mode

2005-09-19 Steven Sturges <ssturges@sourcefire.com>
    * src/win32/WIN32-Includes/NETINET/IP.H:
    * src/win32/WIN32-Includes/NETINET/IP_VAR.H:
    * src/win32/WIN32-Includes/libnet/LibnetNT.h:
      Always use winsock2.h

2005-09-16 mfr <roesch@sourcefire.com>
    * src/snort.c:
      New command line switch, -K, to explicitly set logging mode.  Available
      arguments are "none", "pcap" and "ascii".
      Pcap mode is now the default logging mode of Snort.
      CheckLogDir() is no longer called in IDS mode until after reading in
      the snort.conf file to prevent unncessary exiting due to logdir being
      specified in snort.conf and inadvertantly checking for the existence
      of /var/log/snort.
    * src/util.c:
      Included CheckLogDir() call in CreatePidFile() on the off chance
      we have to fall back to using pv.log_dir which can happen due to
      the IDS mode logdir check being removed in src/snort.c
    * src/decode.c:
      Added check for bad length of TCP SACK option.
    * snort.8:
      Updated for -K command line switch
    * doc/README:
      Updated for new command line options and default logging mode.

2005-09-16 Steven Sturges <ssturges@sourcefire.com>
    * src/preprocessors/spp_frag3.c:
      Additional fixes to better handle various targets and extensions to
      the Shankar/Paxson model.  Thanks Judy Novak for all of the OS
      testing & pcap work.

2005-09-14 Andrew Mullican <amullican@sourcefire.com>
    * etc/gen-msg.map
    * src/generators.h
    * src/preprocessors/spp_rpc_decode.c:
      Added new alert on zero-length RPC fragment.

2005-09-14 Steven Sturges <ssturges@sourcefire.com>
    * src/win32/WIN32-Includes/pcap-namedb.h (removed):
    * src/win32/WIN32-Includes/pcap.h (removed):
    * src/win32/WIN32-Includes/WinPCAP/Devioctl.h:
    * src/win32/WIN32-Includes/WinPCAP/Gnuc.h:
    * src/win32/WIN32-Includes/WinPCAP/Ntddndis.h:
    * src/win32/WIN32-Includes/WinPCAP/Ntddpack.h:
    * src/win32/WIN32-Includes/WinPCAP/Packet32.h:
    * src/win32/WIN32-Includes/WinPCAP/Win32-Extensions.h:
    * src/win32/WIN32-Includes/WinPCAP/bittypes.h:
    * src/win32/WIN32-Includes/WinPCAP/bucket_lookup.h:
    * src/win32/WIN32-Includes/WinPCAP/count_packets.h:
    * src/win32/WIN32-Includes/WinPCAP/ip6_misc.h:
    * src/win32/WIN32-Includes/WinPCAP/memory_t.h:
    * src/win32/WIN32-Includes/WinPCAP/normal_lookup.h:
    * src/win32/WIN32-Includes/WinPCAP/pcap-bpf.h:
    * src/win32/WIN32-Includes/WinPCAP/pcap-int.h:
    * src/win32/WIN32-Includes/WinPCAP/pcap-stdinc.h:
    * src/win32/WIN32-Includes/WinPCAP/pcap.h:
    * src/win32/WIN32-Includes/WinPCAP/pthread.h:
    * src/win32/WIN32-Includes/WinPCAP/remote-ext.h:
    * src/win32/WIN32-Includes/WinPCAP/sched.h:
    * src/win32/WIN32-Includes/WinPCAP/semaphore.h:
    * src/win32/WIN32-Includes/WinPCAP/tcp_session.h:
    * src/win32/WIN32-Includes/WinPCAP/time_calls.h:
    * src/win32/WIN32-Includes/WinPCAP/tme.h:
    * src/win32/WIN32-Includes/mysql/Libmysql.def (removed):
    * src/win32/WIN32-Includes/mysql/config-netware.h:
    * src/win32/WIN32-Includes/mysql/config-os2.h:
    * src/win32/WIN32-Includes/mysql/config-win.h:
    * src/win32/WIN32-Includes/mysql/dbug.h (removed):
    * src/win32/WIN32-Includes/mysql/errmsg.h:
    * src/win32/WIN32-Includes/mysql/libmysql.def:
    * src/win32/WIN32-Includes/mysql/libmysqld.def:
    * src/win32/WIN32-Includes/mysql/m_ctype.h:
    * src/win32/WIN32-Includes/mysql/m_string.h:
    * src/win32/WIN32-Includes/mysql/my_alloc.h:
    * src/win32/WIN32-Includes/mysql/my_dbug.h:
    * src/win32/WIN32-Includes/mysql/my_getopt.h:
    * src/win32/WIN32-Includes/mysql/my_global.h:
    * src/win32/WIN32-Includes/mysql/my_list.h:
    * src/win32/WIN32-Includes/mysql/my_pthread.h:
    * src/win32/WIN32-Includes/mysql/my_sys.h:
    * src/win32/WIN32-Includes/mysql/mysql.h:
    * src/win32/WIN32-Includes/mysql/mysql_com.h:
    * src/win32/WIN32-Includes/mysql/mysql_embed.h:
    * src/win32/WIN32-Includes/mysql/mysql_time.h:
    * src/win32/WIN32-Includes/mysql/mysql_version.h:
    * src/win32/WIN32-Includes/mysql/mysqld_error.h:
    * src/win32/WIN32-Includes/mysql/raid.h:
    * src/win32/WIN32-Includes/mysql/typelib.h:
    * src/win32/WIN32-Libraries/Packet.lib:
    * src/win32/WIN32-Libraries/wpcap.lib:
    * src/win32/WIN32-Libraries/mysql/mysqlclient.lib:
    * src/win32/WIN32-Prj/snort.dsp:
      Updated to use WinPCAP 3.1 and MySql client 4.13.  Preparation for
      Snort 2.4.1 release on Win32.

2005-09-14 Steven Sturges <ssturges@sourcefire.com>
    * src/snort.c:
      Mark -z option as to be deprecated.

    * src/preprocessors/spp_frag3.c:
      Fix issue with Teardrop alerts introduced with last update.

2005-09-01 Steven Sturges <ssturges@sourcefire.com>
    * src/decode.c:
    * src/decode.h:
      Fix snort decoder to correctly handle PPP over Ethernet decoding.
      Thanks Aristeu Gil Alves Jr for the pcap.

    * src/snort.c:
    * src/util.c:
    * configure.in:
      Added patch for time stats from Bill Parker.  Enable with 
      configure --enable-timestats.

    * src/snort.c:
      Do not allow -T (test mode) & -D (daemonize) together.

    * src/preprocessors/spp_frag3.c:
      Fix issue with Teardrop alerts.

    * src/preprocessors/spp_portscan.c:
    * src/preprocessors/spp_portscan2.c:
      Add deprecation warning.  These will be deprecated in the next
      snort build.

2005-08-31 Steven Sturges <ssturges@sourcefire.com>
    * src/snort.c:
    * src/decode.c:
    * src/decode.h:
      Added decoder for IPEnc for Open BSD.  Thanks Jason Ish for the
      patch (long time ago) and Chris Kuethe for reraising the issue.

    * src/snort.c:
      Allow snort to use usernames (-u) and groupnames (-g) that include
      numbers.  Thanks to Shaick for the patch.
                                        
2005-08-29 Steven Sturges <ssturges@sourcefire.com>
    * src/preprocessors/spp_sfportscan.c:
    * etc/snort.conf:
    * doc/README.sfportscan:
      Change ip_proto to ip for portscan configuration.  Thanks David Bianco
      for pointing this out and Andy Mullican for the updates.

    * src/snort.c:
      Fix broken -T option.  Thanks Andy Mullican for the fix.

    * src/output-plugins/spo_alert_prelude.c:
      Fix for prelude initialization.  Thanks Yoann Vandoorselaere for the
      update.

    * src/preprocessors/spp_frag3.c:
    * doc/README.frag3:
      Update to address Solaris reassembly issues.  Update README to
      include info about new target-based policy.

2005-08-23 Steven Sturges <ssturges@sourcefire.com>
    * src/preprocessors/spp_frag3.c:
      Resolve some issues with handling of overlap conditions, multiple
      fragments with MoreFrags bit not set and added target based policies
      for windows and solaris (since they are actually different in
      certain cases).

    * src/preprocessors/stream.h:
      Added data structure padding to fix issues with 64bit Solaris.

    * src/log.c:
      Fix problem in sniffer mode when incomplete TCP option data is received.
      Thanks A Hernandez for the find.

    * src/decode.c:
      Set the source & dest ports used for logging before doing checksum
      verification.  If invalid checksum, ports will be logged (even though
      they may be invalid).
      Wrapped alerts for same src/dst and loopback in mode==IDS & decoder
      alert checks.

    * src/plugbase.h:
      Use hex values for preprocessor bitmask constants instead of the
      decimal equivalent.

    * src/detection-plugins/sp_byte_jump.c:
    * src/detection-plugins/sp_byte_check.c:
      Allow for signed offset values to handle negative offset in
      rules.  Fixes potential issue on 64-bit architectures.

    * src/detection-plugins/sp_pattern_match.c:
    * src/detection-plugins/sp_pattern_match.h:
      For content matches, when subsequent rule options fail, start searching
      again in correct location instead of again at end of the currently
      found pattern.

    * src/preprocessors/perf-base.c:
    * src/preprocessors/perf-base.h:
    * src/preprocessors/perf.h:
    * src/preprocessors/snort_httpinspect.c:
    * src/preprocessors/spp_frag2.c:
    * src/preprocessors/spp_perfmonitor.c:
    * src/preprocessors/spp_xlink2state.c:
    * src/preprocessors/str_search.c:
    * src/preprocessors/xlink2state.c:
    * src/sfutil/asn1.c:
    * src/sfutil/mpse.h:
    * src/plugbase.c:
    * src/snort.c:
      Code/compiler warning cleanup.


2005-08-15 Steven Sturges <ssturges@sourcefire.com>
    * src/decode.c:
    * src/win32/WIN32-Includes/NETINET/IN_SYSTM.H:
      Updated Win32 to handle pflog patch.

2005-08-15 Steven Sturges <ssturges@sourcefire.com>
    * src/output-plugins/spo_alert_prelude.c:
    * etc/snort.conf:
      Fix GCC4 warning, make the arguments parser more robust and
      less fault tolerant. Correct parsing of IDMEF severity mapping.
      Don't try to initialize Prelude support when 'output alert_prelude'
      is not specified.  Removed deprecated documentation from the conf
      file.  Thanks Yoann Vandoorselaere for the updates.

    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/snort_stream4_session.c:
    * src/preprocessors/stream.h:
      Fixed problem on Solaris when reassembling at exit.
      Thanks Andrew Rucker Jones for identifying the issue.

    * src/decode.c:
    * src/decode.h:
    * src/snort.c:
      Added support for new OpenBSD pflog format.  Older pflog format,
      OpenBSD 3.3 and earlier, is still supported.  Thanks Breno Leitao
      and Christian Reis for the patch.

    * src/decode.c:
    * src/decode.h:
    * src/util.c:
      Added statistics counter for ETH_LOOPBACK packets.  Thanks rmkml
      for the patch.

2005-07-29 mfr <roesch@sourcefire.com>
    * rpm/snort.spec:
      Fix epoch inclusion for RPM generation

2005-07-29 Steven Sturges <ssturges@sourcefire.com>
    * src/preprocessors/spp_stream4.c:
      Fixed debug prints for new flush behavior changes.

    * src/detection-plugins/sp_pattern_match.c:
      Added checks to ensure some syntax correctness for content
      rules.  Thanks Erik de Castro Lopo for the patch.

2005-07-27 mfr <roesch@sourcefire.com>
    * etc/snort.conf:
      Changed snort.conf to reflect flush_behavior changes

2005-07-24 mfr <roesch@sourcefire.com>
    * src/preprocessors/spp_stream4.c:
      Fix parsing problem in the flush_behavior config directive

    * etc/snort.conf:
      Turn perfmonitor off by default

2005-07-22 Steven Sturges <ssturges@sourcefire.com>
    * src/preprocessors/spp_stream4.c:
      Changed flush_behavior to use names instead of numeric value.
      New behaviors names are 'default', 'large_window', and 'random'

2005-07-22 Steven Sturges <ssturges@sourcefire.com>
    * src/win32/WIN32-Includes/config.h:
      Changed Snort version number

    * src/detection-plugins/sp_pattern_match.c:
      Fixed error message for replace

2005-07-22 mfr <roesch@sourcefire.com>
    * src/preprocessors/HttpInspect/client/Makefile.am:
    * src/preprocessors/HttpInspect/event_output/Makefile.am:
      More cleanup

2005-07-22 mfr <roesch@sourcefire.com>
    * src/preprocessors/HttpInspect/anomaly_detection/Makefile.am:
    * src/preprocessors/HttpInspect/mode_inspection/Makefile.am:
    * src/preprocessors/HttpInspect/normalization/Makefile.am:
    * src/preprocessors/HttpInspect/server/Makefile.am:
    * src/preprocessors/HttpInspect/session_inspection/Makefile.am:
    * src/preprocessors/HttpInspect/user_interface/Makefile.am:
    * src/preprocessors/HttpInspect/utils/Makefile.am:
      Remove references to files in other directories

2005-07-22 mfr <roesch@sourcefire.com>
    * rpm/snort.spec:
      Fixup the spec file to reflect new method of rules distribution

2005-07-22 mfr <roesch@sourcefire.com>
    * configure.in:
      Fix PostgreSQL support

2005-07-21 mfr <roesch@sourcefire.com>
    * src/snort.h:
      Bump build number

2005-07-21 mfr <roesch@sourcefire.com>
    * rpm/snort.spec:
    * rpm/generate-all-rpms:
      Setup for 2.4.0 release, removed inline build option from RPM generation
      for the time being

    * configure.in:
    * Makefile.am:
    * doc/Makefile.am:
      Updated for 2.4.0 release to remove references to sig docs and rules, 
      which are now external to the distro

    * etc/snort.conf:
      Updated snort.conf for 2.4 release

2005-07-20 mfr <roesch@sourcefire.com>
    * autojunk.sh:
      Added --copy switch to automake call, patch from 
      Jeff Nathan <jeff@snort.org>

    * congfigure.in:
      Added maintainer mode call to prevent endless configure reruns.  From
      Jeff Nathan <jeff@snort.org>

2005-07-20 Steven Sturges <ssturges@sourcefire.com>

    * src/preprocessors/perf-base.c:
    * src/preprocessors/perf.c:
      Improved file handling of perfmon stats file rollover.

    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/stream.h:
      Provided ability to use 2 sets of static flushpoints as well as
      random flushpoints for reassembly.  Thanks Jason Brvenik for the
      patch.

    * src/plugbase.c:
    * src/plugbase.h:
    * src/preprocessors/snort_stream4_session.h:
    * src/preprocessors/snort_stream4_session.c:
    * src/preprocessors/spp_stream4.c:
    * src/snort.c:
    * src/snort.h:
      Added code to process unflushed Streams at snort exit
      and when stream is purged from cache because of memory
      issues.

    * src/preprocessors/spp_telnet_negotiation.c:
      Small fix for normalization of subnegotiation options.

2005-07-19 mfr <roesch@sourcefire.com>
    * doc/BUGS:
      Updated BUGS file for 2.4 release.

    * configure.in:
      Added PostgreSQL fixes and exit code patch from Javier 
      Fernandez-Sanguino Pena <jfs@computer.org>

2005-07-18 mfr <roesch@sourcefire.com>
    * doc/README:
      Updated the README file to reflect the current version of Snort and
      command line switches that are available (and the ones that no longer
      are available as well...)
       
2005-07-11 Steven Sturges <ssturges@sourcefire.com>

    * src/detection-plugins/sp_byte_jump.c:
      Fixed log message.

    * src/log.c:
      Convert ICMP Router Advertisement time to host byte order before
      printing.

    * src/snort.c:
    * src/snort.h:
    * src/preprocessors/perf.c:
    * src/preprocessors/perf.h:
    * src/preprocessors/spp_perfmonitor.c:
      Use singal to rollover perf stats file without having to restart
      snort.  Thanks Andrew Mullican for the patch.

    * src/preprocessors/perf-base.c:
    * src/preprocessors/perf-base.h:
    * src/preprocessors/spp_frag3.c:
      Performance update for Frag3.  Also added stats fields to Perfmon
      for Frag3.

    * src/sfutil/mwm.c:
      Fix to handle multiple instances (different case) of the same pattern
      when the matching one occurs later than the others.

    * src/snort.c:
    * src/output-plugins/spo_alert_prelude.c:
    * src/output-plugins/spo_alert_prelude.h:
      Fix to handle heartbeat and pthread issues with Prelude.  Thanks Yoann
      Vandoorselaere for the patch.

    * src/sfutil/mwm.c:
    * src/preprocessor/spp_sfportscan.c:
    * src/preprocessor/HttpInspect/normalization/hi_norm.c:
      Data initialization fixes.  Thanks Yoann Vandoorselaere
      for the patch.

    * src/output-plugins/spo_database.c:
      Update for Oracle output.  Thanks Joel Esler for the fix.
      
    * src/output-plugins/spo_unified.c:
      Provide additional reliabilty for NT_SPECIAL_OUTPUT.  Thanks
      Eric Lauzon for the fix.

2005-06-10 Jeremy Hewlett <jh@snort.org>

    * src/output-plugins/spo_alert_prelude.c:
      Handle case when Packet pointer is NULL for Portscan alerts.

    * src/preprocessors/spp_frag3.c:
    * src/decode.c:
      Fixed processing of fragmented UDP traffic.

2005-05-20 Jeremy Hewlett <jh@snort.org>

    * src/preprocessors/spp_perfmonitor.c:
      Fixed misprinted filename (mnorton).

    * src/snort.c:
      Allow -T flag when MUST_SPECIFY_DEVICE is enabled (mnorton).

2005-05-19 Jeremy Hewlett <jh@snort.org>

    * src/parser/IpAddrSet.c:
      Fixed problem with parsing IP addresses of 255.255.255.255 for
      rules (ssturges).

2005-05-18 Jeremy Hewlett <jh@snort.org>

    * src/decode.h:
    * src/decode.c:
    * src/generators.h:
    * src/preprocessors/spp_frag3.c:
      Added processing of IP Options in fragmented packets (ssturges).
      Thanks Brice Cotte for getting us discussing this topic.

    * src/preprocessors/snort_stream4_session.c:
      Fixed potential memory corruption (ssturges).

2005-05-09 Jeremy Hewlett <jh@snort.org>

    * src/parser.c:
      Increase  limit  on  number  of rule options to 256 (was 64).
      Report error if limit is reached -- previously,  extra  options
      were ignored.  Also increased max line length to 4096 chars, from
      1024.

2005-05-09 Andrew Mullican <amullican@sourcefire.com>

    * src/preprocessors/xlink2state.c:
      Bugfix for PowerPC architecture.

2005-05-05 Jeremy Hewlett <jh@sourcefire.com>
    
    * src/preprocessors/perf-base.c:
      Updated  to  better  match  true  on  the  wire and user data
      values (Marc Norton).

2005-04-28 Jeremy Hewlett <jh@sourcefire.com>

    * src/snort.c:
      Added check for MUST_SPECIFY_DEVICE #ifdef, which if used,
      requires either a -i or -r commandline switch to start snort.  If
      not used, current behavior remains (Marc Norton).

    * autojunk.sh:
    * configure.in:
    * Makefile.am:
    * etc/snort.conf:
    * m4/libprelude.m4:
    * m4/Makefile.am:
    * src/plugbase.c:
    * src/output-plugins/Makefile.am:
    * src/output-plugins/spo_alert_prelude.c:
    * src/output-plugins/spo_alert_prelude.h:
      Added support for prelude, enable with --enable-prelude. Thanks
      Yoann Vandoorselaere!

2005-04-26 Jeremy Hewlett <jh@sourcefire.com>

    * src/parser/IpAddrSet.c:
      Fixed Snort not resolving hostnames that start with a numeric and
      also parsing of invalid CIDR blocks (Daniel Cid).

    * src/plugbase.c:
    * src/plugbase.h:
      Remove unused functions str2s, hex2s, and int2s (Andy Mullican).
      Thanks Jeff Nathan for pointing this out.

    * src/preprocessors/spp_rpc_decode.c:
      Ignore multiple rpc requests if in a rebuilt packet (Thanks Andy
      Mullican).

    * src/inline.c:
      File descriptor clean up from Will Metcalf.

2005-04-22 Andrew Mullican <amullican@sourcefire.com>

    * etc/gen-msg.map:
    * src/generators.h:
    * src/plugbase.c:
    * src/preprocessors/Makefile.am:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/stream4.h:
    * src/preprocessors/spp_xlink2state.c:
    * src/preprocessors/spp_xlink2state.h:
    * src/preprocessors/xlink2state.c:
    * src/preprocessors/xlink2state.h:
    * src/preprocessors/str_search.c:
    * src/preprocessors/str_search.h:
      Added xlink2state mini-preprocessor to catch MS Exchange buffer
      X-Link2State data overflow.

2005-04-11 Jeremy Hewlett <jh@sourcefire.com>

    * src/detection-plugins/sp_byte_check.c:
    * src/detection-plugins/sp_byte_jump.c:
      Fixed error messages in byte_jump & byte_test rule options (Marc
      Norton).

    * detection_plugins/sp_byte_jump.c:
      Fixed issue with 'multiplier' option.  It is now being done before
      the 'align' option.  This helps with rules that look at SMB
      traffic (Steve Sturges).

    * src/preprocessors/flow/flow_cache.c:
    * src/preprocessors/Makefile.am:
    * src/preprocessors/snort_stream4_session.c:
    * src/preprocessors/snort_stream4_session.h:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/stream4.h:
    * src/sfutil/sfxhash.c:
    * src/sfutil/sfxhash.h:
    * etc/snort.conf:
      Performance Improvements to Flow & Stream4 session management.
      Also added limit to number of active sessions for Stream4, default
      of 8192.  Old memcap value now only applies to packets stored for
      reassembly.  Configure using preprocessor stream4: max_sessions
      16384 in snort.conf (Steve Sturges).

    * src/preprocessor/spp_perfmonitor.c:
    * src/preprocessor/spp_perfmonitor.h:
    * src/snort.c:
      Added -Z flag to set full path name to PerfMonitor stats file.
      This will override the file or snortfile configuration option
      (Marc Norton).

2005-04-05 Jeremy Hewlett <jh@sourcefire.com>

    * src/detect.c:
    * src/fpdetect.c:
    * src/log.c:
    * src/snort.c:
    * src/snort.h:
    * src/tag.c:
    * src/output-plugins/spo_unified.c:
      Added a -G flag that specifies an instance identifier for the event
      logs.  Can be used when running multiple instances of snort, either
      on different CPUs or on same CPU but different interface.  Each
      snort instance will use the value specified to generate unique
      event ids.  Can specify either a decimal value (-G 1) or hex value
      preceeded by 0x (-G 0x11). Thanks Steve Sturges.

    * src/decode.h:
    * src/output-plugins/spo_csv.c:
    * src/output-plugins/spo_database.c:
      Fix to remove unnecessary ICMP echo extension, and update output
      plugins to use ICMP header info. Thanks Kevin Douglas for finding
      this and Andrew Mullican for the fix.

    * src/decode.h:
    * src/detect.c:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/stream.h:
    * etc/snort.conf:
      Add option to Stream4 to limit server-side inspection for improved
      performance.  Similar to HttpInspect's flow-depth, this option
      limits rule-inspection of server traffic to the set number of bytes
      (in 1 or more packets) until another client request is seen.  Thanks
      Steve Sturges & Marc Norton

    * src/plugbase.c:
      Fix issue generating ascii strings.  Thanks Sandro Poppi for the fix.

2005-04-01 Jeremy Hewlett <jh@sourcefire.com>

    * src/preprocessors/spp_sfportscan.c:
      Additional fixes for suppression issue with sfPortscan and Open
      Ports.  Fix for packets logged with bogus ip lengths (related to
      Open Port alerts). Thanks Andy Mullican.

2005-03-25 Jeremy Hewlett <jh@sourcefire.com>

    * src/output-plugins/spo_alert_syslog.c:
    * src/snort.c:
      Add snort's PID to syslog. Thanks Steve Sturges.

    * src/preprocessors/spp_stream4.c:
      Added to default ports in Stream4 and cleaned up Stream4
      configuration processing. Thanks Steve Sturges.

    * src/preprocessors/spp_frag3.c:
      Added packet dump (debug only) to Frag3. Patch from Steve Sturges.

    * src/sfthreshold.c:
      Added detail to config error messages for thresholding. Patch from
      Steve Sturges.

    * src/fpdetect.c:
    * src/plugbase.h:
    * src/detection-plugins/sp_flowbits.c:
    * src/preprocessors/spp_sfportscan.c:
      Code Cleanup (general), thanks Steve Sturges.

    * rpm/snort.org.spec:
    * rpm/snort.logrotate:
      Added schemas to distro, and 'sharedscripts' to logrotate. General
      clean up of spec file. Thanks Josh Kelley for pointing this out.

2005-03-25 Jeremy Hewlett <jh@sourcefire.com>

    * src/preprocessors/spp_sfportscan.c:
      Fixed suppression issue with sfPortscan and Open Ports. Patch from
      Andy Mullican.

2005-03-15 Jeremy Hewlett <jh@sourcefire.com>

    * src/decode.c:
    * src/parser/IpAddrSet.c:
    * src/parser/IpAddrSet.h:
    * src/preprocessors/spp_frag3.c:
    * etc/generators:
      Updates/Fixes to Frag3 IP reassembler (thanks ssturges):
      1) Push first fragmented UDP packet through, but do not inspect
      other fragmented packets (until rebuilt).  
      2) Printing of Configuration Info 
      3) Code readability

    * src/parser.c:
      Removal of comment parsing code added for 2.3.1.

    * src/decode.c:
    * src/generators.h:
      Added support for detection of Lookback & Same src/dest attacks in
      the packet decoder. This obsoletes sids 527, 528. Thanks Marc
      Norton for the feature.

    * src/detection-plugins/Makefile.am:
    * src/plugbase.c:
    * src/detection-plugins/sp_ftpbounce.c:
    * src/detection-plugins/sp_ftpbounce.h:
      Added FTP Bounce detection Plugin. Thanks Steve Sturges.

    * src/detection-plugins/sp_flowbits.c:
      Increased Flowbits hash table size. Thanks Marc Norton.

    * src/fpcreate.c:
      Performance improvement in pattern matcher from Marc Norton.

    * src/decode.c:
    * src/decode.h:
    * src/fpdetect.c:
    * src/preprocessors/spp_frag2.c:
    * src/preprocessors/spp_frag3.c:
    * src/preprocessors/spp_frag3.h:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/stream.h:
    * src/snort.c:
    * src/snort.h:
      Eliminate duplicate alerts on Rebuilt Streams/IP reassembled packets.
      Patch from Andy Mullican and Steve Sturges.

    * src/preprocessors/portscan.c:
    * src/preprocessors/sfportscan.c:
    * doc/README.sfportscan:
    * etc/generators:
    * etc/gen-msg.map:
      Added handling of midstream sessions in portscan preprocessors.
      Thanks Andy Mullican.

    * src/generators.h:
    * src/preprocessors/spp_stream4.c:
    * src/preprocessors/stream.h:
    * src/ubi_BinTree.c:
    * src/ubi_BinTree.h:
    * src/ubi_SplayTree.c:
    * src/ubi_SplayTree.h:
    * etc/gen-msg.map:
    * etc/snort.conf:
      Stream4 fixes - Handle PAWS, NULL TCP Flags in established session,
      limit overlaps in established session, update ACK when server sends
      RST. Performance changes for cleaning up session cache. Thanks
      Steve Sturges and Andy Mullican for the patches.

    * src/preprocessors/HttpInspect/include/hi_ui_config.h:
    * src/preprocessors/HttpInspect/user_interface/hi_ui_config.c:
    * src/preprocessors/snort_httpinspect.c:
    * doc/README.http_inspect:
      Added uri_tab_delimiter option to HttpInspect. Patch from Andy
      Mullican.

    * src/preprocessors/perf-base.c:
      Updates to PerfMon to handle multiple CPUs properly. Thanks Steve Sturges.

    * src/preprocessors/spp_telnet_negotiation.c:
      Fixed telnet decoder bug when ignoring Sub-negotiation end command.
      Thanks Steve Sturges.

2005-03-08 Jeremy Hewlett <jh@sourcefire.com>

    * src/preprocessors/spp_flow.c:
    * src/detection-plugins/sp_flowbits.c:
      Increased number of flowbits (mnorton)

2005-03-08 Steven Sturges <ssturges@sourcefire.com>

    * src/parser.c:
      Fixed parsing of comments at end of line in config file.   In
      snort.conf, anything that follows a # on a line is considered a
      comment.

2005-03-04 Jeremy Hewlett <jh@sourcefire.com>

    * src/preprocessors/spp_sfportscan.c:
      Fixed alignment issue causing sfPortscan to crash on Solaris/HPUX.
      Thanks Andy Mullican for the fix. Thanks Senthil Prabu.S and
      Jonathan Miner for working with us on this.

2005-01-28 Jeremy Hewlett <jh@sourcefire.com>

    * src/decode.c:
    * src/decode.h:
    * src/output-plugins/spo_unified.c:
    * src/preprocessors/HttpInspect/utils/hi_util_kmap.c:
    * src/preprocessors/portscan.c:
    * src/preprocessors/portscan.h:
    * src/preprocessors/spp_rpc_decode.c:
    * src/preprocessors/spp_sfportscan.c:
    * src/sfthreshold.c:
      Fixed compiler warnings and code formatting (tabs to spaces).

2005-01-20 Andrew Mullican <amullican@sourcefire.com>

    * src/generators.h:
    * src/preprocessors/spp_bo.c:
      Added 2 BackOrifice alerts (1 client, 1 server) so that some alerts
      can be suppressed.

2005-01-18 Steven Sturges <ssturges@sourcefire.com>

    * src/plugbase.c:
    * src/plugbase.h:
    * src/preprocessors/snort_httpinspect.c:
    * src/preprocessors/snort_httpinspect.h:
    * src/preprocessors/spp_frag3.c:
    * src/preprocessors/spp_httpinspect.c:
    * src/snort.c:
      Change to verify that preprocessors have sufficient configuration
      data to correctly operate.

    * src/preprocessors/spp_frag3.c:
      Fixes to Frag3 to only have one instance of preprocessor.  Uses
      policy context internally based on destination address of packet.
      Previously, each Frag3 Policy would result in a separate
      preprocessor instance.  Also fixed use of ttl_limit option.

2005-01-18 Andrew Mullican <amullican@sourcefire.com>

    * src/decode.c:
    * src/decode.h:
    * src/parser.c:
      Added ability to ignore packets based on port.  Syntax in
      snort.conf is 
        config ignore_ports: <tcp|udp> <list of ports separated by whitespace> 
      where list of ports can also include port ranges (ports separated by :).

2005-01-17 Steven Sturges <ssturges@sourcefire.com>

    * src/inline.c:
    * src/preprocessors/perf-base.c:
    * src/preprocessors/perf-base.h:
    * src/preprocessors/perf.h:
    * src/preprocessors/sfprocpidstats.c:
    * src/preprocessors/spp_frag2.c:
    * src/preprocessors/spp_frag3.c:
    * src/preprocessors/spp_perfmonitor.c:
    * src/snort.c:
    * src/snort.h:
    * src/util.c:
      Performance fixes to get correct 'on-the-wire' statistics.  Added
      'atexitonly' option for perfmonitor that results in performance
      stats only being dumped when snort exits, rather than periodically
      throughout snort's lifetime.
      
2005-01-13 Steven Sturges <ssturges@sourcefire.com>

    * src/preprocessors/spp_frag3.c:
      Fixed parsing of frag3 options to use space delimited options to
      handle IP address lists correctly.

    * etc/snort.conf:
      Updated example options for frag3
 
2005-01-13 Marc Norton <mnorton@sourcefire.com>

    * src/preprocessors/spp_sfportscan.c:
      Fixed arithmetic to correctly set the ip packet length in the ip
      header prior to writing the portscan info to the packet. Thanks Jon
      Hart for the test case and finding the bug.

2004-12-23 Steven Sturges <ssturges@sourcefire.com>

    * src/detect.c:
    * src/detection-plugins/sp_byte_jump.c:
    * src/detection-plugins/sp_pattern_match.c:
    * src/parser.c:
    * src/plugbase.c:
    * src/preprocessors/perf-base.c:
    * src/preprocessors/snort_httpinspect.c:
    * src/preprocessors/spp_conversation.c:
    * src/preprocessors/spp_sfportscan.c:
    * src/preprocessors/spp_stream4.c:
    * src/sfthreshold.c:
    * src/snort.c:
    * src/util.c:
    * src/util.h:
    * src/sfutil/Makefile.am:
